#!/bin/sh
######################################################################
#
# Database setup script for Sapphire/Web
# Date: 1/3/96
#
# Copyright (c) 1996 Bluestone, Inc.
######################################################################
PATH=/bin:/usr/ucb:/usr/bin:/sbin
FOUND=false

ypwhich > /dev/null 2>&1

if [ $? = 0 ]; then
  echo "Using NIS"
  INFORMIX=`ypmatch informix passwd.byname | cut -d: -f6`
  ORACLE=`ypmatch oracle passwd.byname | cut -d: -f6`
  SYBASE=`ypmatch sybase passwd.byname | cut -d: -f6`
else
  INFORMIX=`egrep "^informix:" /etc/passwd | cut -d: -f6` 
  ORACLE=`egrep "^oracle:" /etc/passwd | cut -d: -f6`
  SYBASE=`egrep "^sybase:" /etc/passwd | cut -d: -f6`
fi

echo "#!/bin/csh" > /tmp/saweb_db.$$

if [ "$INFORMIX" ]; then
  echo "Found INFORMIX user"
  grep "^setenv INFORMIX" $INFORMIX/.cshrc >> /tmp/saweb_db.$$
  grep "^setenv ONCONFIG" $INFORMIX/.cshrc >> /tmp/saweb_db.$$
  FOUND=true
fi

if [ "$ORACLE" ]; then 
  echo "Found ORACLE user" 
  grep "^setenv ORACLE" $ORACLE/.cshrc >> /tmp/saweb_db.$$
  FOUND=true
fi

if [ "$SYBASE" ]; then
  echo "Found SYBASE user"
  grep "^setenv SYBASE" $SYBASE/.cshrc >> /tmp/saweb_db.$$
  FOUND=true
fi

if [ "$FOUND" = "false" ]; then
  echo "Error: Could not find any databases. Starting dummy Sapphire/Gateway"
  echo "setenv SYBASE $SAPPHIRE/lib" >> /tmp/saweb_db.$$ 
else
  echo "Putting database variables in $HOME/Sapphire.cshrc"
fi

cat /tmp/saweb_db.$$ >> $HOME/Sapphire.cshrc
echo $SAPPHIRE/bin/dborbd.sh >> /tmp/saweb_db.$$
chmod 755 /tmp/saweb_db.$$

echo "Trying to start Sapphire/Gateway"
/tmp/saweb_db.$$
rm /tmp/saweb_db.$$
