#!/bin/sh  
######################################################################
# sabrowser.sh
#
# Run the web browser. To change the web browser, change $BROWSER_EXEC
# and change $BROWSER_NAME. Make sure you change both of them.
#
#
# Author: Bluestone Technical Support <support@bluestone.com>
# Date: 10/2/95
######################################################################
#BROWSER=mosaic
BROWSER=netscape


print_usage()
{
	echo "Usage: " >&2
	echo "sabrowser.sh -openFile|-openURL path" >&2
}


OLDIFS=$IFS
IFS=":"				# set internal file separater to :
BROWSER_FOUND=cantfind
for i in $PATH; do
	if [ -x $i/$BROWSER ]; 
	then
		BROWSER_FOUND=found
	fi
done

if [ -f $BROWSER ];
then
	BROWSER_FOUND=found
fi

if [ "$BROWSER_FOUND" != "found" ]; 
then
	echo "Can't find $BROWSER"
	exit 1
fi
IFS=$OLDIFS


if [ -z "$2" ]
then  

	print_usage
	exit 1
fi
echo "Starting "${BROWSER}" with "${2}

if [ "$BROWSER" = "netscape" ]
then
	if [ "$1" = "-openFile" ]
	then
     		$BROWSER -remote openFile\($2\)
		if [ $? != 0 ]
	  	then
			echo "Starting new instance of "${BROWSER}
			$BROWSER -install $2 &
	  	fi
	else
		if [ "$1" = "-openURL" ]
		then
			$BROWSER -remote openURL\($2\)
			if [ $? != 0 ]
			then
				echo "Starting new instance of "${BROWSER}
				$BROWSER -install $2 &
			fi
		else
		  	echo "Unknown option "$1
			print_usage
			exit 1
		fi
	fi
else
  echo "Starting new instance of "${BROWSER}
  $BROWSER $2 &
fi





