#!/bin/sh

#PLATFORM=sun
#PLATFORM=solaris
#PLATFORM=hp
#PLATFORM=ibm
PLATFORM=ibm413
#PLATFORM=sgi
#PLATFORM=dec

EXT=BAK

USAGE_MSG="Usage : $0 makefile-name [SYBASE|ORACLE|INFORMIX|ORB]"

if [ $# -ne 2 ] 
then
	echo $USAGE_MSG
	echo "Exiting..."
	exit 1
fi

if [ ! -f $1 ]
then
	echo $USAGE_MSG
	echo "$1 is not a file"
	echo "Exiting..."
	exit 1
fi

case $PLATFORM in
	solaris)
		EX_SYB_LIBS="-L\$(SYBASE)/lib -lsybdb"
		EX_ORA_LIBS="-xcg92 -L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lsqlnet -lnlsrtl -lcv6 -lcore -lnlsrtl -lcv6 -lcore"
###### for non xcg92 or gcc try below:
#		EX_ORA_LIBS="\$(ORACLE_HOME)/lib/__fstd.o -L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lsqlnet -lnlsrtl -lcv6 -lcore -lnlsrtl -lcv6 -lcore"
		EX_INF_LIBS="-L/usr/ccs/lib -L\$(INFORMIXDIR)/lib -L\$(INFORMIXDIR)/lib/esql -lsql -los -lasf \$(INFORMIXDIR)/lib/netlib.a \$(INFORMIXDIR)/lib/esql/libgen.a -los \$(INFORMIXDIR)/lib/esql/libgen.a -lasf"
		;;
	hp)
		EX_SYB_LIBS="-L\$(SYBASE)/lib -lsybdb"
		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lpls -lsqlnet -lcv6 -lcore"
		EX_INF_LIBS="-L\$(INFORMIXDIR)/lib -L\$(INFORMIXDIR)/lib/esql -lsql -los -lasf \$(INFORMIXDIR)/lib/netlib.a -lgen -los -lgen -lasf \$(INFORMIXDIR)/lib/nettlistub.a -lV3"
		;;
	ibm)
		EX_SYB_LIBS="-L\$(SYBASE)/lib -lsybdb"
		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lpls -lsqlnet -lcv6 -lcore"
#### alternative for some variations of an oracle installation
#uncommment the these oracle libs, comment the below oracle libs
#		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lpls -lsqlnet -lnlsrtl -lcv6 -lcore -lnlsrtl -lcv6 -lcore"
		EX_INF_LIBS="-L\$(INFORMIXDIR)/lib -L\$(INFORMIXDIR)/lib/esql -lsql -los -lasf \$(INFORMIXDIR)/lib/netlib.a -lgen -los -lgen -lasf \$(INFORMIXDIR)/lib/nettlistub.a -lbsd"
		;;
	ibm413)
		EX_SYB_LIBS="-L\$(SYBASE)/lib -lsybdb"
		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lsqlnet -lora -lnlsrtl -lcv6 -lcore -lnlsrtl -lcv6 -lcore"
#### alternative for some variations of an oracle installation
#uncommment the these oracle libs, comment the below oracle libs
#		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lpls -lsqlnet -lnlsrtl -lcv6 -lcore -lnlsrtl -lcv6 -lcore"
		EX_INF_LIBS="-L\$(INFORMIXDIR)/lib -L\$(INFORMIXDIR)/lib/esql -lsql -los -lasf \$(INFORMIXDIR)/lib/netlib.a -lgen -los -lgen -lasf \$(INFORMIXDIR)/lib/nettlistub.a -lbsd"
		;;
	sun)
		EX_SYB_LIBS="-L\$(SYBASE)/lib -lsybdb"
		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lpls -lsqlnet -lcv6 -lcore"
#### alternative for some variations of an oracle installation
#uncommment the these oracle libs, comment the below oracle libs
#		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lpls -lsqlnet -lnlsrtl -lcv6 -lcore -lnlsrtl -lcv6 -lcore"
		EX_INF_LIBS="-L\$(INFORMIXDIR)/lib -L\$(INFORMIXDIR)/lib/esql -lsql -los -lasf \$(INFORMIXDIR)/lib/netlib.a -lgen -los -lgen -lasf -lnsl"
		;;
	sgi)
		EX_SYB_LIBS="-L\$(SYBASE)/lib -lsybdb"
		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lsqlnet -lnlsrtl -lcv6 -lcore -lnlsrtl -lcv6 -lcore"
		EX_INF_LIBS="-lrpcsvc -lsun -lbsd -lmld -lc -lPW -L\$(INFORMIXDIR)/lib -L\$(INFORMIXDIR)/lib/esql -lsql -los -lasf \$(INFORMIXDIR)/lib/netlib.a \$(INFORMIXDIR)/lib/esql/libgen.a -los \$(INFORMIXDIR)/lib/esql/libgen.a -lasf -lnsl"
		;;
	dec)
		EX_SYB_LIBS="-L\$(SYBASE)/lib -lsybdb"
		EX_ORA_LIBS="-L\$(ORACLE_HOME)/lib -lsql -locic \$(ORACLE_HOME)/lib/osntab.o -lsqlnet -lora -lsqlnet -lora -lnlsrtl3 -lc3v6 -lcore3 -lnlsrtl3 -lcore3 -lm -lrt -lm"
		EX_INF_LIBS="-L\$(INFORMIXDIR)/lib -L\$(INFORMIXDIR)/lib/esql -lsql -los \$(INFORMIXDIR)/lib/netlib.a \$(INFORMIXDIR)/lib/esql/libgen.a -los \$(INFORMIXDIR)/lib/esql/libgen.a -ltli \$(INFORMIXDIR)/lib/netstub.a -lxti -laio -lpthreads -lc_r -lm -lmach -lc -lrt -laud -lots"
		;;
	*)
		echo "Platform variable in $0 not properly set".
		echo "Exiting..."
		exit 1
		;;
esac

case $2 in
	SYBASE)
		XT_CLIENT_LIB=libwebdbSY.a
		EX_LIBS=$EX_SYB_LIBS
		;;
	ORACLE)
		XT_CLIENT_LIB=libwebdbOR.a
		EX_LIBS=$EX_ORA_LIBS
		;;
	INFORMIX)
		XT_CLIENT_LIB=libwebdbIF.a
		EX_LIBS=$EX_INF_LIBS
		;;
	ORB)
		XT_CLIENT_LIB=libwebdb.a
		EX_LIBS=
		;;
	*)
		echo $USAGE_MSG
		echo "Exiting..."
		exit 1
		;;
esac

# Check Makefile
grep '^SA_LIBS' $1
status1=$?
if [ $status1 -ne 0 ]
then
	echo "$1 does not look like a Sapphire client makefile."
	echo "Exiting..."
	exit 1
fi

cp $1 $1.$EXT
if [ $? -ne 0 ]
then
	echo "Modification failed. Can't make backup copy of $1."
	echo "Exiting..."
	exit 1
fi

echo "Making backup copy $1.$EXT"

sed -e "/^SA_LIBS.*$/ s%%SA_LIBS = \$\(SALIB\)/$XT_CLIENT_LIB $EX_LIBS%" \
$1.$EXT > $1

if [ $? -ne 0 ]
then
	echo "Can't modify file $1."
	echo "Exiting..."
	exit 1
fi

echo "Done"
exit 0
