#!/bin/sh 
# This script gets called when a user presses the release button in the project window.
# It is called before the code is generated in the release directory.
# The default action of this script is to copy all .c .h files to the release directory.
# This is needed so we can make sure that user defined functions can be found when the
# project is built in the release directory.
# All files with the file extension specifed in the option Makefile.$SA_SOURCE_SUFFIX
# will also be copied.
# Note that after the tool generates the code for the project the script sarel2.sh gets 
# called.

# arg	description
# 1     sourceSuffix    The file extension used for the generated C/C++ code.

print_usage()
{
	echo "Usage: " >&2
	echo "sarel1.sh sourceSuffix" >&2
}


if [ $# -ne 1 ]
then
	print_usage
    exit 1
fi

if [ -z "$1" ]
then
	print_usage
    exit 1
fi

sourceSuffix=$1

mkdir -p release
if [ "$?" != 0 ]
then
	echo "******* Could not make release directory *******"
	exit 1
fi

cp *.c *.h *${sourceSuffix} release











