#!/bin/sh 
# arg    description
# 1      cgiName		The name of the cgi executable
# 2      startupHtml	The name of the startup html document
# 3		 cgiTestPath    The host and path (host:path) to install
#						the cgi executable and html templates
# 4		 htmlTestUrl    The URL where the html docs are found.
# 5		 htmlTestPath   The host and path (host:path) to install
#						the html documents.
# 6      makeFileName   The name of the Makefile used to build
#					  	the cgi.
# 7      htmlFileNames  A list of HTML files to be copied.
#


resolve_tilda()
{
	echo `/bin/csh -f -s << END 
	/bin/echo $1 
	END`
}
print_usage()
{
	echo "Usage: " >&2
	echo "satest.sh cgiName startupHtml cgiTestPath" >&2
	echo "			htmlTestUrl htmlTestPath makeFileName htmlFileNames" >&2
}

if [ $# -ne 7 ]
then
	print_usage
    exit 1
fi

if [ -z "$7" ]
then
	print_usage
    exit 1
fi


samake.sh $6


if [ "$?" != 0 ]
then
	echo "******* Make Failed! *******"
	exit 1
fi


localHost=`hostname`
remoteHost=`echo $5 | cut -f1 -d:`
htmlPath=`echo $5 | cut -f2 -d:`
if [ "$htmlPath" = "$remoteHost" ]
then
	htmlPath=`resolve_tilda $5`
	mkdir -p $htmlPath
elif [ "$remoteHost" = "$localHost" ]
then

	htmlPath=`resolve_tilda $htmlPath`
	mkdir -p $htmlPath
else
	realUser=`echo $remoteHost | cut -f1 -d@`
	realHost=`echo $remoteHost | cut -f2 -d@`
	if [ "$realUser" = "$realHost" ]
	then

		htmlPath=`resolve_tilda $htmlPath`
		echo "Trying to create directory $htmlPath on host $remoteHost"
		rsh -n $remoteHost "/bin/csh -c 'mkdir -p $htmlPath'"
	else
		htmlPath=`resolve_tilda $htmlPath`
		echo "Trying to create directory $htmlPath as $realUser on host $realHost"
		rsh -l $realUser -n $realHost "/bin/csh -c 'mkdir -p $htmlPath'"
	fi
	htmlPath=`echo "${remoteHost}:${htmlPath}"`

fi
remoteHost=`echo $3 | cut -f1 -d:`
cgiPath=`echo $3 | cut -f2 -d:`
if [ "$cgiPath" = "$remoteHost" ]
then
	cgiPath=`resolve_tilda $3`
	mkdir -p $cgiPath
elif [ "$remoteHost" = "$localHost" ]
then
	
	cgiPath=`resolve_tilda $cgiPath`
	mkdir -p $cgiPath
else
	realUser=`echo $remoteHost | cut -f1 -d@`
	realHost=`echo $remoteHost | cut -f2 -d@`

	if [ "$realUser" = "$realHost" ]
	then
		cgiPath=`resolve_tilda $cgiPath`
		echo "Trying to create directory $cgiPath on host $realHost"
		rsh -n $remoteHost "/bin/csh -c 'mkdir -p $cgiPath'"

	else
		cgiPath=`resolve_tilda $cgiPath`
		echo "Trying to create directory $cgiPath as $realUser on host $realHost"
		rsh -l $realUser -n $realHost "/bin/csh -c 'mkdir -p $cgiPath'"
	fi	
	cgiPath=`echo "${remoteHost}:${cgiPath}"`
fi

echo ""
echo "Installing to "$cgiPath
rcp $1 ${cgiPath}/$1
echo "Installing to "$htmlPath
rcp $7 ${htmlPath}/


fullPath=${4}/${2}

sabrowser.sh -openURL $fullPath

