#include <stdio.h>
#include "SaRnHtml.h"

#define SA_LESSTHAN "&lt;"
#define SA_GREATERTHAN "&gt;"
#define SA_AMP "&amp;"
#define SA_QUOTE "&quot;"
#define SA_SPACE "&sp;"
#define SA_LISTITEM_BEGIN "<LI>"
#define SA_LISTITEM_END "</LI>"
#define SA_OPTION_BEGIN "<OPTION>"
#define SA_OPTION_END "</OPTION>"

#define SA_HTML_B "<HTML>\n"
#define SA_HTML_E "</HTML>"
#define SA_HEAD_B "<HEAD>"
#define SA_HEAD_E "</HEAD>"
#define SA_TITLE_B "<TITLE>"
#define SA_TITLE_E "</TITLE>"
#define SA_BODY_B "<BODY>\n"
#define SA_BODY_E "</BODY>"
#define SA_FORM_B "<FORM "
#define SA_FORM_E "</FORM>"
#define SA_TABLE_BM "<TABLE %s %s %s >"
#define SA_TABLE_B "<TABLE BORDER >"
#define SA_TABLE_CAPTION "<CAPTION %s >%s</CAPTION>"
#define SA_TABLE_E "</TABLE>"
#define SA_TABLEROW_B "<TR>"
#define SA_TABLEROW_BM "<TR %s %s %s >"
#define SA_TABLEROW_E "</TR>"
#define SA_TABLEITEM_BM "<TD %s %s %s %s >%s</TD>"
#define SA_TABLEHEAD_BM "<TH %s %s %s %s >%s</TH>"
#define SA_TABLEITEM "<TD>%s</TD>"
#define SA_TABLEHEAD "<TH>%s</TH>"
#define SA_LISTHEAD "<LH>%s</LH>"
#define SA_LISTITEM "<LI>%s</LI>"
#define SA_TABLEITEM_B "<TD>"
#define SA_TABLEITEM_E "</TD>"
#define SA_TABLEHEAD_B "<TH>"
#define SA_TABLEHEAD_E "</TH>"
#define SA_HEADER_B "<H%-d>"
#define SA_HEADER_E "</H%-d>"
#define SA_HEADER "<H%-d>%s</H%-d>"
#define SA_MENU_B "<MENU>"
#define SA_MENU_E "</MENU>"
#define SA_OLIST_E "</OL>"
#define SA_OLIST_B "<OL>"
#define SA_ULIST_E "</UL>"
#define SA_ULIST_B "<UL>"
#define SA_SELECT_B "%s <SELECT NAME=\"%s\" %s %s >"
#define SA_SELECT_E "</SELECT>"
#define SA_SELECT_OPTION "<OPTION %s VALUE=\"%s\">%s</OPTION>"
#define SA_TEXTA_E "</TEXTAREA>"
#define SA_ACTION "ACTION=\"%s\" "
#define SA_METHOD "METHOD=\"%s\" "
#define SA_ENCTYPE "ENCTYPE=\"%s\" "
#define SA_PASSWORD "<INPUT TYPE=\"password\" NAME=\"%s\" VALUE=\"%s\" >"
#define SA_CHECKBOX "<INPUT TYPE=\"checkbox\" NAME=\"%s\" VALUE=\"%s\" %s >%s"
#define SA_RADIO "<INPUT TYPE=\"radio\" NAME=\"%s\" VALUE=\"%s\" %s >%s"
#define SA_SUBMIT "<INPUT TYPE=\"submit\" NAME=\"%s\" VALUE=\"%s\" >"
#define SA_HIDDEN "<INPUT TYPE=\"hidden\" NAME=\"%s\" VALUE=\"%s\" >"
#define SA_TEXTBOX "<INPUT TYPE=\"text\" NAME=\"%s\" VALUE=\"%s\" %s %s >"
#define SA_TEXTAREA "<TEXTAREA NAME=\"%s\" %s %s %s >%s</TEXTAREA>"
#define SA_TEXTAREA_B "<TEXTAREA NAME=\"%s\" %s %s %s >"
#define SA_RESET "<INPUT TYPE=\"reset\" VALUE=\"%s\" >"
#define SA_ALIGN "ALIGN=\"%s\" "
#define SA_VALIGN "VALIGN=\"%s\" "
#define SA_SIZE "SIZE=\"%-d\" "
#define SA_ANCHOR "<A HREF=\"%s\" %s>%s</A>"
#define SA_NAME "NAME=\"%s\" "
#define SA_MAIL "<A HREF=\"mailto:%s\" >%s</A>"

static char* align_types[] = {
							"",
							"TOP",
							"MIDDLE",
							"BOTTOM",
							"LEFT",
							"CENTER",
							"RIGHT"
							};

#define SA_ERRORS "ErrorSite"
static pSutList theErrStrings = NULL;

static pSutList theKeyList = NULL;

#ifdef  _NO_PROTO
char* SaSafeExecArg(arg)
char* arg;
#else
char* SaSafeExecArg(char *arg)
#endif
{
	char *safeArg,*s;
	int i;
	int argLen = strlen(arg);
	
	int safeLen = (argLen *2) +1;

	if (!arg)
		return NULL;
	
	safeArg = (char*) malloc(safeLen);
	if (!safeArg){

		return NULL;
	}
	s = safeArg;
	for (i=0;i < argLen;i++)
	{
		if(arg[i]=='`' || arg[i] == ';' || arg[i] == '|' || arg[i]=='<' || arg[i]=='>')
		{
			*s = '\\';
			s++;
		}
		*s = arg[i];
		s++;
	}
	*s = '\0';
	return safeArg;
	
				   
}


#ifdef _NO_PROTO
void SaPrintAllErrors(file, site, client)
char* file;
char* site;
void* client;
#else
void SaPrintAllErrors(char* file, char* site, void* client)
#endif
{
	int i, size;
	char* str;

	size = SutSizList(theErrStrings);
	for (i=0; i<size; i++)
	{
		str = (char*) SutGetNList(theErrStrings, i);
		SaPrintOutHtmlError(str);
	}
}

#ifdef _NO_PROTO
void SaPrintAllKeys(file, site, client)
char* file;
char* site;
void* client;
#else
void SaPrintAllKeys(char* file, char* site, void* client)
#endif
{
	pSutList anchPieces;
	char* currentPtr;

	currentPtr = SaGetCurrentPtr();
	if(!currentPtr)
	{
		return;
	}
	currentPtr = SaGetCurrentAnchString(currentPtr);
	if(!currentPtr)
	{
		return;
	}
	anchPieces = SaAnchStringToPieceList(currentPtr);
	if (!anchPieces)
	{
		free(currentPtr);
		return;
	}

	SaSetSkipAnch();
	free(currentPtr);

	fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,0));
	SaPrintKeyStr();
	fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,1));
	fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,3));
	fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,2));
	SutDestroyList(anchPieces);
}

#ifdef _NO_PROTO
int SaPrintKeyStr()
#else
int SaPrintKeyStr()
#endif
{
	int i, size;
	char* str;

	size = SutSizList(theKeyList);
	for (i=0; i<size; i++)
	{
		str = (char*) SutGetNList(theKeyList, i);
		fprintf(stdout, "___%s", str);
	}
	return 0;
}

#ifdef _NO_PROTO
void SaClearTheErrors()
#else
void SaClearTheErrors()
#endif
{
	if (theErrStrings) SutDestroyList(theErrStrings);
	theErrStrings = NULL;
}

#ifdef _NO_PROTO
void SaClearKeyList()
#else
void SaClearKeyList()
#endif
{
	if (theKeyList) SutDestroyList(theKeyList);
	theKeyList = NULL;
}

#ifdef _NO_PROTO
int SaStoreKeyString(key, val)
char* key;
char* val;
#else
int SaStoreKeyString(char* key, char* val)
#endif
{
	char* str;

	if((!key) || (!*key))
		return 0;
	if((!val) || (!*val))
		return 0;

	if(!theKeyList)
	{
		theKeyList = SutNewList();
	}
	str = (char*) malloc(strlen(key) + strlen(val) + 2);
	sprintf(str, "%s=%s", key, val);
	SutAddList(theKeyList, str);
	return 1;
}

#ifdef _NO_PROTO
void SaStoreErrString(str)
char* str;
#else
void SaStoreErrString(char* str)
#endif
{
	if((!str) || (!*str))
		return;

	if(!theErrStrings)
	{
		theErrStrings = SutNewList();
	}
	SutAddList(theErrStrings, SaCopyString(str));
}

#ifdef _NO_PROTO
int SaRegErrSite(filename, site)
char* filename;
char* site;
#else
int SaRegErrSite(char* filename, char* site)
#endif
{
	if((!site) || (!*site))
		return 0;

	SaDisableConsole();
	SaAddConsoleErrHandler(SaStoreErrString);
	SaRegisterFuncSite(filename, site, SaPrintAllErrors, NULL);

	return 1;
}

#ifdef _NO_PROTO
int SaRegStdErrSite()
#else
int SaRegStdErrSite()
#endif
{
	SaRegErrSite(NULL, SA_ERRORS);
	return 1;
}

#ifdef _NO_PROTO
int SaCatFile(filename)
char* filename;
#else
int SaCatFile(char* filename)
#endif
{
	char* contents;

	if ((!filename) || (!*filename))
		return 0;

	contents = SaReadFileToString(filename);
	if (!contents)
		return 0;

	fprintf(stdout, "%s", contents);
	free(contents);

	return 1;
}

#ifdef _NO_PROTO
void SaIncludeHtml(file, site, client)
char* file;
char* site;
void* client;
#else
void SaIncludeHtml(char* file, char* site, void* client)
#endif
{
	char* filename;

	filename = (char*) client;
	if (!filename)
		return;

	SaCatFile(filename);
	return;
}

#ifdef _NO_PROTO
int SaHtmlTitle(title)
char* title;
#else
int SaHtmlTitle(char* title)
#endif
{
	char* html;

	html = SaMakeHtmlString(title);
	fprintf(stdout, "%s", SA_TITLE_B);
	fprintf(stdout, "%s", html);
	fprintf(stdout, "%s", SA_TITLE_E);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaAnchor(href, elabel, ename)
char* href;
char* elabel;
char* ename;
#else
int SaAnchor(char* href, char* elabel, char* ename)
#endif
{
	char* html;
	char* html2;
	char* html3;
	char* buff;

	if ((!ename) || (!*ename))
	{
		buff = (char*) malloc(1);
		buff[0] = '\0';
	}
	else
	{
		html3 = SaMakeHtmlString(ename);
		buff = (char*) malloc(strlen(html3) + 20);
		sprintf(buff, SA_NAME, html3);
		free(html3);
	}

	html = SaMakeHtmlString(href);
	html2 = SaMakeHtmlString(elabel);
	fprintf(stdout, SA_ANCHOR, html, buff, html2);
	free(html);
	free(html2);
	free(buff);
	return 0;
}

#ifdef _NO_PROTO
int SaMailTo(eaddr, elabel)
char* eaddr;
char* elabel;
#else
int SaMailTo(char* eaddr, char* elabel)
#endif
{
	char* html;
	char* html2;

	html = SaMakeHtmlString(eaddr);
	html2 = SaMakeHtmlString(elabel);
	fprintf(stdout, SA_MAIL, html, html2);
	free(html);
	free(html2);
	return 0;
}

#ifdef _NO_PROTO
int SaFormHidden(ename, evalue)
char* ename;
char* evalue;
#else
int SaFormHidden(char* ename, char* evalue)
#endif
{
	char* html;
	char* html2;

	if ((!ename) || (!*ename))
	{
		html = SaMakeHtmlString("SaFormName");
	}
	else
	{
		html = SaMakeHtmlString(ename);
	}
	html2 = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_HIDDEN, html, html2);
	free(html);
	free(html2);
	return 0;
}

#ifdef _NO_PROTO
int SaFormReset(evalue)
char* evalue;
#else
int SaFormReset(char* evalue)
#endif
{
	char* html;

	html = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_RESET, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaFormSubmit(ename, evalue)
char* ename;
char* evalue;
#else
int SaFormSubmit(char* ename, char* evalue)
#endif
{
	char* html;
	char* html2;

	if ((!ename) || (!*ename))
	{
		html = SaMakeHtmlString("SubmitName");
	}
	else
	{
		html = SaMakeHtmlString(ename);
	}
	html2 = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_SUBMIT, html, html2);
	free(html);
	free(html2);
	return 0;
}

#ifdef _NO_PROTO
int SaFormPass(ename, evalue)
char* ename;
char* evalue;
#else
int SaFormPass(char* ename, char* evalue)
#endif
{
	char* html;
	char* html2;

	if ((!ename) || (!*ename))
	{
		html = SaMakeHtmlString("SaPassWord");
	}
	else
	{
		html = SaMakeHtmlString(ename);
	}
	html2 = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_PASSWORD, html, html2);
	free(html);
	free(html2);
	return 0;
}

#ifdef _NO_PROTO
int SaTableCaption(evalue, align)
char* evalue;
int align;
#else
int SaTableCaption(char* evalue, int align)
#endif
{
	char* html;
	char alignBuf[32];

	html = SaMakeHtmlString(evalue);
	if ((align > SA_NOALIGN) && (align <= SA_RIGHT))
	{
		sprintf(alignBuf, SA_ALIGN, align_types[align]);
	}
	else
	{
		alignBuf[0] = '\0';
	}
	fprintf(stdout, SA_TABLE_CAPTION, alignBuf, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaTextAreaBegin(ename, rows, cols, align)
char* ename;
int rows;
int cols;
int align;
#else
int SaTextAreaBegin(char* ename, int rows, int cols, int align)
#endif
{
	char* html;
	char rowBuf[32];
	char colBuf[32];
	char alignBuf[32];

	html = SaMakeHtmlString(ename);
	if (rows > 0)
	{
		sprintf(rowBuf, "ROWS=\"%-d\" ", rows);
	}
	else
	{
		rowBuf[0] = '\0';
	}
	if (cols > 0)
	{
		sprintf(colBuf, "COLS=\"%-d\" ", cols);
	}
	else
	{
		colBuf[0] = '\0';
	}
	if ((align > SA_NOALIGN) && (align <= SA_RIGHT))
	{
		sprintf(alignBuf, SA_ALIGN, align_types[align]);
	}
	else
	{
		alignBuf[0] = '\0';
	}
	fprintf(stdout, SA_TEXTAREA_B, html, rowBuf, colBuf, alignBuf);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaTableHeadExt(evalue, rows, cols, align, nowrap)
char* evalue;
int rows;
int cols;
int align;
int nowrap;
#else
int SaTableHeadExt(char* evalue, int rows, int cols, int align, int nowrap)
#endif
{
	char* html;
	char rowBuf[32];
	char colBuf[32];
	char alignBuf[32];

	html = SaMakeHtmlString(evalue);
	if (rows > 0)
	{
		sprintf(rowBuf, "ROWSPAN=\"%-d\" ", rows);
	}
	else
	{
		rowBuf[0] = '\0';
	}
	if (cols > 0)
	{
		sprintf(colBuf, "COLSPAN=\"%-d\" ", cols);
	}
	else
	{
		colBuf[0] = '\0';
	}
	if ((align > SA_NOALIGN) && (align <= SA_RIGHT))
	{
		sprintf(alignBuf, SA_ALIGN, align_types[align]);
	}
	else
	{
		alignBuf[0] = '\0';
	}
	fprintf(stdout, SA_TABLEHEAD_BM, nowrap? "NOWRAP" : "", rowBuf, colBuf,
								alignBuf, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaTableItem(evalue)
char* evalue;
#else
int SaTableItem(char* evalue)
#endif
{
	char* html;

	html = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_TABLEITEM, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaTableHead(evalue)
char* evalue;
#else
int SaTableHead(char* evalue)
#endif
{
	char* html;

	html = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_TABLEHEAD, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaListItem(evalue)
char* evalue;
#else
int SaListItem(char* evalue)
#endif
{
	char* html;

	html = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_LISTITEM, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaListHead(evalue)
char* evalue;
#else
int SaListHead(char* evalue)
#endif
{
	char* html;

	html = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_LISTHEAD, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaTableItemExt(evalue, rows, cols, align, nowrap)
char* evalue;
int rows;
int cols;
int align;
int nowrap;
#else
int SaTableItemExt(char* evalue, int rows, int cols, int align, int nowrap)
#endif
{
	char* html;
	char rowBuf[32];
	char colBuf[32];
	char alignBuf[32];

	html = SaMakeHtmlString(evalue);
	if (rows > 0)
	{
		sprintf(rowBuf, "ROWSPAN=\"%-d\" ", rows);
	}
	else
	{
		rowBuf[0] = '\0';
	}
	if (cols > 0)
	{
		sprintf(colBuf, "COLSPAN=\"%-d\" ", cols);
	}
	else
	{
		colBuf[0] = '\0';
	}
	if ((align > SA_NOALIGN) && (align <= SA_RIGHT))
	{
		sprintf(alignBuf, SA_ALIGN, align_types[align]);
	}
	else
	{
		alignBuf[0] = '\0';
	}
	fprintf(stdout, SA_TABLEITEM_BM, nowrap? "NOWRAP" : "", rowBuf, colBuf,
								alignBuf, html);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaTextArea(ename, evalue, rows, cols, align)
char* ename;
char* evalue;
int rows;
int cols;
int align;
#else
int SaTextArea(char* ename, char* evalue, int rows, int cols, int align)
#endif
{
	char* html;
	char* html2;
	char rowBuf[32];
	char colBuf[32];
	char alignBuf[32];

	html = SaMakeHtmlString(ename);
	html2 = SaMakeHtmlString(evalue);
	if (rows > 0)
	{
		sprintf(rowBuf, "ROWS=\"%-d\" ", rows);
	}
	else
	{
		rowBuf[0] = '\0';
	}
	if (cols > 0)
	{
		sprintf(colBuf, "COLS=\"%-d\" ", cols);
	}
	else
	{
		colBuf[0] = '\0';
	}
	if ((align > SA_NOALIGN) && (align <= SA_RIGHT))
	{
		sprintf(alignBuf, SA_ALIGN, align_types[align]);
	}
	else
	{
		alignBuf[0] = '\0';
	}
	fprintf(stdout, SA_TEXTAREA, html, rowBuf, colBuf, alignBuf, html2);
	free(html);
	free(html2);
	return 0;
}

#ifdef _NO_PROTO
int SaTextBox(ename, evalue, size, maxsize)
char* ename;
char* evalue;
int size;
int maxsize;
#else
int SaTextBox(char* ename, char* evalue, int size, int maxsize)
#endif
{
	char* html;
	char* html2;
	char sizeBuf[32];
	char maxBuf[32];

	html = SaMakeHtmlString(ename);
	html2 = SaMakeHtmlString(evalue);
	if (size > 0)
	{
		sprintf(sizeBuf, SA_SIZE, size);
	}
	else
	{
		sizeBuf[0] = '\0';
	}
	if (maxsize > 0)
	{
		sprintf(maxBuf, "MAXLENGTH=\"%-d\" ", maxsize);
	}
	else
	{
		maxBuf[0] = '\0';
	}
	fprintf(stdout, SA_TEXTBOX, html, html2, sizeBuf, maxBuf);
	free(html);
	free(html2);
	return 0;
}

#ifdef _NO_PROTO
int SaSelectBegin(ename, multi, size, elabel)
char* ename;
int multi;
int size;
char* elabel;
#else
int SaSelectBegin(char* ename, int multi, int size, char* elabel)
#endif
{
	char* html;
	char* html2;
	char sizeBuf[32];

	html = SaMakeHtmlString(ename);
	html2 = SaMakeHtmlString(elabel);
	if (size > 0)
	{
		sprintf(sizeBuf, SA_SIZE, size);
	}
	else
	{
		sizeBuf[0] = '\0';
	}
	fprintf(stdout, SA_SELECT_B, html2, html, multi ? "MULTIPLE" : "", sizeBuf);
	free(html);
	free(html2);
	return 0;
}

#ifdef _NO_PROTO
int SaFormRadio(ename, evalue, checked, elabel)
char* ename;
char* evalue;
int checked;
char* elabel;
#else
int SaFormRadio(char* ename, char* evalue, int checked, char* elabel)
#endif
{
	char* html;
	char* html2;
	char* html3;

	html = SaMakeHtmlString(ename);
	html2 = SaMakeHtmlString(evalue);
	html3 = SaMakeHtmlString(elabel);
	fprintf(stdout, SA_RADIO, html, html2, checked ? "CHECKED" : "", html3);
	free(html);
	free(html2);
	free(html3);
	return 0;
}

#ifdef _NO_PROTO
int SaSelectOption(evalue, selected, elabel)
char* evalue;
int selected;
char* elabel;
#else
int SaSelectOption(char* evalue, int selected, char* elabel)
#endif
{
	char* html2;
	char* html3;

	html2 = SaMakeHtmlString(evalue);
	html3 = SaMakeHtmlString(elabel);
	fprintf(stdout, SA_SELECT_OPTION, selected ? "SELECTED" : "", html2, html3);
	free(html2);
	free(html3);
	return 0;
}

#ifdef _NO_PROTO
int SaFormCheckBox(ename, evalue, checked, elabel)
char* ename;
char* evalue;
int checked;
char* elabel;
#else
int SaFormCheckBox(char* ename, char* evalue, int checked, char* elabel)
#endif
{
	char* html;
	char* html2;
	char* html3;

	html = SaMakeHtmlString(ename);
	if ((!evalue) || (!*evalue))
	{
		html2 = SaMakeHtmlString("on");
	}
	else
	{
		html2 = SaMakeHtmlString(evalue);
	}
	html3 = SaMakeHtmlString(elabel);
	fprintf(stdout, SA_CHECKBOX, html, html2, checked ? "CHECKED" : "", html3);
	free(html);
	free(html2);
	free(html3);
	return 0;
}

#ifdef _NO_PROTO
int SaFormBegin(faction, fmethod)
char* faction;
char* fmethod;
#else
int SaFormBegin(char* faction, char* fmethod)
#endif
{
	char* html;

	html = SaMakeHtmlString(faction);
	if ((!fmethod) || (!*fmethod))
		fmethod = "post";
	fprintf(stdout, "%s", SA_FORM_B);
	fprintf(stdout, SA_ACTION, html);
	fprintf(stdout, SA_METHOD, fmethod);
	fprintf(stdout, "> ");
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaFormEnd()
#else
int SaFormEnd()
#endif
{
	fprintf(stdout, "%s", SA_FORM_E);
	return 0;
}

#ifdef _NO_PROTO
int SaTableBegin()
#else
int SaTableBegin()
#endif
{
	fprintf(stdout, "%s", SA_TABLE_B);
	return 0;
}

#ifdef _NO_PROTO
int SaRowBeginExt(nowrap, align, valign)
int nowrap;
int align;
int valign;
#else
int SaRowBeginExt(int nowrap, int align, int valign)
#endif
{
	char alignBuf[32];
	char valignBuf[32];
	
	if ((align >= SA_LEFT) && (align <= SA_RIGHT))
	{
		sprintf(alignBuf, SA_ALIGN, align_types[align]);
	}
	else
	{
		alignBuf[0] = '\0';
	}
	if ((valign > SA_NOALIGN) && (valign <= SA_BOTTOM))
	{
		sprintf(valignBuf, SA_VALIGN, align_types[align]);
	}
	else
	{
		valignBuf[0] = '\0';
	}
	fprintf(stdout, SA_TABLEROW_BM, nowrap ? "NOWRAP" : "", align, valign);
	return 0;
}

#ifdef _NO_PROTO
int SaTableBeginExt(border, nowrap, align)
int border;
int nowrap;
int align;
#else
int SaTableBeginExt(int border, int nowrap, int align)
#endif
{
	char alignBuf[32];
	
	if ((align > SA_NOALIGN) && (align <= SA_RIGHT))
	{
		sprintf(alignBuf, SA_ALIGN, align_types[align]);
	}
	else
	{
		alignBuf[0] = '\0';
	}
	fprintf(stdout, SA_TABLE_BM, border? "BORDER" : "", nowrap ? "NOWRAP" : "",
			align);
	return 0;
}

#ifdef _NO_PROTO
int SaTableEnd()
#else
int SaTableEnd()
#endif
{
	fprintf(stdout, "%s", SA_TABLE_E);
	return 0;
}

#ifdef _NO_PROTO
int SaTableItemBegin()
#else
int SaTableItemBegin()
#endif
{
	fprintf(stdout, "%s", SA_TABLEITEM_B);
	return 0;
}

#ifdef _NO_PROTO
int SaTableItemEnd()
#else
int SaTableItemEnd()
#endif
{
	fprintf(stdout, "%s", SA_TABLEITEM_E);
	return 0;
}

#ifdef _NO_PROTO
int SaHeader(evalue, size)
char* evalue;
int size;
#else
int SaHeader(char* evalue, int size)
#endif
{
	char* html;

	if ((size < 1) || (size > 6))
		size = 1;
	html = SaMakeHtmlString(evalue);
	fprintf(stdout, SA_HEADER, size, html, size);
	free(html);
	return 0;
}

#ifdef _NO_PROTO
int SaHeaderBegin(size)
int size;
#else
int SaHeaderBegin(int size)
#endif
{
	if ((size < 1) || (size > 6))
		size = 1;
	fprintf(stdout, SA_HEADER_B, size);
	return 0;
}

#ifdef _NO_PROTO
int SaHeaderEnd(size)
int size;
#else
int SaHeaderEnd(int size)
#endif
{
	if ((size < 1) || (size > 6))
		size = 1;
	fprintf(stdout, SA_HEADER_E, size);
	return 0;
}

#ifdef _NO_PROTO
int SaTableHeadBegin()
#else
int SaTableHeadBegin()
#endif
{
	fprintf(stdout, "%s", SA_TABLEHEAD_B);
	return 0;
}

#ifdef _NO_PROTO
int SaTableHeadEnd()
#else
int SaTableHeadEnd()
#endif
{
	fprintf(stdout, "%s", SA_TABLEHEAD_E);
	return 0;
}

#ifdef _NO_PROTO
int SaTableRowBegin()
#else
int SaTableRowBegin()
#endif
{
	fprintf(stdout, "%s", SA_TABLEROW_B);
	return 0;
}

#ifdef _NO_PROTO
int SaTableRowEnd()
#else
int SaTableRowEnd()
#endif
{
	fprintf(stdout, "%s", SA_TABLEROW_E);
	return 0;
}

#ifdef _NO_PROTO
int SaTextAreaEnd()
#else
int SaTextAreaEnd()
#endif
{
	fprintf(stdout, "%s", SA_TEXTA_E);
	return 0;
}

#ifdef _NO_PROTO
int SaUListBegin()
#else
int SaUListBegin()
#endif
{
	fprintf(stdout, "%s", SA_ULIST_B);
	return 0;
}

#ifdef _NO_PROTO
int SaListItemEnd()
#else
int SaListItemEnd()
#endif
{
	fprintf(stdout, "%s", SA_LISTITEM_END);
	return 0;
}

#ifdef _NO_PROTO
int SaListItemBegin()
#else
int SaListItemBegin()
#endif
{
	fprintf(stdout, "%s", SA_LISTITEM_BEGIN);
	return 0;
}

#ifdef _NO_PROTO
int SaOListBegin()
#else
int SaOListBegin()
#endif
{
	fprintf(stdout, "%s", SA_OLIST_B);
	return 0;
}

#ifdef _NO_PROTO
int SaUListEnd()
#else
int SaUListEnd()
#endif
{
	fprintf(stdout, "%s", SA_ULIST_E);
	return 0;
}

#ifdef _NO_PROTO
int SaOListEnd()
#else
int SaOListEnd()
#endif
{
	fprintf(stdout, "%s", SA_OLIST_E);
	return 0;
}

#ifdef _NO_PROTO
int SaMenuBegin()
#else
int SaMenuBegin()
#endif
{
	fprintf(stdout, "%s", SA_MENU_B);
	return 0;
}

#ifdef _NO_PROTO
int SaMenuEnd()
#else
int SaMenuEnd()
#endif
{
	fprintf(stdout, "%s", SA_MENU_E);
	return 0;
}

#ifdef _NO_PROTO
int SaSelectEnd()
#else
int SaSelectEnd()
#endif
{
	fprintf(stdout, "%s", SA_SELECT_E);
	return 0;
}

#ifdef _NO_PROTO
int SaHtmlBegin()
#else
int SaHtmlBegin()
#endif
{
	fprintf(stdout, "%s", SA_HTML_B);
	return 0;
}

#ifdef _NO_PROTO
int SaHtmlEnd()
#else
int SaHtmlEnd()
#endif
{
	fprintf(stdout, "%s", SA_HTML_E);
	return 0;
}

#ifdef _NO_PROTO
int SaBodyBegin()
#else
int SaBodyBegin()
#endif
{
	fprintf(stdout, "%s", SA_BODY_B);
	return 0;
}

#ifdef _NO_PROTO
int SaBodyEnd()
#else
int SaBodyEnd()
#endif
{
	fprintf(stdout, "%s", SA_BODY_E);
	return 0;
}

#ifdef _NO_PROTO
int SaHeadBegin()
#else
int SaHeadBegin()
#endif
{
	fprintf(stdout, "%s", SA_HEAD_B);
	return 0;
}

#ifdef _NO_PROTO
int SaHeadEnd()
#else
int SaHeadEnd()
#endif
{
	fprintf(stdout, "%s", SA_HEAD_E);
	return 0;
}

/***** end of new ****/
#ifdef _NO_PROTO
int SaHtmlStrLen(str)
char* str;
#else
int SaHtmlStrLen(char* str)
#endif
{
	static int once = 0;
	int amp_len, quot_len, less_len, grea_len;
	int len = 0;
	char* ptr;

	if(!once)
	{
		once = 1;
		amp_len = strlen(SA_AMP) - 1;
		less_len = strlen(SA_LESSTHAN) - 1;
		grea_len = strlen(SA_GREATERTHAN) - 1;
		quot_len = strlen(SA_QUOTE) - 1;
	}

	if (str == NULL)
	{
		return 0;
	}
	ptr = str;
	while(*ptr != '\0')
	{
		len++;
		if(*ptr == '&')
		{
			len+=  amp_len;
		}
		else if(*ptr == '<')
		{
			len+=  less_len;
		}
		else if(*ptr == '>')
		{
			len+= grea_len;
		}
		else if(*ptr == '"')
		{
			len+= quot_len;
		}
		ptr++;
	}
	return len;
}

#ifdef _NO_PROTO
char* SaMakeHtmlString(str)
char* str;
#else
char* SaMakeHtmlString(char* str)
#endif
{
	static int once = 0;
	static int amp_len, quot_len, less_len, grea_len;
	char *s;
	int len = 0;
	char* ptr;
	char* ptr2;

	if(!once)
	{
		once = 1;
		amp_len = strlen(SA_AMP) - 1;
		less_len = strlen(SA_LESSTHAN) - 1;
		grea_len = strlen(SA_GREATERTHAN) - 1;
		quot_len = strlen(SA_QUOTE) - 1;
	}

	if (str == NULL)
	{
		s = (char *) malloc(1);
		s[0] = '\0';
		return s;
	}
	ptr = str;
	while(*ptr != '\0')
	{
		len++;
		if(*ptr == '&')
		{
			len+=  amp_len;
		}
		else if(*ptr == '<')
		{
			len+=  less_len;
		}
		else if(*ptr == '>')
		{
			len+= grea_len;
		}
		else if(*ptr == '"')
		{
			len+= quot_len;
		}
		ptr++;
	}
	s = (char*) malloc(len + 1);
	ptr = str;
	ptr2 = s;
	while(*ptr != '\0')
	{
		if(*ptr == '&')
		{
			strcpy(ptr2, SA_AMP);
			ptr2+=  amp_len;
		}
		else if(*ptr == '<')
		{
			strcpy(ptr2, SA_LESSTHAN);
			ptr2+=  less_len;
		}
		else if(*ptr == '>')
		{
			strcpy(ptr2, SA_GREATERTHAN);
			ptr2+= grea_len;
		}
		else if(*ptr == '"')
		{
			strcpy(ptr2, SA_QUOTE);
			ptr2+= quot_len;
		}
		else
		{
			*ptr2 = *ptr;
		}
		ptr++;
		ptr2++;
	}
	*ptr2 = *ptr;
	return s;
}

#ifdef _NO_PROTO
char* SaFixHtmlQString(str)
char* str;
#else
char* SaFixHtmlQString(char* str)
#endif
{
	int len;
	char* fixStr;
	char* fptr;
	char* ptr;
	int sp_len;

	if(str == NULL)
		return NULL;

	sp_len = strlen(SA_SPACE);

	len = strlen(str);
	fixStr = (char*) malloc(len + 1);
	ptr = str;
	fptr = fixStr;
	while (*ptr)
	{
		if (strncmp(ptr, SA_SPACE, sp_len) == 0)
		{
			*fptr = ' ';
			ptr += sp_len-1;
		}
		else
		{
			*fptr = *ptr;
		}
		fptr++;
		ptr++;
	}
	*fptr = '\0';
	return fixStr;
}

#ifdef _NO_PROTO
char* SaMakeHtmlQString(str)
char* str;
#else
char* SaMakeHtmlQString(char* str)
#endif
{
	static int once = 0;
	static int amp_len, quot_len, less_len, grea_len, space_len;
	char *s;
	int len = 0;
	char* ptr;
	char* ptr2;

	if(!once)
	{
		once = 1;
		amp_len = strlen(SA_AMP) - 1;
		less_len = strlen(SA_LESSTHAN) - 1;
		grea_len = strlen(SA_GREATERTHAN) - 1;
		quot_len = strlen(SA_QUOTE) - 1;
		space_len = strlen(SA_SPACE) - 1;
	}

	if (str == NULL)
	{
		s = (char *) malloc(1);
		s[0] = '\0';
		return s;
	}
	ptr = str;
	while(*ptr != '\0')
	{
		len++;
		if(*ptr == '&')
		{
			len+=  amp_len;
		}
		else if(*ptr == '<')
		{
			len+=  less_len;
		}
		else if(*ptr == '>')
		{
			len+= grea_len;
		}
		else if(*ptr == '"')
		{
			len+= quot_len;
		}
		else if(*ptr == ' ')
		{
			len+= space_len;
		}
		ptr++;
	}
	s = (char*) malloc(len + 1);
	ptr = str;
	ptr2 = s;
	while(*ptr != '\0')
	{
		if(*ptr == '&')
		{
			strcpy(ptr2, SA_AMP);
			ptr2+=  amp_len;
		}
		else if(*ptr == '<')
		{
			strcpy(ptr2, SA_LESSTHAN);
			ptr2+=  less_len;
		}
		else if(*ptr == '>')
		{
			strcpy(ptr2, SA_GREATERTHAN);
			ptr2+= grea_len;
		}
		else if(*ptr == '"')
		{
			strcpy(ptr2, SA_QUOTE);
			ptr2+= quot_len;
		}
		else if(*ptr == ' ')
		{
			strcpy(ptr2, SA_SPACE);
			ptr2+= space_len;
		}
		else
		{
			*ptr2 = *ptr;
		}
		ptr++;
		ptr2++;
	}
	*ptr2 = *ptr;
	return s;
}

#ifdef _NO_PROTO
void SaPrintOutHtmlError(msg)
char* msg;
#else
void SaPrintOutHtmlError(char* msg)
#endif
{
	char* html;

	if ((!msg) || (!*msg))
		return;
	html = SaMakeHtmlString(msg);
	fprintf(stdout, "<PRE>%s\n</PRE>", html);
	free(html);
}

#ifdef _NO_PROTO
void SaBeginMsgBox(title)
char *title;
#else
void SaBeginMsgBox(char* title)
#endif
{
	char *str;

	if (!title)
	{
		str = SaMakeHtmlString("Results");
	}
	else
	{
		str = SaMakeHtmlString(title);
	}

	fprintf(stdout, "%s", SA_HTML_B);
	fprintf(stdout, "%s", SA_HEAD_B);
	fprintf(stdout, "%s", SA_TITLE_B);
	fprintf(stdout, "%s", str);
	fprintf(stdout, "%s", SA_TITLE_E);
	fprintf(stdout, "%s", SA_HEAD_E);
	fprintf(stdout, "%s", SA_BODY_B);

	free(str);
}

#ifdef _NO_PROTO
void SaEndMsgBox()
#else
void SaEndMsgBox()
#endif
{
	fprintf(stdout, "%s", SA_BODY_E);
	fprintf(stdout, "%s", SA_HTML_E);
}

#ifdef _NO_PROTO
void SaPopulateTableMsgBox(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateTableMsgBox(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	SaBeginMsgBox((char*) client_data);
	SaPopulateTableAll(list, client_data, cbs);
	SaEndMsgBox();
}

#ifdef _NO_PROTO
void SaPopulateMsgBox(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateMsgBox(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	SaBeginMsgBox((char*) client_data);
	SaPopulateParagraph(list, client_data, cbs);
	SaEndMsgBox();
}

#ifdef _NO_PROTO
void SaPopulateMasDetHotList(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateMasDetHotList(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;
	char* currentPtr;
	int numCols = -1;
	int primeKeys = 1;
	pSutList anchPieces;
	int whichColumn;
	char* lastGroup = NULL;
	char* lastTitle = NULL;
	char* newGroup = NULL;
	char* appendString;

	if (cbs == NULL)
		return;

	whichColumn = (int) client_data;
	if (whichColumn < 0)
		whichColumn = 0;

	if (whichColumn >= cbs->groups[0].nCols)
		whichColumn = (cbs->groups[0].nCols) - 1;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
		if (cbs->groups[groupCount].nCols > numCols)
			numCols = cbs->groups[groupCount].nCols;
	}

	if (totalRows == 0)
	{
		return;
	}

	currentPtr = SaGetCurrentPtr();
	if(!currentPtr)
	{
		return;
	}
	currentPtr = SaGetCurrentAnchString(currentPtr);
	if(!currentPtr)
	{
		return;
	}
	anchPieces = SaAnchStringToPieceList(currentPtr);
	if (!anchPieces)
	{
		free(currentPtr);
		return;
	}

	SaSetSkipAnch();
	free(currentPtr);

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=primeKeys; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			if (colCount == whichColumn)
			{
				if(!lastTitle)
				{
					if (cbs->groups[groupCount].columnTitles)
					{
						lastTitle = SaMakeHtmlString(
								cbs->groups[groupCount].columnTitles[colCount]);
					}
					else
					{
						lastTitle = SaMakeHtmlString("");
					}
				}
				continue;
			}
			colSize = cbs->groups[groupCount].colWidth[colCount];
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);

		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				if (whichColumn == colCount)
				{
					if (newGroup)
						free(newGroup);
					newGroup = SaMakeHtmlString(
							cbs->groups[groupCount].data[colCount][rowCount]);
					if (lastGroup)
					{
						if(strcmp(lastGroup, newGroup) == 0)
						{
							free(newGroup);
							newGroup = NULL;
							continue;
						}
					}
					if (lastGroup)
					{
						free(lastGroup);
					}
					lastGroup = newGroup;
					newGroup = NULL;
					fprintf(stdout, "<BR>\n<BR>\n");
					fprintf(stdout, "<H2>%s : %s</H2>", lastTitle, lastGroup);
					fprintf(stdout, "<BR>\n");
				}
			}
			fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,0));
			for(colCount=0; colCount<primeKeys; colCount++)
			{
				if (whichColumn == colCount)
					continue;
				html_str = SaMakeHtmlQString
						(cbs->groups[groupCount].data[colCount][rowCount]);
				fprintf(stdout, "___%s", html_str);
				free(html_str);
			}	/** end for each column **/
			appendString = SaGetOptionValue(cbs->groups[0].options,
							ANCH_MORE);
			if(appendString)
			{
				html_str = SaMakeHtmlString(appendString);
				fprintf(stdout, "%s", html_str);
				free(html_str);
				free(appendString);
			}
			SaPrintKeyStr();
			fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,1));
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=primeKeys; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				if (whichColumn == colCount)
					continue;
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			fprintf(stdout, "%s", html_str);
			free(html_str);
			fprintf(stdout, "%s<BR>\n", (char*) SutGetNList(anchPieces,2));
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
	if (lastGroup) free(lastGroup);
	if (newGroup) free(newGroup);
	SutDestroyList(anchPieces);
}

#ifdef _NO_PROTO
void SaPopulateHotList(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateHotList(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;
	char* currentPtr;
	int numCols = -1;
	int primeKeys;
	pSutList anchPieces;
	char* appendString;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
		if (cbs->groups[groupCount].nCols > numCols)
			numCols = cbs->groups[groupCount].nCols;
	}

	if (totalRows == 0)
	{
		return;
	}

	primeKeys = (int) client_data;
	if (primeKeys == 0)
		primeKeys = 1;
	if (numCols < primeKeys)
		return;

	currentPtr = SaGetCurrentPtr();
	if(!currentPtr)
	{
		return;
	}
	currentPtr = SaGetCurrentAnchString(currentPtr);
	if(!currentPtr)
	{
		return;
	}
	anchPieces = SaAnchStringToPieceList(currentPtr);
	if (!anchPieces)
	{
		free(currentPtr);
		return;
	}

	SaSetSkipAnch();
	free(currentPtr);

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=primeKeys; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);

		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,0));
			for(colCount=0; colCount<primeKeys; colCount++)
			{
				html_str = SaMakeHtmlQString
						(cbs->groups[groupCount].data[colCount][rowCount]);
				fprintf(stdout, "___%s", html_str);
				free(html_str);
			}	/** end for each column **/
			appendString = SaGetOptionValue(cbs->groups[0].options,
							ANCH_MORE);
			if(appendString)
			{
				html_str = SaMakeHtmlString(appendString);
				fprintf(stdout, "%s", html_str);
				free(html_str);
				free(appendString);
			}
			SaPrintKeyStr();
			fprintf(stdout, "%s", (char*) SutGetNList(anchPieces,1));
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=primeKeys; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			fprintf(stdout, "%s", html_str);
			free(html_str);
			fprintf(stdout, "%s<BR>\n", (char*) SutGetNList(anchPieces,2));
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
	SutDestroyList(anchPieces);
}

#ifdef _NO_PROTO
void SaPopulateOptions(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateOptions(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;
	int first = 1;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
	}

	if (totalRows == 0)
	{
		return;
	}

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			if (!first)
			{
				fprintf(stdout, "%s", SA_OPTION_END);
				fprintf(stdout, "%s", SA_OPTION_BEGIN);
			}
			first = 0;
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			fprintf(stdout, "%s", html_str);
			free(html_str);
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
}

#ifdef _NO_PROTO
void SaPopulateTextArea(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateTextArea(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
	}

	if (totalRows == 0)
	{
		return;
	}

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			fprintf(stdout, "%s\n", html_str);
			free(html_str);
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
}

#ifdef _NO_PROTO
void SaPopulateParagraph(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateParagraph(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len;
	int bufCount;
	char *buf = NULL;
	char *html_str;
	int labellength;
	int labelcount;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	labellength = -1;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			if (!cbs->groups[groupCount].columnTitles)
				continue;
			if (cbs->groups[groupCount].columnTitles[colCount])
			{
				len = strlen(cbs->groups[groupCount].columnTitles[colCount]);
				if (len > labellength)
					labellength = len;
			}
		}
	}

	if (totalRows == 0)
	{
		return;
	}
	if (labellength < 1)
		labellength = 1;
	labellength++;
	buf = (char*) malloc(labellength + 1);
	buf[0] = '\0';

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				if (!cbs->groups[groupCount].columnTitles)
				{
					for(labelcount=0; labelcount<labellength; labelcount++)
					{
						buf[labelcount] = ' ';
					}
					buf[labellength] = '\0';
				}
				else if (cbs->groups[groupCount].columnTitles[colCount])
				{
					len = strlen(cbs->groups[groupCount].columnTitles[colCount]);
					strcpy(buf, cbs->groups[groupCount].columnTitles[colCount]);
					for(labelcount=len; labelcount<labellength; labelcount++)
					{
						buf[labelcount] = ' ';
					}
					buf[labellength] = '\0';
				}
				else
				{
					for(labelcount=0; labelcount<labellength; labelcount++)
					{
						buf[labelcount] = ' ';
					}
					buf[labellength] = '\0';
				}
				html_str = SaMakeHtmlString(buf);
				fprintf(stdout, "%s : ", html_str);
				free(html_str);
				html_str = SaMakeHtmlString(
					cbs->groups[groupCount].data[colCount][rowCount]);
				fprintf(stdout, "%s<BR>\n", html_str);
				free(html_str);
			}	/** end for each column **/
			fprintf(stdout, "<BR>\n");
		}	/** end for each row **/
		fprintf(stdout, "<BR>\n");
	}	/** end for each group **/

	if (buf) free(buf);
}

#ifdef _NO_PROTO
void SaPopulateTableAll(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateTableAll(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	char* str;
	char* hstr;

	if (cbs == NULL) return;

	str = (char*) client_data;
	hstr = SaMakeHtmlString(str);

	fprintf(stdout, "<TABLE BORDER>\n");
	fprintf(stdout, "<CAPTION>%s</CAPTION>\n", hstr);
	SaPopulateTable(list, client_data, cbs);
	fprintf(stdout, "</TABLE>\n");

	free(hstr);
}

#ifdef _NO_PROTO
void SaPopulateTable(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateTable(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	char *buf = NULL;
	char *html_str;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
	}

	if (totalRows == 0)
	{
		return;
	}

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		fprintf(stdout, "<TR>\n");
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			buf = cbs->groups[groupCount].columnTitles[colCount];
			html_str = SaMakeHtmlString(buf);
			fprintf(stdout, "<TH>%s</TH>\n", html_str);
			free(html_str);
		}
		fprintf(stdout, "</TR>\n");
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			fprintf(stdout, "<TR>\n");
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				buf = cbs->groups[groupCount].data[colCount][rowCount];
				html_str = SaMakeHtmlString(buf);
				fprintf(stdout, "<TD>%s</TD>\n", html_str);
				free(html_str);
			}	/** end for each column **/
			fprintf(stdout, "</TR>\n");
		}	/** end for each row **/
	}	/** end for each group **/
}

#ifdef _NO_PROTO
void SaPopulateForText(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateForText(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
	}

	if (totalRows == 0)
	{
		return;
	}

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			if (totalRows == 1)
			{
				fprintf(stdout, "%s", html_str);
			}
			else
			{
				fprintf(stdout, "%s<BR>\n", html_str);
			}		
			free(html_str);
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
}

#ifdef _NO_PROTO
void SaPopulateMasterDetail(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateMasterDetail(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;
	int whichColumn;
	char* lastGroup = NULL;
	char* lastTitle = NULL;
	char* newGroup = NULL;

	if (cbs == NULL)
		return;

	if (!(cbs->groups))
		return;

	whichColumn = (int) client_data;
	if (whichColumn < 0)
		whichColumn = 0;

	if (whichColumn >= cbs->groups[0].nCols)
		whichColumn = (cbs->groups[0].nCols) - 1;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
	}

	if (totalRows == 0)
	{
		return;
	}

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			if (colCount == whichColumn)
			{
				if(!lastTitle)
				{
					if (cbs->groups[groupCount].columnTitles)
					{
						lastTitle = SaMakeHtmlString(
								cbs->groups[groupCount].columnTitles[colCount]);
					}
					else
					{
						lastTitle = SaMakeHtmlString("");
					}
				}
				continue;
			}
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				if (whichColumn == colCount)
				{
					if (newGroup)
						free(newGroup);
					newGroup = SaMakeHtmlString(
							cbs->groups[groupCount].data[colCount][rowCount]);
					if (lastGroup)
					{
						if(strcmp(lastGroup, newGroup) == 0)
						{
							free(newGroup);
							newGroup = NULL;
							continue;
						}
					}
					if (lastGroup)
					{
						free(lastGroup);
					}
					lastGroup = newGroup;
					newGroup = NULL;
					fprintf(stdout, "<BR>\n<BR>\n");
					fprintf(stdout, "<H2>%s : %s</H2>", lastTitle, lastGroup);
					fprintf(stdout, "<BR>\n");
					continue;
				}
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			if (totalRows == 1)
			{
				fprintf(stdout, "%s", html_str);
			}
			else
			{
				fprintf(stdout, "%s<BR>\n", html_str);
			}		
			free(html_str);
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
	if (lastGroup) free(lastGroup);
	if (newGroup) free(newGroup);
}

#ifdef _NO_PROTO
void SaPopulateChars(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateChars(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
	}

	if (totalRows == 0)
	{
		return;
	}

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			if (totalRows == 1)
			{
				fprintf(stdout, "%s", html_str);
			}
			else
			{
				fprintf(stdout, "%s<BR>\n", html_str);
			}		
			free(html_str);
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
}

#ifdef _NO_PROTO
void SaPopulateListItem(list, client_data, cbs)
Widget list;
XtPointer client_data;
SaCallbackStruct *cbs;
#else
void SaPopulateListItem(Widget list, XtPointer client_data,
						SaCallbackStruct *cbs)
#endif
{
	int groupCount, rowCount, colCount;
	int totalRows;
	int len, colSize;
	int i;
	int bufCount;
	int bufLen;
	char *buf = NULL;
	char *html_str;
	int first = 1;

	if (cbs == NULL) return;

	/*** determine # rows for all groups **/
	totalRows = 0;
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		totalRows = totalRows + cbs->groups[groupCount].nRows;
	}

	if (totalRows == 0)
	{
		return;
	}

	/*** process one results group at a time ****/
	for (groupCount=0; groupCount<cbs->nGroups; groupCount++)
	{
		bufLen = 0;
		for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
		{
			colSize = cbs->groups[groupCount].colWidth[colCount];
			bufLen += colSize + 1;
		}
		if (buf) free(buf);
		buf = (char*) malloc(bufLen + 1);
		for(rowCount=0; rowCount<cbs->groups[groupCount].nRows; rowCount++)
		{
			if (!first)
			{
				fprintf(stdout, "%s", SA_LISTITEM_END);
				fprintf(stdout, "%s", SA_LISTITEM_BEGIN);
			}
			first = 0;
			buf[0] = '\0';
			bufCount = 0;
			for(colCount=0; colCount<cbs->groups[groupCount].nCols; colCount++)
			{
				colSize = cbs->groups[groupCount].colWidth[colCount];
				if(cbs->groups[groupCount].data[colCount][rowCount] == NULL)
				{
					len = 0;
				}
				else
				{
					len =
					strlen(cbs->groups[groupCount].data[colCount][rowCount]);
					strcat(buf,
						cbs->groups[groupCount].data[colCount][rowCount]);
					bufCount += len;
				}
				for(i=len; i<colSize+1; i++)
				{
					if (colCount!=cbs->groups[groupCount].nCols-1)
						buf[bufCount++] = ' ';
				}
				buf[bufCount] = '\0';
			}	/** end for each column **/
			html_str = SaMakeHtmlString(buf);
			fprintf(stdout, "%s", html_str);
			free(html_str);
		}	/** end for each row **/
	}	/** end for each group **/

	if (buf) free(buf);
}
