#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <varargs.h>
#include "SaRnHtml.h"

#include "SaHtmlTP.h"

#define HTML_BEGIN "<HTML>\n<TITLE>"
#define HTML_BODY "</TITLE>\n<BODY>\n"
#define HTML_END "</BODY>\n</HTML>"
#define HTML_ADDB "<INPUT TYPE=\"SUBMIT\" NAME=\"SubmitName\" VALUE=\"Insert\">"
#define HTML_DELB "<INPUT TYPE=\"SUBMIT\" NAME=\"SubmitName\" VALUE=\"Delete\">"
#define HTML_UPDB "<INPUT TYPE=\"SUBMIT\" NAME=\"SubmitName\" VALUE=\"Update\">"
#define HTML_FINB "<INPUT TYPE=\"SUBMIT\" NAME=\"SubmitName\" VALUE=\"Search\">"
#define HTML_PASS "Password : <INPUT TYPE=\"PASSWORD\" NAME=\"SaPassWord\" VALUE=\"%s\">"
#define HTML_USER "Username : <INPUT NAME=\"SaUserName\" VALUE=\"%s\">"
#define HTML_RESET "<INPUT TYPE=\"RESET\" VALUE=\"Reset\">"
#define HTML_IBOX_LAB "\n%s : "
#define HTML_IBOX "<INPUT NAME=\"%s\" VALUE=\"%s\" SIZE=%d>\n"
#define HTML_MTBOX "<TEXTAREA NAME=\"%s\" ROWS=4 COLS=64>%s</TEXTAREA>\n"
#define HTML_HBOX " <INPUT TYPE=\"hidden\" NAME=\"%s_OLD\" VALUE=\"%s\">"
#define HTML_CBOX " <INPUT TYPE=\"hidden\" NAME=\"SA_TABLE_COLS\" VALUE=\"%s\">"
#define HTML_KBOX " <INPUT TYPE=\"hidden\" NAME=\"SA_TABLE_KEYS\" VALUE=\"%s\">"
#define HTML_QBOX " <INPUT TYPE=\"hidden\" NAME=\"SA_TABLE_NOQU\" VALUE=\"%s\">"
#define HTML_TBOX " <INPUT TYPE=\"hidden\" NAME=\"SA_TABLE_NAME\" VALUE=\"%s\">"
#define HTML_HID "<INPUT TYPE=\"hidden\" NAME=\"SaFormName\" VALUE=\"%s\">\n"
#define HTML_FOR "<PRE><FORM ACTION=\"%s\" METHOD=\"post\" >\n"
#define HTML_FOR_E "</FORM></PRE>"
#define HTML_ANCH_S "<A HREF=\"%s?FNC=%s\" >Temp</A> "
#define HTML_SEL_BEG "<SELECT NAME=\"%s_OP\">"
#define HTML_OPT_EL "<OPTION %s VALUE=\"%s\">%s</OPTION>"
#define HTML_SEL_END "</SELECT>"
#define HTML_ESC "<BR><BR><A HREF=\"%s\" >RETURN</A> "
#define HTML_TABLE_ARG "TABLE="
#define HTML_TABLE_ARG2 "TABLE"

#define HTML_TABLE_USE_PASS "SaHtmlTable.UsePass"
#define HTML_TABLE_ECHO_PASS "SaHtmlTable.EchoPass"
#define HTML_TABLE_HIDE_INSERT "SaHtmlTable.HideInsert"
#define HTML_TABLE_HIDE_UPDATE "SaHtmlTable.HideUpdate"
#define HTML_TABLE_HIDE_DELETE "SaHtmlTable.HideDelete"
#define HTML_TABLE_TEMPLATE "SaHtmlTable.Template"
#define HTML_TABLE_AUTO_KEY "SaHtmlTable.AutoKey"

#define HTML_TABLE_FILE_EXT "_tab.html"
#define HTML_TABLE_BEGIN "##Sa_Table_Begin##"
#define HTML_TABLE_END "##Sa_Table_End##"
#define HTML_TABLE_LIST "##Sa_Table_List##"

#define SA_N 1000
#define SA_S 1001 
#define SA_C 1002 
#define SA_K 1003 
#define SA_Q 1004 

static char* default_ops[] = {
							" ",
							" like ",
							" begins ",
							" ends ",
							" contains ",
							" = ",
							" > ",
							" >= ",
							" < ",
							" <= "
							};

static char* default_ops_str[] = {
							"not used",
							"like",
							"begins with",
							"ends with",
							"contains",
							"equals",
							"greater than",
							"greater than or equals",
							"less than",
							"less than or equals"
							};

extern pSutList SaParseFileString SUTPROTO((char* str,char *colsep,
						char *textsep));
extern pSutList SaOptionGetFromString SUTPROTO((char *str));
int SaDoHtmlTable SUTPROTO((char *server, char* db, char* table, int vendor,
				pSutList options));

#ifdef _NO_PROTO
int SaParseTemplateHtmlTable(tbl)
pSaHtmlTable tbl;
#else
int SaParseTemplateHtmlTable(pSaHtmlTable tbl)
#endif
{
	char* filename;
	char* tablename;
	char* contents;
	char* ptr;
	char* str;
	pSutList frags;
	pSutList options;

	if(!tbl)
		return 1;

	/**** check if owner name is prepended, and skip owner ***/
	tablename = strstr(tbl->tble, ".");
	if((!tablename) || (!*tablename))
	{
		tablename = tbl->tble;
	}
	else
	{
		tablename += 1;
	}
	/**** template file name determined from table name ****/
	filename = (char*) malloc(strlen(tablename) + 1 +
							strlen(HTML_TABLE_FILE_EXT));
	sprintf(filename, "%s%s", tablename, HTML_TABLE_FILE_EXT);
	/**** read in template file ****/
	contents = SaReadFileToString(filename);
	free(filename);
	if ((!contents) || (!*contents))
		return 1;

	ptr = contents;

	str = ptr;
	/*** verify template file ****/
	ptr = strstr(str, HTML_TABLE_BEGIN);
	if ((!ptr) || (!*ptr))
	{
		free(contents);
		return 1;
	}
	frags = SutNewList();
	*ptr = '\0';
	SutAddList(frags, SaCopyString(str));
	ptr += strlen(HTML_TABLE_BEGIN);

	str = ptr;
	ptr = strstr(str, HTML_TABLE_END);
	if ((!ptr) || (!*ptr))
	{
		free(contents);
		SutDestroyList(frags);
		return 1;
	}
	*ptr = '\0';
	options = SaOptionGetFromString(str);
	ptr += strlen(HTML_TABLE_END);
	
	str = ptr;
	ptr = strstr(str, HTML_TABLE_LIST);
	if ((!ptr) || (!*ptr))
	{
		free(contents);
		SutDestroyList(frags);
		return 1;
	}
	*ptr = '\0';
	SutAddList(frags, SaCopyString(str));
	ptr += strlen(HTML_TABLE_LIST);

	if ((!ptr) || (!*ptr))
	{
		free(contents);
		SutDestroyList(frags);
		return 1;
	}
	SutAddList(frags, SaCopyString(ptr));

	tbl->frags = frags;
	if (options)
	{
		if (tbl->options)
		{
			SutListCat(tbl->options, options);
			SutDeleteList(options);
		}
		else
		{
			tbl->options = options;
		}
	}
	free(contents);

	return 0;
}

#ifdef _NO_PROTO
int SaVaHtmlTable(server, db, table, vendor, va_alist)
char *server;
char* db;
char* table;
int vendor;
/* va_dcl */
int va_alist;
#else
#ifndef _WINDOWS
int SaVaHtmlTable(char* server, char* db, char* table, int vendor, ...)
#else
int XKEXPORT SaVaHtmlTable(char* server, char* db, char* table, int vendor,
					int va_alist)
#endif /* _WINDOWS */
#endif
{
	char *str;
	int stat;
	va_list ap;
	pSutList options = NULL;

	va_start(ap);

	while((str = va_arg(ap, char*)) != NULL)
	{
		if (options == NULL)
		{
			options = SutNewList();
		}
		SutAddList(options, SaCopyString(str));
	}

	/***** create table, pass in options *****/
	stat = SaDoHtmlTable(server, db, table, vendor, options);
	if (!stat)
	{
		SutDestroyList(options);
	}

	va_end(ap);
	return stat;
}

#ifdef _NO_PROTO
char* SaMakeStateStrHtmlTable(tbl, kind)
pSaHtmlTable tbl;
int kind;
#else
char* SaMakeStateStrHtmlTable(pSaHtmlTable tbl, int kind)
#endif
{
	int i, size;
	char* colName;
	char* html = NULL;
	char* str = NULL;
	int len;

	if (!tbl)
		return SaMakeHtmlString("");

	size = SutSizList(tbl->columnNames);
	if (size <= 0)
		return SaMakeHtmlString("");

	len = 1;
	for(i=0; i<size; i++)
	{
		colName = (char*) SutGetNList(tbl->columnNames, i);
		switch(kind)
		{
			case SA_C:
			default:
				break;
			case SA_K:
				if ((int) SutGetNList(tbl->keys, i) == 0)
					continue;
				break;
			case SA_Q:
				if ((int) SutGetNList(tbl->quotes, i) == 1)
					continue;
				break;
		}
		len += strlen(colName) + 1;
	}

	if (len == 1)
		return SaMakeHtmlString("");

	str = (char*) malloc(len + 1);
	str[0] = '\0';
	for(i=0; i<size; i++)
	{
		colName = (char*) SutGetNList(tbl->columnNames, i);
		switch(kind)
		{
			case SA_C:
			default:
				break;
			case SA_K:
				if ((int) SutGetNList(tbl->keys, i) == 0)
					continue;
				break;
			case SA_Q:
				if ((int) SutGetNList(tbl->quotes, i) == 1)
					continue;
				break;
		}
		strcat(str, colName);
		strcat(str, ",");
	}

	len = strlen(str);
	if (str[len-1] == ',')
		str[len-1] = '\0';

	html = SaMakeHtmlString(str);
	free(str);

	return html;
}

#ifdef _NO_PROTO
char* SaFindHtmlTableComp(tbl, cbs)
pSaHtmlTable tbl;
SaCallbackStruct* cbs;
#else
char* SaFindHtmlTableComp(pSaHtmlTable tbl, SaCallbackStruct* cbs)
#endif
{
	char *buf;
	char *opVal;
	char* primeKeyValue;
	char* newPrimeKeyValue = NULL;
	char* primeKeyName;
	pSutList values;
	int i;
	int len;
	int size;
	int first_and = 0;
	int mod_flag = 0;
	int primeKey = 0;
	char* colName;

	if (!tbl)
		return NULL;

	len = 0;
	size = SutSizList(tbl->columnNames);
	if (size <= 0) return NULL;

	values = SutNewList();
	
	for (i=0; i<size; i++)
	{
		if ((int) SutGetNList(tbl->opFlags, i) == 0)
			continue;
		primeKeyName = (char*) SutGetNList(tbl->columnNames, i);
		if ((int) SutGetNList(tbl->quotes, i) == 1)
		{
			primeKeyValue = SaMakeEscapedString(SaGetInputValue(primeKeyName));
		}
		else
		{
			primeKeyValue = SaCopyDbString(SaGetInputValue(primeKeyName));
		}
		len += strlen(primeKeyValue);
		len += strlen((char*)SutGetNList(tbl->columnNames, i));
		/*** longest op ???? ***/
		len += 20;
		SutAddList(values, primeKeyValue);
	}
	buf = (char*) malloc(len + strlen(tbl->tble) + 20*size + 30);
	sprintf(buf, "where ");
	for (i=0; i<size; i++)
	{
		if ((int)SutGetNList(tbl->opFlags, i) == 0)
			continue;
		primeKeyName = (char*)SutGetNList(tbl->columnNames, i);
		colName = (char*) malloc(strlen(primeKeyName) + strlen("_OP") + 4);
		sprintf(colName, "%s_OP", primeKeyName);
		opVal = SaGetInputValue(colName);
		if ((!opVal) || (!*opVal) || ((strcmp(opVal, " ")==0)))
		{
			free(colName);
			continue;
		}
		primeKey++;
		if (first_and == 1)
			strcat(buf, " and ");
		strcat(buf, (char*)SutGetNList(tbl->columnNames, i));
		primeKeyValue = (char*) SutGetNList(values, i);
		if (strcmp(opVal, " ends ") == 0)
		{
			opVal = " like ";
			if (strcmp(primeKeyValue, "null") != 0)
			{
				newPrimeKeyValue = (char*) malloc(strlen(primeKeyValue) + 3);
				if ((int) SutGetNList(tbl->quotes, i) == 1)
				{
					sprintf(newPrimeKeyValue, "'%s%s", "%", &primeKeyValue[1]);
				}
				else
				{
					sprintf(newPrimeKeyValue, "%s%s", "%", &primeKeyValue[1]);
				}
				primeKeyValue = newPrimeKeyValue;
			}
		}
		else if (strcmp(opVal, " begins ") == 0)
		{
			opVal = " like ";
			if (strcmp(primeKeyValue, "null") != 0)
			{
				newPrimeKeyValue = (char*) malloc(strlen(primeKeyValue) + 3);
				if ((int) SutGetNList(tbl->quotes, i) == 1)
				{
					sprintf(newPrimeKeyValue, "%s", primeKeyValue);
					len = strlen(newPrimeKeyValue);
					newPrimeKeyValue[len-1] = '%';
					newPrimeKeyValue[len] = '\'';
					newPrimeKeyValue[len+1] = '\0';
				}
				else
				{
					sprintf(newPrimeKeyValue, "%s%s", primeKeyValue, "%");
				}
				primeKeyValue = newPrimeKeyValue;
			}
		}
		else if (strcmp(opVal, " contains ") == 0)
		{
			opVal = " like ";
			if (strcmp(primeKeyValue, "null") != 0)
			{
				newPrimeKeyValue = (char*) malloc(strlen(primeKeyValue) + 3);
				if ((int) SutGetNList(tbl->quotes, i) == 1)
				{
					sprintf(newPrimeKeyValue, "'%s%s", "%", &primeKeyValue[1]);
					len = strlen(newPrimeKeyValue);
					newPrimeKeyValue[len-1] = '%';
					newPrimeKeyValue[len] = '\'';
					newPrimeKeyValue[len+1] = '\0';
				}
				else
				{
					sprintf(newPrimeKeyValue, "%s%s%s", "%",
									&primeKeyValue[1], "%");
				}
				primeKeyValue = newPrimeKeyValue;
			}
		}
		strcat(buf, opVal);
		strcat(buf, primeKeyValue);
		first_and = 1;
		free(colName);
		if (newPrimeKeyValue)
		{
			free(newPrimeKeyValue);
			newPrimeKeyValue = NULL;
		}
	}
	primeKeyValue = NULL;
	
	if (primeKeyValue) free(primeKeyValue);
	SutDestroyList(values);
	/* fprintf(stdout, "%s" , buf); */
	if (!primeKey)
	{
		free(buf);
		return NULL;
	}
	return buf;
}

#ifdef _NO_PROTO
int SaInitFromStateHtmlTable(tbl, options)
pSaHtmlTable tbl;
pSutList options;
#else
int SaInitFromStateHtmlTable(pSaHtmlTable tbl, pSutList options)
#endif
{
	int i, j, size, size2;
	char* colName;
	char* colName2;
	pSutList valList;
	char* state_str;
	int colLen = 0;

	if (!tbl)
		return 1;

	state_str = SaGetInputValue("SA_TABLE_COLS");
	if ((!state_str) || (!*state_str))
		return 1;

	if ((SaGetInputValue("SA_TABLE_KEYS") == NULL) || 
					(SaGetInputValue("SA_TABLE_NOQU") == NULL))
		return 1;

	valList = SaParseFileString(state_str, ",", NULL);
	size = SutSizList(valList);
	if (size <= 0)
	{
		SutDestroyList(valList);
		return 1;
	}
	for (i=0; i<size; i++)
	{
		colName = (char*) SutGetNList(valList, i);
		if ((!colName) || (!*colName))
		{
			SutDestroyList(valList);
			return 1;
		}
		colLen = strlen(colName);
		if (colLen > tbl->colLen)
			tbl->colLen = colLen;
	}
	tbl->columnNames = valList;
	tbl->size = size;

	tbl->keys = SutNewList();
	tbl->quotes = SutNewList();
	tbl->updateColumnNumbers = SutNewList();
	tbl->autoColumnNumbers = SutNewList();
	tbl->textBoxes = SutNewList();
	tbl->opFlags = SutNewList();
	for (i=0; i<size; i++)
	{
		SutAddList(tbl->keys, (void*) 0);
		SutAddList(tbl->quotes, (void*) 1);
		SutAddList(tbl->updateColumnNumbers, (void*)1);
		SutAddList(tbl->autoColumnNumbers, (void*)0);
		SutAddList(tbl->textBoxes, (void*)0);
		SutAddList(tbl->opFlags, (void*)1);
	}

	state_str = SaGetInputValue("SA_TABLE_KEYS");
	valList = SaParseFileString(state_str, ",", NULL);
	size2 = SutSizList(valList);

	for (j=0; j<size2; j++)
	{
		colName2 = (char*) SutGetNList(valList, j);
		if(!colName2)
			continue;
		for (i=0; i<size; i++)
		{
			colName = (char*) SutGetNList(tbl->columnNames, i);
			if (strcmp(colName, colName2) == 0)
			{
				SutReplaceNList(tbl->keys, i, (void*)1);
				break;
			}
		}
	}
	SutDestroyList(valList);

	state_str = SaGetInputValue("SA_TABLE_NOQU");
	valList = SaParseFileString(state_str, ",", NULL);
	size2 = SutSizList(valList);

	for (j=0; j<size2; j++)
	{
		colName2 = (char*) SutGetNList(valList, j);
		if(!colName2)
			continue;
		for (i=0; i<size; i++)
		{
			colName = (char*) SutGetNList(tbl->columnNames, i);
			if (strcmp(colName, colName2) == 0)
			{
				SutReplaceNList(tbl->quotes, i, (void*)0);
				break;
			}
		}
	}
	SutDestroyList(valList);

	return 0;
}

#ifdef _NO_PROTO
int SaInitFromOptionsHtmlTable(tbl)
pSaHtmlTable tbl;
#else
int SaInitFromOptionsHtmlTable(pSaHtmlTable tbl)
#endif
{
	char* value;
	int val;
	pSutList valList;
	pSutList options;
	int i, size;
	int j, size2;
	int size3;
	char* colName;
	char* colName2;
	char* colName3;
	int found;
	pSutList subList;
	int k, opSize;

	if (!tbl)
		return 1;

	if (tbl->options == NULL)
		return 1;

	size = SutSizList(tbl->columnNames);

	options = tbl->options;

	value = SaGetOptionValue(options, HTML_TABLE_USE_PASS);
	if (value)
	{
		tbl->usePass = 1;
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_ECHO_PASS);
	if (value)
	{
		tbl->echoPass = 1;
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_HIDE_INSERT);
	if (value)
	{
		tbl->hideInsert = 1;
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_HIDE_DELETE);
	if (value)
	{
		tbl->hideDelete = 1;
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_HIDE_UPDATE);
	if (value)
	{
		tbl->hideUpdate = 1;
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_ESC_HREF);
	if (value)
	{
		if (tbl->escHref) free(tbl->escHref);
		tbl->escHref = value;
	}

	value = SaGetOptionValue(options, HTML_TABLE_WHERE_CLAUSE);
	if (value)
	{
		if (tbl->whereClaus) free(tbl->whereClaus);
		tbl->whereClaus = value;
	}

	value = SaGetOptionValue(options, HTML_TABLE_MAX_ROWS);
	if (value)
	{
		val = atoi(value);
		if (val < -1)
			val = -1;
		SaSetMaxRows(val);
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_UPDATE_TYPE);
	if (value)
	{
		val = atoi(value);
		if ((val <0) || (val>2))
			val = 0;
		tbl->whereType = val;
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_AUTO_KEY);
	if (value)
	{
		tbl->autoKey = 1;
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_UPDATE_COLS);
	if (value)
	{
		valList = SaParseFileString(value, ",", NULL);
		size2 = SutSizList(valList);
		for(i=0; i<size; i++)
		{
			colName = (char*) SutGetNList(tbl->columnNames, i);
			found = 0;
			for(j=0; j<size2; j++)
			{
				colName2 = (char*) SutGetNList(valList, j);
				if (!colName2)
					continue;
				if (strcmp(colName, colName2) == 0)
				{
					found = 1;
					break;
				}
			}
			if (found)
			{
				SutReplaceNList(tbl->updateColumnNumbers, i, (void*)1);
			}
			else
			{
				SutReplaceNList(tbl->updateColumnNumbers, i, (void*)0);
			}
		}
		SutDestroyList(valList);
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_AUTO_COLS);
	if (value)
	{
		valList = SaParseFileString(value, ",", NULL);
		size2 = SutSizList(valList);
		for(i=0; i<size; i++)
		{
			colName = (char*) SutGetNList(tbl->columnNames, i);
			found = 0;
			for(j=0; j<size2; j++)
			{
				colName2 = (char*) SutGetNList(valList, j);
				if (!colName2)
					continue;
				if (strcmp(colName, colName2) == 0)
				{
					found = 1;
					break;
				}
			}
			if (found)
			{
				SutReplaceNList(tbl->autoColumnNumbers, i, (void*)1);
			}
			else
			{
				SutReplaceNList(tbl->autoColumnNumbers, i, (void*)0);
			}
		}
		SutDestroyList(valList);
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_TEXTBOX_COLS);
	if (value)
	{
		valList = SaParseFileString(value, ",", NULL);
		size2 = SutSizList(valList);
		for(i=0; i<size; i++)
		{
			colName = (char*) SutGetNList(tbl->columnNames, i);
			found = 0;
			for(j=0; j<size2; j++)
			{
				colName2 = (char*) SutGetNList(valList, j);
				if (!colName2)
					continue;
				if (strcmp(colName, colName2) == 0)
				{
					found = 1;
					break;
				}
			}
			if (found)
			{
				SutReplaceNList(tbl->textBoxes, i, (void*)1);
			}
			else
			{
				SutReplaceNList(tbl->textBoxes, i, (void*)0);
			}
		}
		SutDestroyList(valList);
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_DISPLAY_COLS);
	if (value)
	{
		tbl->displayColumnNumbers = SutNewList();
		valList = SaParseFileString(value, ",", NULL);
		size2 = SutSizList(valList);
		for(j=0; j<size2; j++)
		{
			colName2 = (char*) SutGetNList(valList, j);
			if (!colName2)
				continue;
			found = 0;
			for(i=0; i<size; i++)
			{
				colName = (char*) SutGetNList(tbl->columnNames, i);
				if (strcmp(colName, colName2) == 0)
				{
					found = 1;
					break;
				}
			}
			if (found)
			{
				SutAddList(tbl->displayColumnNumbers, (void*)i);
			}
		}
		SutDestroyList(valList);
		free(value);
	}

	value = SaGetOptionValue(options, HTML_TABLE_SEARCH_OPS);
	if (value)
	{
		if (strcmp(value, "None") == 0)
		{
			for (i=0; i<size; i++)
			{
				SutReplaceNList(tbl->opFlags, i, (void*)0);
			}
		}
		else
		{
			for (i=0; i<size; i++)
			{
				SutReplaceNList(tbl->opFlags, i, (void*)0);
			}
			valList = SaParseFileString(value, ",", NULL);
			size2 = SutSizList(valList);
			for(j=0; j<size2; j++)
			{
				colName2 = (char*) SutGetNList(valList, j);
				if (!colName2)
					continue;
				subList = SaParseFileString(colName2, "=", NULL);
				size3 = SutSizList(subList);
				colName3 = (char*) SutGetNList(subList, 0);
				if (!colName2)
				{
					SutDestroyList(subList);
					continue;
				}
				found = 0;
				for(i=0; i<size; i++)
				{
					colName = (char*) SutGetNList(tbl->columnNames, i);
					if (strcmp(colName, colName3) == 0)
					{
						found = 1;
						break;
					}
				}
				if (size3 < 2)
				{
					if (found)
					{
						SutReplaceNList(tbl->opFlags, i, (void*)1);
					}
					SutDestroyList(subList);
						
				}
				else
				{
					if(found)
					{
						colName3 = (char*) SutGetNList(subList, 1);
						if (colName3)
						{
							if (strcmp(colName3, "num") == 0)
							{
								SutReplaceNList(tbl->opFlags, i, (void*)SA_N);
							}
							else if (strcmp(colName3, "str") == 0)
							{
								SutReplaceNList(tbl->opFlags, i, (void*)SA_S);
							}
							else
							{
								opSize = sizeof(default_ops)/
												sizeof(default_ops[0]);
								for (k=1; k<opSize; k++)
								{
									if (strcmp(colName3,default_ops_str[k])==0)
									{
										SutReplaceNList(tbl->opFlags, i,
														(void*)k);
										break;
									}
								}
							}
						}
					}
					SutDestroyList(subList);
				}
			}

			SutDestroyList(valList);
			free(value);
		}
	}

	return 0;
}

#ifdef _NO_PROTO
int SaWriteOptionsHtmlTableComp(tbl, colNum, opflag)
pSaHtmlTable tbl;
int colNum;
int opflag;
#else
int SaWriteOptionsHtmlTableComp(pSaHtmlTable tbl, int colNum, int opflag)
#endif
{
	int size;
	char* colName;
	char* opVal;
	char* opStr;
	int opSize, opStart;
	int i;
	char* colOpName;
	char* oldOpVal;
	int select_flag;

	if (!tbl)
		return 0;
	size = SutSizList(tbl->columnNames);
	if (size <=0)
		return 0;

	if ((colNum < 0) || (colNum>=size) || (opflag < 0))
		return 0;

	colName = (char*) SutGetNList(tbl->columnNames, colNum);
	fprintf(stdout, HTML_SEL_BEG, colName);
	colOpName = (char*) malloc(strlen(colName) + strlen("_OP") + 1);
	sprintf(colOpName, "%s_OP", colName);
	oldOpVal = SaGetInputValue(colOpName);

	opSize = sizeof(default_ops)/sizeof(default_ops[0]);
	opStart = 0;

	if (opflag == SA_N)
	{
		opStart = 5;
	}
	else if (opflag == SA_S)
	{
		opSize = 6;
	}
	for (i=opStart; i<opSize; i++)
	{
		select_flag = 0;
		if (opflag > 1)
		{
			if(opflag != i)
				continue;
		}
		opVal = SaMakeHtmlString(default_ops[i]);
		opStr = SaMakeHtmlString(default_ops_str[i]);
		if (oldOpVal)
		{
			if (strcmp(oldOpVal, default_ops[i]) == 0)
			{
				select_flag = 1;
			}
		}
		fprintf(stdout, HTML_OPT_EL, select_flag ? "SELECTED" : "",opVal,opStr);
		free(opVal);
		free(opStr);
	}
	fprintf(stdout, HTML_SEL_END);
	free(colOpName);

	return 1;
}

#ifdef _NO_PROTO
pSutList SaGetKeysList(erver, base, able, endor, size, columnNames)
char *erver;
char *base;
char *able;
int	endor;
int	size;
pSutList columnNames;
#else
pSutList SaGetKeysList(char* erver, char* base, char* able, int endor, int size,
									pSutList columnNames)
#endif
{
#define SY_KEYS "sp_helpkey '%s'"
	
#define INF_KEYS "select part1,part2,part3,part4,part5,part6,part7,part8 \
from sysindexes i, \
systables t,sysconstraints c where c.tabid = t.tabid and t.tabid = i.tabid and \
t.tabname='%s' and c.constrtype='P' and i.idxtype='U' and i.idxname = c.idxname"
	
#define INF_OKEYS "select part1,part2,part3,part4,part5,part6,part7,part8 \
from sysindexes i, \
systables t,sysconstraints c where c.tabid = t.tabid and t.tabid = i.tabid and \
t.tabname='%s' and c.constrtype='P' and i.idxtype='U' \
and i.idxname = c.idxname and t.owner = '%s'"
	
#define ORA_KEYS "select u.column_name from all_constraints c, \
all_cons_columns u where constraint_type = 'P' \
and c.table_name = UPPER('%s') and u.constraint_name = c.constraint_name"
	
#define ORA_OKEYS "select u.column_name from all_constraints c, \
all_cons_columns u where constraint_type = 'P' \
and c.table_name = UPPER('%s') and u.constraint_name = c.constraint_name \
and c.OWNER = UPPER('%s')"

	SaCallbackStruct *cbs;
	pSutList quoteList;
	int i;
	int j;
	char* buf;
	char *ptr;
	char *col;
	char *trlPtr;
	int key_flag;
	char* workTable;
	char* ownerName = NULL;
	
	cbs = NULL;
	key_flag = 0;
	
	if ((!erver) || (!base) || (!able) || (size<=0) || (!columnNames))
	{
		return NULL;
	}
	if (endor > SGEINFORMIX)
		return NULL;

	quoteList = SutNewList();
	for (i=0; i<size; i++)
	{
		SutAddList(quoteList, (void*)0);
	}

	switch(endor)
	{
		case SGESYBASE:
			buf = (char*) malloc(strlen(SY_KEYS) + strlen(able) + 10);
			sprintf(buf, SY_KEYS, able);
			break;
		case SGEINFORMIX:
			workTable = SaCopyString(able);
			ptr = workTable;
			while (*ptr != '\0')
			{
				if(*ptr == '.')
				{
					*ptr++ = '\0';
					ownerName = ptr;
					break;
				}
				ptr++;
			}
			if (ownerName == NULL)
			{
				buf = (char*) malloc(strlen(INF_KEYS) + strlen(able) + 10);
				sprintf(buf, INF_KEYS, able);
			}
			else
			{
				buf = (char*) malloc(strlen(INF_OKEYS) + strlen(able) + 10);
				sprintf(buf, INF_OKEYS, ownerName, workTable);
			}
			free(workTable);
			break;
		case SGEORACLE:
			workTable = SaCopyString(able);
			ptr = workTable;
			while (*ptr != '\0')
			{
				if(*ptr == '.')
				{
					*ptr++ = '\0';
					ownerName = ptr;
					break;
				}
				ptr++;
			}
			if (ownerName == NULL)
			{
				buf = (char*) malloc(strlen(ORA_KEYS) + strlen(able) + 10);
				sprintf(buf, ORA_KEYS, able);
			}
			else
			{
				buf = (char*) malloc(strlen(ORA_OKEYS) + strlen(able) + 10);
				sprintf(buf, ORA_OKEYS, ownerName, workTable);
			}
			free(workTable);
			break;
	}
	cbs = SaExecSQL(erver, base, endor, buf);
	switch(endor)
	{
		case SGESYBASE:
			if((cbs == NULL) || (cbs->nGroups != 1) || (cbs->groups[0].nCols
				!= 5) || (cbs->groups[0].nRows <= 0))
			{
				free(buf);
				SaFreeCbs(cbs);
				return quoteList;
			}
			for (i=0; i<cbs->groups[0].nRows; i++)
			{
				ptr = cbs->groups[0].data[0][i];
				if (ptr == NULL)
					continue;
				if (strcmp(ptr, "primary") == 0)
				{
					ptr = cbs->groups[0].data[3][i];
					if (ptr != NULL) key_flag = 1;
					break;
				}
			}
			if (key_flag != 1)
			{
				free(buf);
				SaFreeCbs(cbs);
				return quoteList;
			}
			col = strtok(ptr, ", ");
			while (col != NULL)
			{
				if (strcmp(col, "*") == 0)
					break;
				for (j=0; j<size; j++)
				{
					trlPtr = (char*) SutGetNList(columnNames, j);
					if (strcmp(col, trlPtr) == 0)
					{
							SutReplaceNList(quoteList, j, (void*)1);
							continue;
					}
				}
				col = strtok(NULL, ", ");
			}
			break;
		case SGEORACLE:
			if((cbs == NULL) || (cbs->nGroups != 1) || (cbs->groups[0].nCols
				!= 1) || (cbs->groups[0].nRows <= 0))
			{
				free(buf);
				SaFreeCbs(cbs);
				return quoteList;
			}
			for (i=0; i<cbs->groups[0].nRows; i++)
			{
				ptr = cbs->groups[0].data[0][i];
				if (ptr == NULL)
					continue;
				for (j=0; j<size; j++)
				{
					trlPtr = (char*) SutGetNList(columnNames, j);
					if (strcmp(ptr, trlPtr) == 0)
					{
							SutReplaceNList(quoteList, j, (void*)1);
							continue;
					}
				}
			}
			break;
		case SGEINFORMIX:
			if((cbs == NULL) || (cbs->nGroups != 1) || (cbs->groups[0].nCols
				!= 8) || (cbs->groups[0].nRows != 1))
			{
				free(buf);
				SaFreeCbs(cbs);
				return quoteList;
			}
			for (i=0; i<cbs->groups[0].nCols; i++)
			{
				ptr = cbs->groups[0].data[i][0];
				if (ptr == NULL)
					continue;
				j = atoi(ptr);
				if (j==0)
					continue;
				if (j<=size)
				{
					SutReplaceNList(quoteList, j-1, (void*)1);
					continue;
				}
			}
			break;
	}
	free(buf);
	SaFreeCbs(cbs);
	return quoteList;
}

#ifdef _NO_PROTO
pSutList SaGetQuoteList(erver, base, able, endor, size)
char* erver;
char* base;
char* able;
int	endor;
int	size;
#else
pSutList SaGetQuoteList(char* erver, char* base, char* able, int endor,
								int size)
#endif
{
#define SY_QUOTES "select colid, c.type from sysobjects o, syscolumns c where o.id = c.id and o.id = object_id('%s') order by colid"
		
		SaCallbackStruct *cbs;
		pSutList quoteList;
		int i;
		char* buf;
		char *ptr;
		int type_no;
	
		cbs = NULL;
	
		if ((!erver) || (!base) || (!able) || (size<=0))
		{
			return NULL;
		}
		quoteList = SutNewList();
		for (i=0; i<size; i++)
		{
			SutAddList(quoteList, (void*)1);
		}
		/**** all datatypes can be quoted in INFORMIX and ORACLE ****/
		if ((endor == SGEORACLE) || (endor == SGEINFORMIX))
		{
			return quoteList;
		}
	
		buf = (char*) malloc(strlen(SY_QUOTES) + strlen(able) + 10);
		sprintf(buf, SY_QUOTES, able);
		cbs = SaExecSQL(erver, base, endor, buf);
		
		for (i=0; i<size; i++)
		{
			if(cbs == NULL)
				break;
			if(cbs->nGroups != 1)
				break;
			if(cbs->groups[0].nCols != 2)
				break;
			if(cbs->groups[0].nRows != size)
				break;
			ptr = cbs->groups[0].data[1][i];
			if (ptr == NULL)
				break;
			type_no = atoi(ptr);
			switch(type_no)
			{
				case 37:
				case 38:
				case 42:
				case 48:
				case 50:
				case 52:
				case 55:
				case 56:
				case 59:
				case 60:
				case 62:
				case 63:
				case 106:
				case 108:
				case 109:
				case 110:
				case 122:
					SutReplaceNList(quoteList, i, (void*)0);
					break;
				default:
					break;
			}
		}
		free(buf);
		SaFreeCbs(cbs);
		return quoteList;
}

#ifdef _NO_PROTO
SaCallbackStruct* SaSearchHtmlTableComp(tbl, cbs, whereClaus)
pSaHtmlTable tbl;
SaCallbackStruct* cbs;
char* whereClaus;
#else
SaCallbackStruct* SaSearchHtmlTableComp(pSaHtmlTable tbl, SaCallbackStruct* cbs,
	char* whereClaus)
#endif
{
	SaCallbackStruct *rcbs;
	char *buf;
	int i;
	int colLen = 0;
	char* colName;
	char* bigWhere = NULL;

	if (!tbl)
		return NULL;

	if ((!whereClaus) || (!*whereClaus))
	{
		if(tbl->whereClaus)
		{
			whereClaus = tbl->whereClaus;
		}
		else
		{
			whereClaus = "";
		}
	}
	else
	{
		if(tbl->whereClaus)
		{
#ifndef _WINDOWS
			if(strncasecmp(tbl->whereClaus, "where", strlen("where")) == 0)
#else
			if(_strnicmp(tbl->whereClaus, "where", strlen("where")) == 0)
#endif
			{
				bigWhere = SaStrMCat(whereClaus, " and ",
							(tbl->whereClaus)+5, NULL);
			}
			else
			{
				bigWhere = SaStrMCat(whereClaus, " ", tbl->whereClaus, NULL);
			}
			whereClaus = bigWhere;
		}
	}

	buf = (char*) malloc(strlen(tbl->tble) + strlen(whereClaus) +
						strlen("select * from ") + 10);
	sprintf(buf, "select * from %s %s", tbl->tble, whereClaus);
	if(bigWhere) free(bigWhere);

	rcbs = SaExecSQL(tbl->serv, tbl->DB, tbl->vend, buf);

	if (rcbs == NULL)
	{
		free(buf);
		return NULL;
	}

	if (tbl->columnNames == NULL)
	{
		tbl->size = rcbs->groups[0].nCols;
		tbl->columnNames = SutNewList();
		tbl->updateColumnNumbers = SutNewList();
		tbl->autoColumnNumbers = SutNewList();
		tbl->textBoxes = SutNewList();
		tbl->opFlags = SutNewList();
		for (i=0; i<tbl->size; i++)
		{
			colName = SaCopyString(rcbs->groups[0].columnTitles[i]);
			SutAddList(tbl->columnNames, colName);
			colLen = strlen(colName);
			if (colLen > tbl->colLen)
				tbl->colLen = colLen;
			SutAddList(tbl->updateColumnNumbers, (void*)1);
			SutAddList(tbl->autoColumnNumbers, (void*)0);
			SutAddList(tbl->textBoxes, (void*)0);
			SutAddList(tbl->opFlags, (void*)1);
		}
	}

	if (tbl->keys == NULL)
	{
		tbl->keys = SaGetKeysList(tbl->serv, tbl->DB, tbl->tble, tbl->vend,
							tbl->size, tbl->columnNames);
	}
	if (tbl->quotes == NULL)
	{
		tbl->quotes = SaGetQuoteList(tbl->serv, tbl->DB, tbl->tble, tbl->vend,
							tbl->size);
	}
	free(buf);
	return rcbs;
}

#ifdef _NO_PROTO
SaCallbackStruct* SaSelectHtmlTableComp(tbl, cbs)
pSaHtmlTable tbl;
SaCallbackStruct* cbs;
#else
SaCallbackStruct* SaSelectHtmlTableComp(pSaHtmlTable tbl, SaCallbackStruct* cbs)
#endif
{
	char *buf;
	char* primeKeyValue;
	char* primeKeyName;
	pSutList values;
	int i;
	int len;
	int size;
	int first_and = 0;
	int mod_flag = 0;
	int primeKey = 0;
	int keyValue;
	SaCallbackStruct* rcbs;

	if (!tbl)
		return NULL;

	len = 0;
	size = SutSizList(tbl->columnNames);
	if (size <= 0) return NULL;

	values = SutNewList();
	
	for (i=0; i<size; i++)
	{
		keyValue = (int) SutGetNList(tbl->keys, i);
		if (keyValue)
			primeKey++;
	}
	
	if (primeKey == 0)
	{
		primeKeyName = (char*) SutGetNList(tbl->columnNames, primeKey);
		if ((int) SutGetNList(tbl->quotes, primeKey) == 1)
		{
			primeKeyValue = SaMakeEscapedString(SaGetNArg(primeKey));
		}
		else
		{
			primeKeyValue = SaCopyDbString(SaGetNArg(primeKey));
		}
		buf = (char*) malloc(strlen(primeKeyValue) + strlen(tbl->tble) +
			strlen(primeKeyName) + 30);
		sprintf(buf, "select * from %s where %s = %s", tbl, primeKeyName,
					primeKeyValue);
	}
	else
	{
		primeKey = 0;
		for (i=0; i<size; i++)
		{
			if ((int) SutGetNList(tbl->keys, i) == 0)
				continue;
			primeKeyName = (char*) SutGetNList(tbl->columnNames, i);
			if ((int) SutGetNList(tbl->quotes, i) == 1)
			{
				primeKeyValue = SaMakeEscapedString(SaGetNArg(primeKey));
			}
			else
			{
				primeKeyValue = SaCopyDbString(SaGetNArg(primeKey));
			}
			primeKey++;
			len += strlen(primeKeyValue);
			len += strlen((char*)SutGetNList(tbl->columnNames, i));
			SutAddList(values, primeKeyValue);
		}
		buf = (char*) malloc(len + strlen(tbl->tble) + 20*size + 30);
		sprintf(buf, "select * from %s where ", tbl->tble);
		primeKey = 0;
		for (i=0; i<size; i++)
		{
			if ((int)SutGetNList(tbl->keys, i) == 0)
				continue;
			if (first_and == 1)
				strcat(buf, " and ");
			strcat(buf, (char*)SutGetNList(tbl->columnNames, i));
			strcat(buf, " = ");
			primeKeyValue = (char*) SutGetNList(values, primeKey);
			strcat(buf, primeKeyValue);
			primeKey++;
			first_and = 1;
		}
		primeKeyValue = NULL;
	}
	rcbs = SaExecSQL(tbl->serv, tbl->DB, tbl->vend, buf);
	free(buf);
	if (primeKeyValue) free(primeKeyValue);
	SutDestroyList(values);
	return rcbs;
}

#ifdef _NO_PROTO
int SaUpdateHtmlTableComp(tbl, cbs)
pSaHtmlTable tbl;
SaCallbackStruct* cbs;
#else
int SaUpdateHtmlTableComp(pSaHtmlTable tbl, SaCallbackStruct* cbs)
#endif
{
	char *buf = NULL;
	char* primeKeyValue;
	pSutList values;
	pSutList olderData;
	int i;
	int len;
	int size;
	int first_and = 0;
	int mod_flag = 0;
	char* previousValue;
	int primeKey = 0;
	int keyValue;
	char* colName;
	SaCallbackStruct* rcbs;
	char* oldColName;
	
	if (!tbl)
		return 0;
	
	len = 0;
	size = SutSizList(tbl->columnNames);
	if (size <= 0) return 0;
	
	/* if (SaTableComp_CheckUpdateableChanges(SaTableComp, &UxEnv) == 0)
	{
	} */

	values = SutNewList();
	olderData = SutNewList();
	
	for (i=0; i<size; i++)
	{
		colName = (char*)SutGetNList(tbl->columnNames, i);
		if ((int) SutGetNList(tbl->quotes, i) == 1)
		{
			primeKeyValue = SaMakeEscapedString(SaGetInputValue(colName));
		}
		else
		{
			primeKeyValue = SaCopyDbString(SaGetInputValue(colName));
		}
		len += strlen(primeKeyValue);
		len += strlen((char*)SutGetNList(tbl->columnNames, i));
		SutAddList(values, primeKeyValue);
		oldColName = (char*) malloc(strlen(colName) + strlen("_OLD") + 3);
		sprintf(oldColName, "%s_OLD", colName);
		if ((int) SutGetNList(tbl->quotes, i) == 1)
		{
			primeKeyValue = SaMakeEscapedString(SaGetInputValue(oldColName));
		}
		else
		{
			primeKeyValue = SaCopyDbString(SaGetInputValue(oldColName));
		}
		len += strlen(primeKeyValue);
		SutAddList(olderData, primeKeyValue);
		free(oldColName);
	}
	buf = (char*) malloc(2*len + strlen(tbl->tble) + 20*size + 30);
	sprintf(buf, "update %s set ", tbl->tble);
	
	for (i=0; i<size; i++)
	{
		keyValue = (int) SutGetNList(tbl->keys, i);
		if (keyValue)
			primeKey++;
		if ((int) SutGetNList(tbl->updateColumnNumbers, i) == 1)
			continue;
		primeKeyValue = (char*) SutGetNList(values, i);
		previousValue = (char*) SutGetNList(olderData, i);
		if (strcmp(primeKeyValue, previousValue) != 0)
		{
			free(buf);
			SutDestroyList(values);
			SutDestroyList(olderData);
	    	SaAppendTheConsoleText("Warning: You cannot update a non-updateable column.\n");
	    	SaDisplayTheConsole();
			return 0;
		}
	}
	
	if (primeKey == 0)
	{
		/*** only prime key ****/
		for (i=0; i<size; i++)
		{
			if (i == primeKey)
				continue;
			primeKeyValue = (char*) SutGetNList(values, i);
			strcat(buf, (char*)SutGetNList(tbl->columnNames, i));
			strcat(buf, " = ");
			strcat(buf, primeKeyValue);
			if (i<size-1)
				strcat(buf, ", ");
		}
		strcat(buf, " where ");
		strcat(buf, (char*)SutGetNList(tbl->columnNames, primeKey));
		strcat(buf, " = ");
		strcat(buf, (char*)SutGetNList(values, primeKey));
	}
	else
	{
		for (i=0; i<size; i++)
		{
			if ((int)SutGetNList(tbl->keys, i) == 1)
				continue;
			primeKeyValue = (char*) SutGetNList(values, i);
			previousValue = (char*) SutGetNList(olderData, i);
			if (strcmp(primeKeyValue, previousValue) == 0)
				continue;
			mod_flag = 1;
			strcat(buf, (char*)SutGetNList(tbl->columnNames, i));
			strcat(buf, " = ");
			strcat(buf, primeKeyValue);
			strcat(buf, ", ");
		}
		if (mod_flag == 0)
		{
			free(buf);
			SutDestroyList(values);
			SutDestroyList(olderData);
			SaAppendTheConsoleText("Warning : No data modified.\n");
			SaDisplayTheConsole();
			return 0;
		}
		buf[strlen(buf)-2] = '\0';
		strcat(buf, " where ");
		for (i=0; i<size; i++)
		{
			switch (tbl->whereType)
			{
				/*** only prime keys ***/
				case 0:
					if ((int)SutGetNList(tbl->keys, i) == 0)
						continue;
					break;
				case 1:
				/*** only prime keys and modified ***/
					if ((int)SutGetNList(tbl->keys, i) == 0)
					{
						if (strcmp((char*) SutGetNList(olderData,i),
									(char*) SutGetNList(values, i)) == 0)
							continue;
					}
					break;
				case 2:
				/*** only prime keys and modifiable ***/
					if ((int)SutGetNList(tbl->keys, i) == 0)
						if ((int)SutGetNList(tbl->updateColumnNumbers, i) == 0)
							continue;
					break;
			}
			if (first_and == 1)
				strcat(buf, " and ");
			strcat(buf, (char*)SutGetNList(tbl->columnNames, i));
			strcat(buf, " = ");
			primeKeyValue = (char*) SutGetNList(olderData, i);
			strcat(buf, primeKeyValue);
			first_and = 1;
		}
	}
	
	rcbs = SaExecSQL(tbl->serv, tbl->DB, tbl->vend, buf);
	free(buf);
	SaFreeCbs(rcbs);
	SutDestroyList(values);
	SutDestroyList(olderData);
	if (SaGetAffectedRowCount() < 1)
	{
	    SaAppendTheConsoleText(SaCatGets(3, 25, "Warning: no rows updated.\n"));
	    SaDisplayTheConsole();
	}
	return 1;
}

#ifdef _NO_PROTO
int SaDeleteHtmlTableComp(tbl, cbs)
pSaHtmlTable tbl;
SaCallbackStruct* cbs;
#else
int SaDeleteHtmlTableComp(pSaHtmlTable tbl, SaCallbackStruct* cbs)
#endif
{
	char *buf;
	char* primeKeyName;
	char* primeKeyValue;
	int i;
	int first_and = 0;
	int size;
	int len;
	pSutList values;
	int primeKey = 0;
	int keyValue;
	SaCallbackStruct* rcbs;
	
	if (!tbl)
		return 0;
	
	len = 0;
	size = SutSizList(tbl->columnNames);
	if (size <= 0) return 0;
	
	values = SutNewList();
	
	for (i=0; i<size; i++)
	{
		keyValue = (int) SutGetNList(tbl->keys, i);
		if (keyValue)
			primeKey++;
	}
	
	if (primeKey == 0)
	{
		primeKeyName = (char*) SutGetNList(tbl->columnNames, primeKey);
		if ((int) SutGetNList(tbl->quotes, primeKey) == 1)
		{
			primeKeyValue = SaMakeEscapedString(SaGetInputValue(primeKeyName));
		}
		else
		{
			primeKeyValue = SaCopyDbString(SaGetInputValue(primeKeyName));
		}
		buf = (char*) malloc(strlen(primeKeyValue) + strlen(tbl->tble) +
			strlen(primeKeyName) + 30);
		sprintf(buf, "delete from %s where %s = %s", tbl, primeKeyName,
					primeKeyValue);
	}
	else
	{
		for (i=0; i<size; i++)
		{
			if ((int) SutGetNList(tbl->keys, i) == 0)
				continue;
			primeKeyName = (char*) SutGetNList(tbl->columnNames, i);
			if ((int) SutGetNList(tbl->quotes, i) == 1)
			{
				primeKeyValue = SaMakeEscapedString(SaGetInputValue(primeKeyName));
			}
			else
			{
				primeKeyValue = SaCopyDbString(SaGetInputValue(primeKeyName));
			}
			len += strlen(primeKeyValue);
			len += strlen((char*)SutGetNList(tbl->columnNames, i));
			SutAddList(values, primeKeyValue);
		}
		buf = (char*) malloc(len + strlen(tbl->tble) + 20*size + 30);
		sprintf(buf, "delete from %s where ", tbl->tble);
		primeKey = 0;
		for (i=0; i<size; i++)
		{
			if ((int)SutGetNList(tbl->keys, i) == 0)
				continue;
			if (first_and == 1)
				strcat(buf, " and ");
			strcat(buf, (char*)SutGetNList(tbl->columnNames, i));
			strcat(buf, " = ");
			primeKeyValue = (char*) SutGetNList(values, primeKey);
			strcat(buf, primeKeyValue);
			first_and = 1;
			primeKey++;
		}
		primeKeyValue = NULL;
	}
	rcbs = SaExecSQL(tbl->serv, tbl->DB, tbl->vend, buf);
	free(buf);
	SaFreeCbs(rcbs);
	if (primeKeyValue) free(primeKeyValue);
	SutDestroyList(values);
	if (SaGetAffectedRowCount() < 1)
	{
		SaAppendTheConsoleText("Warning : No data deleted.\n");
		SaDisplayTheConsole();
	}
	return 1;
}

#ifdef _NO_PROTO
int SaInsertHtmlTableComp(tbl, cbs)
pSaHtmlTable tbl;
SaCallbackStruct* cbs;
#else
int SaInsertHtmlTableComp(pSaHtmlTable tbl, SaCallbackStruct* cbs)
#endif
{
	char *buf;
	char* primeKeyValue;
	pSutList values;
	int i;
	int len;
	int size;
	char* colName;
	SaCallbackStruct* rcbs;

	if (!tbl)
		return 0;
	
	len = 0;
	size = SutSizList(tbl->columnNames);
	if (size <= 0) return 0;
	
	values = SutNewList();
	for (i=0; i<size; i++)
	{
		colName = (char*) SutGetNList(tbl->columnNames, i);
		if ((int)SutGetNList(tbl->quotes, i) == 1)
		{
			primeKeyValue = SaMakeEscapedString(SaGetInputValue(colName));
		}
		else
		{
			primeKeyValue = SaCopyDbString(SaGetInputValue(colName));
		}
		len += strlen(primeKeyValue);
		SutAddList(values, primeKeyValue);
	}
	buf = (char*) malloc(len + strlen(tbl->tble) + 4*size + 30);
	sprintf(buf, "insert into %s values(", tbl->tble);
	
	for (i=0; i<size; i++)
	{
		if (tbl->autoKey)
		{
			if ((int) SutGetNList(tbl->keys, i) == 1)
			{
				if (i==size-1)
				{
					if(buf[strlen(buf) - 2] == ',')
						buf[strlen(buf) - 2] = '\0';
				}
				continue;
			}
		}
		else
		{
			if ((int) SutGetNList(tbl->autoColumnNumbers, i) == 1)
			{
				if (i==size-1)
				{
					if(buf[strlen(buf) - 2] == ',')
						buf[strlen(buf) - 2] = '\0';
				}
				continue;
			}
		}
		primeKeyValue = (char*) SutGetNList(values, i);
		strcat(buf, primeKeyValue);
		if (i<size-1)
			strcat(buf, ", ");
	}
	strcat(buf, ")");
	
	rcbs = SaExecSQL(tbl->serv, tbl->DB, tbl->vend, buf);
	if (SaGetAffectedRowCount() < 1)
	{
		SaAppendTheConsoleText(" Warning : No data inserted.\n");
		SaDisplayTheConsole();
	}
	SaFreeCbs(rcbs);
	free(buf);
	SutDestroyList(values);
	return 1;
}

#ifdef _NO_PROTO
int SaPopulateHtmlTableComp(tbl, icbs)
pSaHtmlTable tbl;
SaCallbackStruct* icbs;
#else
int SaPopulateHtmlTableComp(pSaHtmlTable tbl, SaCallbackStruct* icbs)
#endif
{
	int i;
	char* html1;
	char* html2;
	char* colName;
	int colLen;
	int colSize;
	pSutList colList;
	int numPrimes = 0;
	int flag;
	int opflag;
	char* server_port;
	char* server_name;
	char* script_name;
	char* act_name;
	char* href;
	char* current_value;
	char* user;
	char* pass;
	char* state_str;
	int anch_flag = 0;
	SaCallbackStruct* rcbs = NULL;
	SaCallbackStruct* acbs = NULL;
	SaCallbackStruct* cbs = NULL;
	char* anch_string;
	char* whereClaus;
	char* argStr;
	pSutList list, oldList;

	if (!tbl)
		return 0;

	server_port = getenv("SERVER_PORT");
	server_name = getenv("SERVER_NAME");
	script_name = getenv("SCRIPT_NAME");
	act_name = SaGetActivator();

	if((!server_port) || (!server_name) || (!script_name) || (!act_name))
	{
		href = SaCopyString("hello");
	}
	else
	{
		href = (char*) malloc(strlen("http://") + strlen(server_name) +
					strlen(script_name) + strlen(server_port) + 5);
		sprintf(href, "http://%s:%s%s", server_name, server_port, script_name);
	}

	if (SaIsSubmitName("Insert"))
	{
		if(!tbl->hideInsert)
		{
			SaInsertHtmlTableComp(tbl, cbs);
			cbs = SaSearchHtmlTableComp(tbl, NULL, "");
		}
		else
		{
			/*** insert disabled, do seacrh instead ***/
			whereClaus = SaFindHtmlTableComp(tbl, cbs);
			cbs = SaSearchHtmlTableComp(tbl, NULL, whereClaus ? whereClaus :"");
			if(whereClaus) free(whereClaus);
		}
	}
	else if (SaIsSubmitName("Update"))
	{
		if(!tbl->hideUpdate)
		{
			SaUpdateHtmlTableComp(tbl, cbs);
			cbs = SaSearchHtmlTableComp(tbl, NULL, "");
		}
		else
		{
			/*** update disabled, do seacrh instead ***/
			whereClaus = SaFindHtmlTableComp(tbl, cbs);
			cbs = SaSearchHtmlTableComp(tbl, NULL, whereClaus ? whereClaus :"");
			if(whereClaus) free(whereClaus);
		}
	}
	else if (SaIsSubmitName("Delete"))
	{
		if(!tbl->hideDelete)
		{
			SaDeleteHtmlTableComp(tbl, cbs);
			cbs = SaSearchHtmlTableComp(tbl, NULL, "");
		}
		else
		{
			/*** delete disabled, do seacrh instead ***/
			whereClaus = SaFindHtmlTableComp(tbl, cbs);
			cbs = SaSearchHtmlTableComp(tbl, NULL, whereClaus ? whereClaus :"");
			if(whereClaus) free(whereClaus);
		}
	}
	else if (SaIsSubmitName("Search"))
	{
		whereClaus = SaFindHtmlTableComp(tbl, cbs);
		cbs = SaSearchHtmlTableComp(tbl, NULL, whereClaus ? whereClaus :"");
		if(whereClaus) free(whereClaus);
	}
	else
	{
		/** must be anchor **/
		cbs = SaSearchHtmlTableComp(tbl, NULL, "");
		if (SaGetNArg(0) != NULL)
			anch_flag = 1;
	}

	if(tbl->frags)
	{
		fprintf(stdout, "%s", (char*) SutGetNList(tbl->frags, 0));
	}
	else
	{
		fprintf(stdout, "%s", HTML_BEGIN);
		fprintf(stdout, "%s", tbl->tble);
		fprintf(stdout, "%s", HTML_BODY);
	}
	fprintf(stdout, HTML_FOR, href);

	if (tbl->usePass)
	{
		user = SaGetInputValue("SaUserName");
		pass = SaGetInputValue("SaPassWord");
		if ((!pass) || (!user) || (!*user))
		{
			;
		}
		else
		{
			SaSetUseDefaultFlag();
			SaSetDefaultUser(user);
			SaSetDefaultPass(pass);
		}
		html1 = SaMakeHtmlString(user);
		html2 = SaMakeHtmlString(pass);
		fprintf(stdout, "<HR>\n");
		fprintf(stdout, HTML_USER, html1);
		fprintf(stdout, "        ");
		if (tbl->echoPass)
		{
			fprintf(stdout, HTML_PASS, html2);
		}
		else
		{
			fprintf(stdout, HTML_PASS, "" );
		}
		fprintf(stdout, "\n<HR>\n");
		free(html1);
		free(html2);
	}

	if (anch_flag)
	{
		rcbs = SaSelectHtmlTableComp(tbl, cbs);
		if ((rcbs == NULL) || (rcbs->nGroups != 1) || (rcbs->groups[0].nCols 
				!= tbl->size) || (rcbs->groups[0].nRows <= 0))
		{
			anch_flag = 0;
			SaFreeCbs(rcbs);
			rcbs = NULL;
		}
	}

	colList = SutNewList();

	for (i=0; i<tbl->size; i++)
	{
		colName = (char*) SutGetNList(tbl->columnNames, i);
		colLen = strlen(colName);
		colSize = cbs->groups[0].colWidth[i];
		if (colSize < 10)
			colSize = 10;
		html1 = SaMakeHtmlString(colName);
		if (anch_flag)
		{
			current_value = rcbs->groups[0].data[i][0];
		}
		else
		{
			current_value = SaGetInputValue(colName);
		}
		html2 = SaMakeHtmlString(current_value);
		fprintf(stdout, HTML_IBOX_LAB, colName);
		opflag = (int) SutGetNList(tbl->opFlags, i);
		if (opflag)
		{
			SaWriteOptionsHtmlTableComp(tbl, i, opflag);
		}
		opflag = (int) SutGetNList(tbl->textBoxes, i);
		if (opflag)
		{
			fprintf(stdout, HTML_MTBOX, colName, html2);
		}
		else
		{
			fprintf(stdout, HTML_IBOX, colName, html2, colSize);
		}
		fprintf(stdout, HTML_HBOX, colName, html2);
		free(html2);
		free(html1);
		flag = (int) SutGetNList(tbl->keys, i);
		if (flag)
		{
			numPrimes++;
			SutAddList(colList, (void*) i);
		}
	}

	if (tbl->displayColumnNumbers == NULL)
	{
		for (i=0; i<tbl->size; i++)
		{
			flag = (int) SutGetNList(tbl->keys, i);
			if (!flag)
				SutAddList(colList, (void*)i);
		}
	}
	else
	{
		for (i=0; i<SutSizList(tbl->displayColumnNumbers); i++)
		{
			flag = (int) SutGetNList(tbl->displayColumnNumbers, i);
			SutAddList(colList, (void*)flag);
		}
	}

	state_str = SaMakeStateStrHtmlTable(tbl, SA_C);
	fprintf(stdout, HTML_CBOX, state_str);
	if(state_str) free(state_str);
	state_str = SaMakeStateStrHtmlTable(tbl, SA_K);
	fprintf(stdout, HTML_KBOX, state_str);
	if(state_str) free(state_str);
	state_str = SaMakeStateStrHtmlTable(tbl, SA_Q);
	fprintf(stdout, HTML_QBOX, state_str);
	if(state_str) free(state_str);

	fprintf(stdout, HTML_TBOX, tbl->tble);

	if(!tbl->hideInsert)
		fprintf(stdout, "%s", HTML_ADDB);
	if(!tbl->hideDelete)
		fprintf(stdout, "%s", HTML_DELB);
	if(!tbl->hideUpdate)
		fprintf(stdout, "%s", HTML_UPDB);
	fprintf(stdout, "%s", HTML_FINB);
	fprintf(stdout, "%s", HTML_RESET);
	fprintf(stdout, HTML_HID, act_name);
	fprintf(stdout, "%s", HTML_FOR_E);

	if(tbl->frags)
	{
		fprintf(stdout, "%s", (char*) SutGetNList(tbl->frags, 1));
	}

	acbs = SaMakeCbsColList(cbs, colList);
	if (acbs)
	{
		anch_string = (char*) malloc(strlen(HTML_ANCH_S) +
					strlen(href) + strlen(act_name) + 10);
		sprintf(anch_string, HTML_ANCH_S, href, act_name);
		SaSetCurrentPtr(anch_string);
		argStr = SaStrMCat(ANCH_MORE, SA_OPTIONS_SEP, ANCH_ARG_SEP,
					HTML_TABLE_ARG, tbl->tble, NULL);
		oldList = acbs->groups[0].options;
		list = SutNewList();
		acbs->groups[0].options = list;
		SutAddList(list, argStr);
		SaPopulateHotList(NULL, (XtPointer)numPrimes, acbs);
		acbs->groups[0].options = oldList;
		SaFreeCbs(acbs);
		SutDestroyList(list);
		free(anch_string);
	}

	if (tbl->escHref)
	{
		fprintf(stdout, HTML_ESC, tbl->escHref);
	}
	{
		fprintf(stdout, HTML_ESC, href);
	}

	if(tbl->frags)
	{
		fprintf(stdout, "%s", (char*) SutGetNList(tbl->frags, 2));
	}
	else
	{
		fprintf(stdout, "%s", HTML_END);
	}

	SutDeleteList(colList);
	free(href);
	if (rcbs) SaFreeCbs(rcbs);
	if (cbs)  SaFreeCbs(cbs);

	return 1;
}

#ifdef _NO_PROTO
int SaFreeHtmlTable(tbl)
pSaHtmlTable tbl;
#else
int SaFreeHtmlTable(pSaHtmlTable tbl)
#endif
{
	if (!tbl)
		return 0;

	if(tbl->DB) free(tbl->DB);
	if(tbl->serv) free(tbl->serv);
	if(tbl->tble) free(tbl->tble);
	if(tbl->whereClaus) free(tbl->whereClaus);
	if(tbl->keys) SutDeleteList(tbl->keys);
	if(tbl->quotes) SutDeleteList(tbl->quotes);
	if(tbl->opFlags) SutDeleteList(tbl->opFlags);
	if(tbl->columnNames) SutDestroyList(tbl->columnNames);
	if(tbl->displayColumnNumbers) SutDeleteList(tbl->displayColumnNumbers);
	if(tbl->updateColumnNumbers) SutDeleteList(tbl->updateColumnNumbers);
	if(tbl->autoColumnNumbers) SutDeleteList(tbl->autoColumnNumbers);
	if(tbl->textBoxes) SutDeleteList(tbl->textBoxes);
	if(tbl->options) SutDestroyList(tbl->options);
	if(tbl->frags) SutDestroyList(tbl->frags);
	if(tbl->escHref) free(tbl->escHref);

	free(tbl);
}

#ifdef _NO_PROTO
pSaHtmlTable SaMakeHtmlTable(server, db, table, vendor)
char *server;
char* db;
char* table;
int vendor;
#else
pSaHtmlTable SaMakeHtmlTable(char *server, char* db, char* table, int vendor)
#endif
{
	SaHtmlTable *tbl;

	if ((!table) || (!*table))
		return NULL;

	tbl = (SaHtmlTable*) calloc(1, sizeof(SaHtmlTable));

	tbl->DB = SaCopyString(db);
	tbl->tble = SaCopyString(table);
	tbl->vend = vendor;

	if (vendor == SGEORACLE)
	{
		tbl->serv = SaCopyString("ORACLE");
	}
	else
	{
		tbl->serv = SaCopyString(server);
	}
	return tbl;
}

#ifdef _NO_PROTO
int SaDoHtmlTable(server, db, table, vendor, options)
char *server;
char* db;
char* table;
int vendor;
pSutList options;
#else
int SaDoHtmlTable(char *server, char* db, char* table, int vendor,
				pSutList options)
#endif
{
	SaHtmlTable *tbl;
	SaCallbackStruct *cbs = NULL;
	int colLen = 0;
	char* state_str;
	char* value;
	char* ovalue;
	int stat = 1;

	if ((!table) || (!*table))
	{
		/*** dynamic table names ***/
		value = SaGetInputValue("SA_TABLE_NAME");
		if ((!value) || (!*value))
		{
			/*** from an anchor ***/
			value = SaGetKeyedArg(HTML_TABLE_ARG2);
			if((value) && (*value))
				table = value;
		}
		else
		{
			/*** from a form ***/
			table = value;
		}
	}

	tbl = SaMakeHtmlTable(server, db, table, vendor);
	if (tbl == NULL)
	{
		SaPrintHtmlError("Error : you must specify a table name.");
		return 0;
	}

	state_str = SaGetInputValue("SA_TABLE_COLS");
	if ((state_str) && (*state_str))
	{
		stat = SaInitFromStateHtmlTable(tbl, NULL);
	}
	if (stat)
		cbs = SaSearchHtmlTableComp(tbl, NULL, "where 1 = 2");

	ovalue = SaGetOptionValue(options, HTML_TABLE_TEMPLATE);
	if (ovalue)
	{
		tbl->autoTemp = 1;
		free(ovalue);
	}
	tbl->options = options;
	if(tbl->autoTemp)
		SaParseTemplateHtmlTable(tbl);

	SaInitFromOptionsHtmlTable(tbl);
	SaPopulateHtmlTableComp(tbl, cbs);

	SaFreeCbs(cbs);
	SaFreeHtmlTable(tbl);

	return 1;
}

