-- This allows & in the input strings
set scan off;

ALTER TABLE authors
	DROP PRIMARY KEY CASCADE;

DROP TABLE authors;

CREATE TABLE authors
(
	au_id 				varchar(11) 	PRIMARY KEY,
	au_lname 			varchar(40) 	not null,
	au_fname 			varchar(20) 	not null,
	phone 				char(12) 		not null,
	address 			varchar(40) 	null,
	city 				varchar(20) 	null,
	state 				char(2) 		null,
	country 			varchar(12) 	null,
	postalcode 			char(10) 		null
);
CREATE INDEX aunmind ON authors (au_lname, au_fname);

ALTER TABLE author_url
	DROP PRIMARY KEY CASCADE;

DROP TABLE author_url;

CREATE TABLE author_url
(
	au_id 				varchar(11) 	PRIMARY KEY,
	au_pic_url 			varchar(255) 	null,
	au_snd_url 			varchar(255) 	null
);




DROP TABLE discounts;

CREATE TABLE discounts
(
	discounttype 		varchar(40) 	not null,
	stor_id 			char(4) 		null,
	lowqty 				int		 		null,
	highqty 			int		 		null,
	discount 			float 			not null
);
CREATE INDEX discountsind ON discounts ( discounttype, stor_id );





ALTER TABLE publishers
	DROP PRIMARY KEY CASCADE;
DROP TABLE publishers;

CREATE TABLE publishers
(
	pub_id 				char(4) 		PRIMARY KEY,
	pub_name 			varchar(40) 	null,
	city 				varchar(20) 	null,
	state 				char(2) 		null
);




DROP TABLE roysched;

CREATE TABLE roysched
(
	title_id 			varchar(6) 		not null,
	lorange 			int 			null,
	hirange 			int 			null,
	royalty 			int 			null
);
CREATE INDEX royschedind ON roysched ( title_id );




ALTER TABLE sales
	DROP PRIMARY KEY CASCADE;
DROP TABLE sales;

CREATE TABLE sales
(
	stor_id 			char(4) 		not null,
	ord_num 			varchar(20) 	not null,
	sdate 				date	 		not null
);
ALTER TABLE sales
	ADD PRIMARY KEY ( stor_id, ord_num );




DROP TABLE salesdetail;

CREATE TABLE salesdetail
(
	stor_id 			char(4) 		not null,
	ord_num 			varchar(20) 	not null,
	title_id 			varchar(6) 		not null,
	qty 				int 			not null,
	discount 			float 			not null
);
CREATE INDEX salesdetailind ON salesdetail (stor_id, ord_num);




ALTER TABLE titleauthor
	DROP PRIMARY KEY CASCADE;
DROP TABLE titleauthor;

CREATE TABLE titleauthor
(
	au_id 				varchar(11) 	not null,
	title_id 			varchar(6) 		not null,
	au_ord 				int		 		null,
	royaltyper 			int 			null
);
ALTER TABLE titleauthor
	ADD PRIMARY KEY ( au_id, title_id );
CREATE INDEX auidind ON titleauthor (au_id);
CREATE INDEX titleidind ON titleauthor (title_id);




ALTER TABLE titles
	DROP PRIMARY KEY CASCADE;
DROP TABLE titles;

CREATE TABLE titles
(
	title_id 			varchar(6) 		PRIMARY KEY,
	title 				varchar(80) 	not null,
	type 				varchar(12) 	DEFAULT 'UNDECIDED',
	pub_id 				char(4) 		null,
	price 				number(7,2)		null,
	advance 			number(7,2)		null,
	total_sales 		int 			null,
	notes 				varchar(200) 	null,
	pubdate 			date	 		DEFAULT SYSDATE,
	contract 			character		not null
);
CREATE INDEX titleind ON titles (title);




ALTER TABLE stores
	DROP PRIMARY KEY CASCADE;
DROP TABLE stores;

CREATE TABLE stores
(
	stor_id 			char(4) 		PRIMARY KEY,
	stor_name 			varchar(40) 	null,
	stor_address 		varchar(40) 	null,
	city 				varchar(20) 	null,
	state 				char(2) 		null,
	country 			varchar(12) 	null,
	postalcode 			char(10) 		null,
	payterms 			varchar(12) 	null
);



-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


ALTER TABLE publishers
	ADD CONSTRAINT pub_idrule
	CHECK ( pub_id in ( '1389', '0736', '0877', '1622', '1756' ) or
			pub_id BETWEEN  '9900' AND '9999' );

ALTER TABLE titles
	ADD CONSTRAINT title_idrule1
	CHECK ( title_id BETWEEN 'BU0000' AND 'BU9999' or
			title_id BETWEEN 'MC0000' AND 'MC9999' or
			title_id BETWEEN 'TC0000' AND 'TC9999' or
			title_id BETWEEN 'PS0000' AND 'PS9999' or
			title_id BETWEEN 'PC0000' AND 'PC9999' or
			title_id BETWEEN 'AAxxxx' AND 'ZZxxxx' or
			title_id BETWEEN 'AAyyyy' AND 'ZZyyyy' );

ALTER TABLE salesdetail
	ADD CONSTRAINT title_idrule2
	CHECK ( title_id BETWEEN 'BU0000' AND 'BU9999' or
			title_id BETWEEN 'MC0000' AND 'MC9999' or
			title_id BETWEEN 'TC0000' AND 'TC9999' or
			title_id BETWEEN 'PS0000' AND 'PS9999' or
			title_id BETWEEN 'PC0000' AND 'PC9999' or
			title_id BETWEEN 'AAxxxx' AND 'ZZxxxx' or
			title_id BETWEEN 'AAyyyy' AND 'ZZyyyy' );

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
--					D A T A
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------




-------------------------------------------------------------------------------
--	AUTHORS DATA
-------------------------------------------------------------------------------
INSERT INTO 
	authors
VALUES
(
	'409-56-7008', 
	'Bennet', 
	'Abraham',
	'415 658-9932', 
	'6223 Bateman St.', 
	'Berkeley', 
	'CA', 
	'USA', 
	'94705'
);
INSERT INTO 
	authors
VALUES 
(
	'213-46-8915', 
	'Green', 
	'Marjorie',
	'415 986-7020', 
	'309 63rd St. #411', 
	'Oakland', 
	'CA', 
	'USA', 
	'94618'
);
INSERT INTO 
	authors
VALUES
(
	'238-95-7766', 
	'Carson', 
	'Cheryl',
	'415 548-7723', 
	'589 Darwin Ln.', 
	'Berkeley', 
	'CA', 
	'USA', 
	'94705'
);
INSERT INTO 
	authors
VALUES
(
	'998-72-3567', 
	'Ringer', 
	'Albert',
	'801 826-0752', 
	'67 Seventh Av.', 
	'Salt Lake City', 
	'UT', 
	'USA', 
	'84152'
);
INSERT INTO 
	authors
VALUES
(
	'899-46-2035', 
	'Ringer', 
	'Anne',
	'801 826-0752', 
	'67 Seventh Av.', 
	'Salt Lake City', 
	'UT', 
	'USA', 
	'84152'
);
INSERT INTO 
	authors
VALUES
(
	'722-51-5454', 
	'DeFrance', 
	'Michel',
	'219 547-9982', 
	'3 Balding Pl.', 
	'Gary', 
	'IN', 
	'USA', 
	'46403'
);
INSERT INTO 
	authors
VALUES
(
	'807-91-6654', 
	'Panteley', 
	'Sylvia',
	'301 946-8853', 
	'1956 Arlington Pl.', 
	'Rockville', 
	'MD', 
	'USA', 
	'20853'
);
INSERT INTO 
	authors
VALUES
(
	'893-72-1158', 
	'McBadden', 
	'Heather',
	'707 448-4982', 
	'301 Putnam', 
	'Vacaville', 
	'CA', 
	'USA', 
	'95688'
);
INSERT INTO 
	authors
VALUES
(
	'724-08-9931', 
	'Stringer', 
	'Dirk',
	'415 843-2991', 
	'5420 Telegraph Av.', 
	'Oakland', 
	'CA', 
	'USA', 
	'94609'
);
INSERT INTO 
	authors
VALUES
(
	'274-80-9391', 
	'Straight', 
	'Dick',
	'415 834-2919', 
	'5420 College Av.', 
	'Oakland', 
	'CA', 
	'USA', 
	'94609'
);
INSERT INTO 
	authors
VALUES
(
	'756-30-7391', 
	'Karsen', 
	'Livia',
	'415 534-9219', 
	'5720 McAuley St.', 
	'Oakland', 
	'CA', 
	'USA', 
	'94609'
);
INSERT INTO 
	authors
VALUES
(
	'724-80-9391', 
	'MacFeather', 
	'Stearns',
	'415 354-7128', 
	'44 Upland Hts.', 
	'Oakland', 
	'CA', 
	'USA', 
	'94612'
);
INSERT INTO 
	authors
VALUES
(
	'427-17-2319', 
	'Dull', 
	'Ann',
	'415 836-7128', 
	'3410 Blonde St.', 
	'Palo Alto', 
	'CA', 
	'USA', 
	'94301'
);
INSERT INTO 
	authors
VALUES
(
	'672-71-3249', 
	'Yokomoto', 
	'Akiko',
	'415 935-4228', 
	'3 Silver Ct.', 
	'Walnut Creek', 
	'CA', 
	'USA', 
	'94595'
);
INSERT INTO 
	authors
VALUES
(
	'267-41-2394', 
	'O''Leary', 
	'Michael',
	'408 286-2428', 
	'22 Cleveland Av. #14', 
	'San Jose', 
	'CA', 
	'USA', 
	'95128'
);
INSERT INTO 
	authors
VALUES
(
	'472-27-2349', 
	'Gringlesby', 
	'Burt',
	'707 938-6445', 
	'PO Box 792', 
	'Covelo', 
	'CA', 
	'USA', 
	'95428'
);
INSERT INTO 
	authors
VALUES
(
	'527-72-3246', 
	'Greene', 
	'Morningstar',
	'615 297-2723', 
	'22 Graybar House Rd.', 
	'Nashville', 
	'TN', 
	'USA', 
	'37215'
);
INSERT INTO 
	authors
VALUES
(
	'172-32-1176', 
	'White', 
	'Johnson',
	'408 496-7223', 
	'10932 Bigge Rd.', 
	'Menlo Park', 
	'CA', 
	'USA', 
	'94025'
);
INSERT INTO 
	authors
VALUES
(
	'712-45-1867', 
	'del Castillo', 
	'Innes',
	'615 996-8275', 
	'2286 Cram Pl. #86', 
	'Ann Arbor', 
	'MI', 
	'USA', 
	'48105'
);
INSERT INTO 
	authors
VALUES
(
	'846-92-7186', 
	'Hunter', 
	'Sheryl',
	'415 836-7128', 
	'3410 Blonde St.', 
	'Palo Alto', 
	'CA', 
	'USA', 
	'94301'
);
INSERT INTO 
	authors
VALUES(
	'486-29-1786', 
	'Locksley', 
	'Chastity',
	'415 585-4620', 
	'18 Broadway Av.', 
	'San Francisco', 
	'CA', 
	'USA', 
	'94130'
);
INSERT INTO 
	authors
VALUES
(
	'648-92-1872', 
	'Blotchet-Halls', 
	'Reginald',
	'503 745-6402', 
	'55 Hillsdale Bl.', 
	'Corvallis', 
	'OR', 
	'USA', 
	'97330'
);
INSERT INTO 
	authors
VALUES
(
	'341-22-1782', 
	'Smith', 
	'Meander',
	'913 843-0462', 
	'10 Mississippi Dr.', 
	'Lawrence', 
	'KS', 
	'USA', 
	'66044'
);

insert into author_url
values('409-56-7008', '409-56-7008.gif', '409-56-7008.wav');

insert into author_url
values ('213-46-8915', '213-46-8915.gif', '213-46-8915.wav');

insert into author_url
values('238-95-7766', '238-95-7766.gif', '238-95-7766.wav');

insert into author_url
values('998-72-3567', '998-72-3567.gif', '998-72-3567.wav');

insert into author_url
values('899-46-2035', '899-46-2035.gif', '899-46-2035.wav');

insert into author_url
values('722-51-5454', '722-51-5454.gif', '722-51-5454.wav');

insert into author_url
values('807-91-6654', '807-91-6654.gif', '807-91-6654.wav');

insert into author_url
values('893-72-1158', '893-72-1158.gif', '893-72-1158.wav');

insert into author_url
values('724-08-9931', '724-08-9931.gif', '724-08-9931.wav');

insert into author_url
values('274-80-9391', '274-80-9391.gif', '274-80-9391.wav');

insert into author_url
values('756-30-7391', '756-30-7391.gif', '756-30-7391.wav');

insert into author_url
values('724-80-9391', '724-80-9391.gif', '724-80-9391.wav');

insert into author_url
values('427-17-2319', '427-17-2319.gif', '427-17-2319.wav');

insert into author_url
values('672-71-3249', '672-71-3249.gif', '672-71-3249.wav');

insert into author_url
values('267-41-2394', '267-41-2394.gif', '267-41-2394.wav');

insert into author_url
values('472-27-2349', '472-27-2349.gif', '472-27-2349.wav');

insert into author_url
values('527-72-3246', '527-72-3246.gif', '527-72-3246.wav');

insert into author_url
values('172-32-1176', '172-32-1176.gif', '172-32-1176.wav');

insert into author_url
values('712-45-1867', '712-45-1867.gif', '712-45-1867.wav');

insert into author_url
values('846-92-7186', '846-92-7186.gif', '846-92-7186.wav');

insert into author_url
values('486-29-1786', '486-29-1786.gif', '486-29-1786.wav');

insert into author_url
values('648-92-1872', '648-92-1872.gif', '648-92-1872.wav');

insert into author_url
values('341-22-1782', '341-22-1782.gif', '341-22-1782.wav');




-------------------------------------------------------------------------------
--	PUBLISHERS DATA
-------------------------------------------------------------------------------
INSERT INTO 
	publishers 
VALUES
(
	'0736', 
	'New Age Books', 
	'Boston', 
	'MA'
);
INSERT INTO 
	publishers 
VALUES
(
	'0877', 
	'Binnet & Hardley', 
	'Washington', 
	'DC'
);
INSERT INTO 
	publishers 
VALUES
(
	'1389', 
	'Algodata Infosystems', 
	'Berkeley', 
	'CA'
);


-------------------------------------------------------------------------------
--	SALES DATA
-------------------------------------------------------------------------------

INSERT INTO
   sales
VALUES
(
	'5023',
	'AB-123-DEF-425-1Z3',
	to_date('10/31/85','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
	'5023',
	'AB-872-DEF-732-2Z1',
	to_date('11/06/85','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '8042',
    '12-F-9',
    to_date('07/13/86','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7896',
    '124152',
    to_date('08/14/86','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7131',
    'Asoap132',
    to_date('11/16/86','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'BS-345-DSE-860-1F2',
    to_date('12/12/86','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7067',
    'NB-1.142',
    to_date('01/02/87','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'AX-532-FED-452-2Z7',
    to_date('12/01/90','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'NF-123-ADS-642-9G3',
    to_date('07/18/87','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7131',
    'Fsoap867',
    to_date('09/08/87','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7066',
    'BA52498',
    to_date('10/27/87','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '8042',
    '91-A-7',
    to_date('03/20/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '8042',
    '91-V-7',
    to_date('03/20/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '8042',
    '55-V-7',
    to_date('03/20/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '8042',
    '13-J-9',
    to_date('01/13/88','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7896',
    '234518',
    to_date('02/14/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'GH-542-NAD-713-9F9',
    to_date('03/15/87','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7131',
    'Asoap432',
    to_date('12/20/90','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'ZA-000-ASD-324-4D1',
    to_date('07/27/88','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7066',
    'BA71224',
    to_date('08/05/88','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'ZD-123-DFG-752-9G8',
    to_date('03/21/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '8042',
    '13-E-7',
    to_date('05/23/89','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '7067',
    'NB-3.142',
    to_date('06/13/90','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'ZS-645-CAT-415-1B2',
    to_date('03/21/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'XS-135-DER-432-8J2',
    to_date('03/21/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '5023',
    'ZZ-999-ZZZ-999-0A0',
    to_date('03/21/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '6380',
    '342157',
    to_date('12/13/85','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '6380',
    '356921',
    to_date('02/17/91','MM/DD/YY')
);
INSERT INTO
   sales
VALUES
(
    '6380',
    '234518',
    to_date('09/30/87','MM/DD/YY')
);


-------------------------------------------------------------------------------
--	SALESDETAIL DATA
-------------------------------------------------------------------------------


INSERT INTO
    salesdetail
VALUES
(
	'7896',
	'234518',
	'TC3218',
	75,
	40
);
INSERT INTO
    salesdetail
VALUES
(
	'7896',
	'234518',
	'TC7777',
	75,
	40
);
INSERT INTO
    salesdetail
VALUES
(
	'7131',
	'Asoap432',
	'TC3218',
	50,
	40
);
INSERT INTO
    salesdetail
VALUES
(
	'7131',
	'Asoap432',
	'TC7777',
	80,
	40
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'XS-135-DER-432-8J2',
	'TC3218',
	85,
	40
);
INSERT INTO
    salesdetail
VALUES
(
	'8042',
	'91-A-7',
	'PS3333',
	90,
	45
);
INSERT INTO
    salesdetail
VALUES
(
	'8042',
	'91-A-7',
	'TC3218',
	40,
	45
);
INSERT INTO
    salesdetail
VALUES
(
	'8042',
	'91-A-7',
	'PS2106',
	30,
	45
);
INSERT INTO
    salesdetail
VALUES
(
	'8042',
	'91-V-7',
	'PS2106',
	50,
	45
);
INSERT INTO
    salesdetail
VALUES
(
	'8042',
	'55-V-7',
	'PS2106',
	31,
	45
);
INSERT INTO
    salesdetail
VALUES
(
	'8042',
	'91-A-7',
	'MC3021',
	69,
	45
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'BS-345-DSE-860-1F2',
	'PC1035',
	1000,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'AX-532-FED-452-2Z7',
	'BU2075',
	500,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'AX-532-FED-452-2Z7',
	'BU1032',
	200,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'AX-532-FED-452-2Z7',
	'BU7832',
	150,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'AX-532-FED-452-2Z7',
	'PS7777',
	125,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'NF-123-ADS-642-9G3',
	'TC7777',
	1000,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'NF-123-ADS-642-9G3',
	'BU1032',
	1000,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'NF-123-ADS-642-9G3',
	'PC1035',
	750,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7131',
	'Fsoap867',
	'BU1032',
	200,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7066',
	'BA52498',
	'BU7832',
	100,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7066',
	'BA71224',
	'PS7777',
	200,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7066',
	'BA71224',
	'PC1035',
	300,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7066',
	'BA71224',
	'TC7777',
	350,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'ZD-123-DFG-752-9G8',
	'PS2091',
	1000,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7067',
	'NB-3.142',
	'PS2091',
	200,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7067',
	'NB-3.142',
	'PS7777',
	250,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7067',
	'NB-3.142',
	'PS3333',
	345,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7067',
	'NB-3.142',
	'BU7832',
	360,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'XS-135-DER-432-8J2',
	'PS2091',
	845,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'XS-135-DER-432-8J2',
	'PS7777',
	581,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'ZZ-999-ZZZ-999-0A0',
	'PS1372',
	375,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7067',
	'NB-3.142',
	'BU1111',
	175,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'XS-135-DER-432-8J2',
	'BU7832',
	885,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'ZD-123-DFG-752-9G8',
	'BU7832',
	900,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'5023',
	'AX-532-FED-452-2Z7',
	'TC4203',
	550,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7131',
	'Fsoap867',
	'TC4203',
	350,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7896',
	'234518',
	'TC4203',
	275,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7066',
	'BA71224',
	'TC4203',
	500,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
	'7067',
    'NB-3.142',
    'TC4203',
	512,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '7131',
    'Fsoap867',
    'MC3021',
	400,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'AX-532-FED-452-2Z7',
    'PC8888',
	105,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'NF-123-ADS-642-9G3',
    'PC8888',
	300,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '7066',
    'BA71224',
    'PC8888',
	350,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '7067',
    'NB-3.142',
    'PC8888',
	335,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '7131',
    'Asoap432',
    'BU1111',
	500,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '7896',
    '234518',
    'BU1111',
	340,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'AX-532-FED-452-2Z7',
    'BU1111',
	370,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZD-123-DFG-752-9G8',
    'PS3333',
	750,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '13-J-9',
    'BU7832',
	300,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '13-E-7',
    'BU2075',
	150,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '13-E-7',
    'BU1032',
	300,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '13-E-7',
    'PC1035',
	400,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '91-A-7',
    'PS7777',
	180,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '13-J-9',
    'TC4203',
	250,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '13-E-7',
    'TC4203',
	226,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '13-E-7',
    'MC3021',
	400,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '91-V-7',
    'BU1111',
	390,
	51.7
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'AB-872-DEF-732-2Z1',
    'MC3021',
	5000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'NF-123-ADS-642-9G3',
    'PC8888',
	2000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'NF-123-ADS-642-9G3',
    'BU2075',
	2000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'GH-542-NAD-713-9F9',
    'PC1035',
	2000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZA-000-ASD-324-4D1',
    'PC1035',
	2000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZA-000-ASD-324-4D1',
    'PS7777',
	1500,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZD-123-DFG-752-9G8',
    'BU2075',
	3000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZD-123-DFG-752-9G8',
    'TC7777',
	1500,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZS-645-CAT-415-1B2',
    'BU2075',
	3000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZS-645-CAT-415-1B2',
    'BU2075',
	3000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'XS-135-DER-432-8J2',
    'PS3333',
	2687,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'XS-135-DER-432-8J2',
    'TC7777',
	1090,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'XS-135-DER-432-8J2',
    'PC1035',
	2138,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZZ-999-ZZZ-999-0A0',
    'MC2222',
	2032,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZZ-999-ZZZ-999-0A0',
    'BU1111',
	1001,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZA-000-ASD-324-4D1',
    'BU1111',
	1100,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'NF-123-ADS-642-9G3',
    'BU7832',
	1400,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'BS-345-DSE-860-1F2',
    'TC4203',
	2700,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'GH-542-NAD-713-9F9',
    'TC4203',
	2500,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'NF-123-ADS-642-9G3',
    'TC4203',
	3500,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'BS-345-DSE-860-1F2',
    'MC3021',
	4500,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'AX-532-FED-452-2Z7',
    'MC3021',
	1600,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'NF-123-ADS-642-9G3',
    'MC3021',
	2550,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZA-000-ASD-324-4D1',
    'MC3021',
	3000,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZS-645-CAT-415-1B2',
    'MC3021',
	3200,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'BS-345-DSE-860-1F2',
    'BU2075',
	2200,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'GH-542-NAD-713-9F9',
    'BU1032',
	1500,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'ZZ-999-ZZZ-999-0A0',
    'PC8888',
	1005,
	50
);
INSERT INTO
    salesdetail
VALUES
(
    '7896',
    '124152',
    'BU2075',
	42,
	50.5
);
INSERT INTO
    salesdetail
VALUES
(
    '7896',
    '124152',
    'PC1035',
	25,
	50.5
);
INSERT INTO
    salesdetail
VALUES
(
    '7131',
    'Asoap132',
    'BU2075',
	35,
	50.5
);
INSERT INTO
    salesdetail
VALUES
(
    '7067',
    'NB-1.142',
    'PC1035',
	34,
	50.5
);
INSERT INTO
    salesdetail
VALUES
(
    '7067',
    'NB-1.142',
    'TC4203',
	53,
	50.5
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '12-F-9',
    'BU2075',
	30,
	55.5
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '12-F-9',
    'BU1032',
	94,
	55.5
);
INSERT INTO
    salesdetail
VALUES
(
    '7066',
    'BA27618',
    'BU2075',
	200,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7896',
    '124152',
    'TC4203',
	350,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7066',
    'BA27618',
    'TC4203',
	230,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7066',
    'BA27618',
    'MC3021',
	200,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7131',
    'Asoap132',
    'MC3021',
	137,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7067',
    'NB-1.142',
    'MC3021',
	270,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7067',
    'NB-1.142',
    'BU2075',
	230,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7131',
    'Asoap132',
    'BU1032',
	345,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '7067',
    'NB-1.142',
    'BU1032',
	136,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '12-F-9',
    'TC4203',
	300,
	62.2
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '12-F-9',
    'MC3021',
	270,
	62.2
);
INSERT INTO
    salesdetail
VALUES
(
    '8042',
    '12-F-9',
    'PC1035',
	133,
	62.2
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'AB-123-DEF-425-1Z3',
    'TC4203',
	2500,
	60.5
);
INSERT INTO
    salesdetail
VALUES
(
    '5023',
    'AB-123-DEF-425-1Z3',
    'BU2075',
	4000,
	60.5
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '342157',
    'BU2075',
	200,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '342157',
    'MC3021',
	250,
	57.2
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '356921',
    'PS3333',
	200,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '356921',
    'PS7777',
	500,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '356921',
    'TC3218',
	125,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '234518',
    'BU2075',
	135,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '234518',
    'BU1032',
	320,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '234518',
    'TC4203',
	300,
	46.7
);
INSERT INTO
    salesdetail
VALUES
(
    '6380',
    '234518',
    'MC3021',
	400,
	46.7
);


-------------------------------------------------------------------------------
-- TITLEAUTHOR DATA
-------------------------------------------------------------------------------


INSERT INTO
    titleauthor
VALUES
(
    '409-56-7008',
    'BU1032',
	1,
	60
);
INSERT INTO
    titleauthor
VALUES
(
    '486-29-1786',
    'PS7777',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '486-29-1786',
    'PC9999',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '712-45-1867',
    'MC2222',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '172-32-1176',
    'PS3333',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '213-46-8915',
    'BU1032',
	2,
	40
);
INSERT INTO
    titleauthor
VALUES
(
    '238-95-7766',
    'PC1035',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '213-46-8915',
    'BU2075',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '998-72-3567',
    'PS2091',
	1,
	50
);
INSERT INTO
    titleauthor
VALUES
(
    '899-46-2035',
    'PS2091',
	2,
	50
);
INSERT INTO
    titleauthor
VALUES
(
    '998-72-3567',
    'PS2106',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '722-51-5454',
    'MC3021',
	1,
	75
);
INSERT INTO
    titleauthor
VALUES
(
    '899-46-2035',
    'MC3021',
	2,
	25
);
INSERT INTO
    titleauthor
VALUES
(
    '807-91-6654',
    'TC3218',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '274-80-9391',
    'BU7832',
	1,
	100
);
INSERT INTO
    titleauthor
VALUES
(
    '427-17-2319',
    'PC8888',
	1,
	50
);
INSERT INTO
    titleauthor
VALUES
(
    '846-92-7186',
    'PC8888',
	2,
	50
);
INSERT INTO
    titleauthor
VALUES
(
    '756-30-7391',
    'PS1372',
	1,
	75
);
INSERT INTO
    titleauthor
VALUES
(
    '724-80-9391',
    'PS1372',
	2,
	25
);
INSERT INTO
    titleauthor
VALUES
(
    '724-80-9391',
    'BU1111',
	1,
	60
);
INSERT INTO
    titleauthor
VALUES
(
    '267-41-2394',
    'BU1111',
	2,
	40
);
INSERT INTO
    titleauthor
VALUES
(
    '672-71-3249',
    'TC7777',
	1,
	40
);
INSERT INTO
    titleauthor
VALUES
(
    '267-41-2394',
    'TC7777',
	2,
	30
);
INSERT INTO
    titleauthor
VALUES
(
    '472-27-2349',
    'TC7777',
	3,
	30
);
INSERT INTO
    titleauthor
VALUES
(
    '648-92-1872',
    'TC4203',
	1,
	100
);



-------------------------------------------------------------------------------
--	TITLES DATA
-------------------------------------------------------------------------------
INSERT INTO 
	titles 
VALUES 
(
	'PC8888', 
	'Secrets of Silicon Valley', 
	'popular_comp', 
	'1389',
	20.00, 
	8000.00, 
	4095, 
	'Muckraking reporting by two courageous women on the world''s largest computer hardware and software manufacturers.', 
	to_date( '06/12/87', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'BU1032', 
	'The Busy Executive''s Database Guide', 
	'business', 
	'1389', 
	19.99, 
	5000.00, 
	4095, 
	'An overview of available database systems with emphasis on common business applications.  Illustrated.', 
	to_date( '06/12/86', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'PS7777', 
	'Emotional Security: A New Algorithm', 
	'psychology', 
	'0736', 
	7.99, 
	4000.00, 
	3336, 
	'Protecting yourself and your loved ones from undue emotional stress in the modern world.  Use of computer and nutritional aids emphasized..', 
	to_date( '06/12/88', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'PS3333', 
	'Prolonged Data Deprivation: Four Case Studies', 
	'psychology', 
	'0736', 
	19.99, 
	2000.00, 
	4072, 
	'What happens when the data runs dry?  Searching evaluations of information- shortage effects on heavy users.', 
	to_date( '06/12/88', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'BU1111', 
	'Cooking with Computers: Surreptitious Balance Sheets', 
	'business', 
	'1389', 
	11.95, 
	5000.00, 
	3876, 
	'Helpful hints on how to use your electronic resources to the best advantage .', 
	to_date( '06/09/88', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'MC2222', 
	'Silicon Valley Gastronomic Treats', 
	'mod_cook', 
	'0877', 
	19.99, 
	0.00, 
	2032, 
	'Favorite recipes for quick, easy, and elegant meals, tried and tested by people who never have time to eat, let alone cook.', 
	to_date( '06/09/89', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'TC7777', 
	'Sushi, Anyone?', 
	'trad_cook', 
	'0877', 
	14.99, 
	8000.00, 
	4095, 
	'Detailed instructions on improving your position in life by learning how to make authentic Japanese sushi in your spare time.  5-10% increase in number of friends per recipe reported from beta test.', 
	to_date( '06/12/87', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'TC4203', 
	'Fifty Years in Buckingham Palace Kitchens', 
	'trad_cook', 
	'0877', 
	11.95, 
	4000.00, 
	15096, 
	'More anecdotes from the Queen''s favorite cook describing life among English royalty.  Recipes, techniques, tender vignettes..', 
	to_date( '06/12/85', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES 
(
	'PC1035', 
	'But Is It User Friendly?', 
	'popular_comp', 
	'1389', 22.95, 7000.00, 8780, 
	'A survey of software for the naive user, focusing on the ''friendliness'' of each.', 
	to_date( '06/30/86', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES
(
	'BU2075', 
	'You Can Combat Computer Stress!', 
	'business', 
	'0736', 
	2.99, 
	10125.00, 
	18722, 
	'The latest medical and psychological techniques for living with the electronic office.  Easy-to-understand explanations.', 
	to_date( '06/30/85', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES
(
	'PS2091', 
	'Is Anger the Enemy?', 
	'psychology', 
	'0736', 
	10.95, 
	2275.00, 
	2045, 
	'Carefully researched study of the effects of strong emotions on the body.  Metabolic charts included.', 
	to_date( '06/15/89', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES
(
	'PS2106', 
	'Life Without Fear', 
	'psychology', 
	'0736', 
	7.00, 
	6000.00, 
	111, 
	'New exercise, meditation, and nutritional techniques that can reduce the shock of daily interactions. Popular audience.  Sample menus included, exercise video available separately.', 
	to_date( '10/05/90', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES
(
	'MC3021', 
	'The Gourmet Microwave', 
	'mod_cook', 
	'0877', 
	2.99, 
	15000.00, 
	22246, 
	'Traditional French gourmet recipes adapted for modern microwave cooking.', 
	to_date( '06/18/85', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES
(
	'TC3218', 
	'Onions, Leeks, and Garlic: Cooking Secrets of the Mediterranean', 
	'trad_cook', 
	'0877', 
	20.95, 
	7000.00, 
	375, 
	'Profusely illustrated in color, this makes a wonderful gift book for a cuisine-oriented friend.',
	to_date( '10/21/90', 'MM/DD/YY' ), 
	1
); 
INSERT INTO 
	titles 
VALUES 
(
	'BU7832', 
	'Straight Talk About Computers', 
	'business', 
	'1389', 
	19.99, 
	5000.00, 
	4095, 
	'Annotated analysis of what computers can do for you: a no-hype guide for the critical user.', 
	to_date( '06/22/87', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
VALUES
(
	'PS1372', 
	'Computer Phobic and Non-Phobic Individuals: Behavior Variations', 
	'psychology', 
	'0877', 
	21.59, 
	000.00, 
	375, 
	'A must for the specialist, this book examines the difference between those who hate and fear computers and those who think they are swell.', 
	to_date( '10/21/90', 'MM/DD/YY' ), 
	1
);
INSERT INTO 
	titles 
(
	title_id, 
	title, type, 
	pub_id, 
	notes, 
	contract
)
VALUES
(
	'PC9999', 
	'Net Etiquette', 
	'popular_comp', 
	'1389', 
	'A must-read for computer conferencing debutantes!', 
	0
); 

-------------------------------------------------------------------------------
--	ROYSCHED DATA
-------------------------------------------------------------------------------

INSERT INTO
	roysched
VALUES
(
	'BU1032',
	0,
	5000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'BU1032',
	5001,
	50000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PC1035',
	0,
	2000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'PC1035',
	2001,
	3000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PC1035',
	3001,
	4000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'PC1035',
	4001,
	10000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'PC1035',
	10001,
	50000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	0,
	1000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	1001,
	3000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	3001,
	5000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	5001,
	7000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	7001,
	10000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	10001,
	12000,
	20
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	12001,
	14000,
	22
);
INSERT INTO
	roysched
VALUES
(
	'BU2075',
	14001,
	50000,
	24
);
INSERT INTO
	roysched
VALUES
(
	'PS2091',
	0,
	1000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'PS2091',
	1001,
	5000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PS2091',
	5001,
	10000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'PS2091',
	10001,
	50000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'PS2106',
	0,
	2000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'PS2106',
	2001,
	5000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PS2106',
	5001,
	10000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'PS2106',
	10001,
	50000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	0,
	1000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	1001,
	2000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	2001,
	4000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	4001,
	6000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	6001,
	8000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	8001,
	10000,
	20
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	10001,
	12000,
	22
);
INSERT INTO
	roysched
VALUES
(
	'MC3021',
	12001,
	50000,
	24
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	0,
	2000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	2001,
	4000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	4001,
	6000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	6001,
	8000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	8001,
	10000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	10001,
	12000,
	20
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	12001,
	14000,
	22
);
INSERT INTO
	roysched
VALUES
(
	'TC3218',
	14001,
	50000,
	24
);
INSERT INTO
	roysched
VALUES
(
	'PC8888',
	0,
	5000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'PC8888',
	5001,
	10000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PC8888',
	10001,
	15000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'PC8888',
	15001,
	50000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'PS7777',
	0,
	5000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'PS7777',
	5001,
	50000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PS3333',
	0,
	5000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'PS3333',
	5001,
	10000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PS3333',
	10001,
	15000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'PS3333',
	15001,
	50000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	0,
	4000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	4001,
	8000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	8001,
	10000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	12001,
	16000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	16001,
	20000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	20001,
	24000,
	20
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	24001,
	28000,
	22
);
INSERT INTO
	roysched
VALUES
(
	'BU1111',
	28001,
	50000,
	24
);
INSERT INTO
	roysched
VALUES
(
	'MC2222',
	0,
	2000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'MC2222',
	2001,
	4000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'MC2222',
	4001,
	8000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'MC2222',
	8001,
	12000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'MC2222',
	8001,
	12000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'MC2222',
	12001,
	20000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'MC2222',
	20001,
	50000,
	20
);
INSERT INTO
	roysched
VALUES
(
	'TC7777',
	0,
	5000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'TC7777',
	5001,
	15000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'TC7777',
	15001,
	50000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'TC4203',
	0,
	2000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'TC4203',
	2001,
	8000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'TC4203',
	8001,
	16000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'TC4203',
	16001,
	24000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'TC4203',
	24001,
	32000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'TC4203',
	32001,
	40000,
	20
);
INSERT INTO
	roysched
VALUES
(
	'TC4203',
	40001,
	50000,
	22
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	0,
	5000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	5001,
	10000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	10001,
	15000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	15001,
	20000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	20001,
	25000,
	18
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	25001,
	30000,
	20
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	30001,
	35000,
	22
);
INSERT INTO
	roysched
VALUES
(
	'BU7832',
	35001,
	50000,
	24
);
INSERT INTO
	roysched
VALUES
(
	'PS1372',
	0,
	10000,
	10
);
INSERT INTO
	roysched
VALUES
(
	'PS1372',
	10001,
	20000,
	12
);
INSERT INTO
	roysched
VALUES
(
	'PS1372',
	20001,
	30000,
	14
);
INSERT INTO
	roysched
VALUES
(
	'PS1372',
	30001,
	40000,
	16
);
INSERT INTO
	roysched
VALUES
(
	'PS1372',
	40001,
	50000,
	18
);



-------------------------------------------------------------------------------
--	STORES DATA
-------------------------------------------------------------------------------

INSERT INTO
    stores
VALUES
(
	'7066', 
	'Barnum''s', 
	'567 Pasadena Ave.', 
	'Tustin', 
	'CA', 
	'USA', 
	'92789', 
	'Net 30'
);
INSERT INTO
    stores
VALUES
(
	'7067', 
	'News & Brews', 
	'577 First St.', 
	'Los Gatos', 
	'CA', 
	'USA', 
	'96745', 
	'Net 30'
);
INSERT INTO
    stores
VALUES
(
	'7131', 
	'Doc-U-Mat: Quality Laundry and Books', 
	'24-A Avrogado Way', 
	'Remulade', 
	'WA', 
	'USA', 
	'98014', 
	'Net 60'
);
INSERT INTO
    stores
VALUES
(
	'8042', 
	'Bookbeat', 
	'679 Carson St.', 
	'Portland', 
	'OR', 
	'USA', 
	'89076', 
	'Net 30'
);
INSERT INTO
    stores
VALUES
(
	'6380', 
	'Eric the Read Books', 
	'788 Catamaugus Ave.', 
	'Seattle', 
	'WA', 
	'USA', 
	'98056', 
	'Net 60'
);
INSERT INTO
    stores
VALUES
(
	'7896', 
	'Fricative Bookshop', 
	'89 Madison St.', 
	'Fremont', 
	'CA', 
	'USA', 
	'90019', 
	'Net 60'
);
INSERT INTO
    stores
VALUES
(
	'5023', 
	'Thoreau Reading Discount Chain', 
	'20435 Walden Expressway', 
	'Concord', 
	'MA', 
	'USA', 
	'01776', 
	'Net 60'
);



-------------------------------------------------------------------------------
--	DISCOUNTS DATA
-------------------------------------------------------------------------------

INSERT INTO 
	discounts 
VALUES
(
	'Initial Customer', 
	NULL, 
	NULL, 
	NULL, 
	10.5
);
INSERT INTO 
	discounts 
VALUES
(
	'Volume Discount', 
	NULL, 
	100, 
	1000, 
	6.7
);
INSERT INTO 
	discounts 
VALUES
(
	'Huge Volume Discount', 
	NULL, 
	1001, 
	NULL, 
	10
);
INSERT INTO 
	discounts 
VALUES
(
	'Customer Discount', 
	'8042', 
	NULL, 
	NULL, 
	5.0
);


-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

ALTER TABLE titleauthor
	ADD CONSTRAINT f_titleauthor1
	FOREIGN KEY ( title_id )
	REFERENCES titles( title_id );

ALTER TABLE titleauthor
	ADD CONSTRAINT f_titleauthor2
	FOREIGN KEY ( au_id )
	REFERENCES authors( au_id );

ALTER TABLE author_url
	ADD CONSTRAINT f_author_url
	FOREIGN KEY ( au_id )
	REFERENCES authors( au_id );

ALTER TABLE roysched
	ADD CONSTRAINT f_roysched
	FOREIGN KEY ( title_id )
	REFERENCES titles( title_id );

ALTER TABLE sales
	ADD CONSTRAINT f_sales
	FOREIGN KEY ( stor_id )
	REFERENCES stores( stor_id );

ALTER TABLE salesdetail
	ADD CONSTRAINT f_salesdetail1
	FOREIGN KEY ( title_id )
	REFERENCES titles( title_id );

--ALTER TABLE salesdetail
--	ADD CONSTRAINT f_salesdetail2
--	FOREIGN KEY ( stor_id, ord_num )
--	REFERENCES sales( stor_id, ord_num );

ALTER TABLE titles
	ADD CONSTRAINT f_titles
	FOREIGN KEY ( pub_id )
	REFERENCES publishers( pub_id );

ALTER TABLE discounts
	ADD CONSTRAINT f_discounts
	FOREIGN KEY ( stor_id )
	REFERENCES stores( stor_id );




-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

--	<<-- Must work on this !!!!!
--		
--CREATE TRIGGER 
--	deltitle
--BEFORE 
--	delete
--ON 
--	titles
--FOR EACH ROW
--DECLARE 
--	dummy		INTEGER;
--BEGIN
--	SELECT
--		count(*)
--	INTO
--		dummy
--	FROM
--		salesdetail
--	WHERE
--		salesdetail.title_id = :old.title_id;
--	IF dummy > 0 THEN
--		raise_application_error( -20501,
--								 'May not delete a title with sales.' );
--	END IF;
--END;
--

--as
--if (select count(*) from deleted, salesdetail
--where salesdetail.title_id = deleted.title_id) >0
--begin
--	rollback transaction
--	print "You can't delete a title with sales."
--end
--go
--
--create trigger totalsales_trig
--on salesdetail
--for insert, update, delete
--as
--/* Save processing:  return if there are no rows affected */
--if @@rowcount = 0
--	begin
--		return
--	end
--
--/* add all the new VALUES */
--/* use isnull:  a null value in the titles table means 
--**              "no sales yet" not "sales unknown"
--*/
--update titles
--        set total_sales = isnull(total_sales, 0) + (select sum(qty)
--		from inserted
--		where titles.title_id = inserted.title_id)
--
--/* remove all VALUES being deleted or updated */
--update titles
--        set total_sales = isnull(total_sales, 0) - (select sum(qty)
--		from deleted
--		where titles.title_id = deleted.title_id)
--go
--create view titleview
--as
--select title, au_ord, au_lname,
--price, total_sales, pub_id
--from authors, titles, titleauthor
--where authors.au_id = titleauthor.au_id
--and titles.title_id = titleauthor.title_id
--go
--CREATE PROCEDURE byroyalty
--(
--	percentage 		INTEGER
--)
--IS
--BEGIN
--	SELECT
--		au_id
--	FROM
--		titleauthor
--	WHERE
--		titleauthor.royaltyper = percentage
--END;
--/
--
--create procedure byroyalty @percentage int
--as
--select au_id from titleauthor
--where titleauthor.royaltyper = @percentage
--go
--grant execute on byroyalty to public
--go

--/* create procs for use by APT Sales Example */
--create proc history_proc @stor_id char(4)
--as
--select date,
--       sales.ord_num,
--       qty,
--       salesdetail.title_id,
--       discount,
--       price,
--       total = qty * price * (1 - discount/100)
--from sales, salesdetail, titles
--where sales.stor_id = @stor_id
--and sales.ord_num = salesdetail.ord_num
--and titles.title_id = salesdetail.title_id
--order by date desc, sales.ord_num
--go
--create proc discount_proc as
--select discounttype, stor_id, lowqty, highqty, discount
--from discounts
--go
--create proc storename_proc
--@stor_name      varchar(40)
--as
--declare @lowered_name varchar(40)
--select  @lowered_name = lower(@stor_name) + "%"
--select  stor_name,
--        stor_id,
--        stor_address,
--        city,
--        state,
--        postalcode,
--        country
--from    stores
--where   lower(stor_name) like @lowered_name
--return  @@rowcount
--go
--create proc storeid_proc
--@stor_id	char(4)
--as
--select stor_name,
--        stor_id,
--        stor_address,
--        city,
--        state,
--        postalcode,
--        country
--from stores
--where stor_id = @stor_id
--return @@rowcount
--go
--create proc insert_sales_proc
--	@stor_id	char(4),
--	@ordernum	varchar(20),
--	@orderdate	varchar(40)
--as
--insert sales
--VALUES(@stor_id, @ordernum, @orderdate)
--go
--create proc insert_salesdetail_proc
--	@stor_id        char(4),
--	@ord_num        varchar(20),
--	@title_id       tid,
--	@qty            smallint,
--	@discount       float
--as
--insert salesdetail
--VALUES(@stor_id, @ord_num, @title_id, @qty, @discount)
--go
--create proc title_proc ( @title varchar(80))
--as
--select @title = lower( @title ) + "%"
--select  title, title_id, price
--from    titles
--where   lower(title) like @title
--return @@rowcount
--go
--create proc titleid_proc ( @title_id varchar(80))
--as
--select @title_id = lower( @title_id ) + "%"
--select  title, title_id, price
--from    titles
--where   lower(title_id) like @title_id
--return @@rowcount
--go
--grant exec on history_proc to public
--grant exec on discount_proc to public
--grant exec on titleid_proc to public
--grant exec on storename_proc to public
--grant exec on storeid_proc to public
--grant exec on insert_sales_proc to public
--grant exec on insert_salesdetail_proc to public
--grant exec on title_proc to public
--go
--grant create procedure to public
--go
--if exists (select * from master.dbo.sysdatabases
--		where name = "pubs2")
--begin
--	execute sp_adduser guest
--end
--go
--if exists (select * from master.dbo.sysdatabases
--		where name = "pubs2")
--begin
--	grant all on publishers to guest
--	grant all on titles to guest
--	grant all on authors to guest
--	grant all on titleauthor to guest
--	grant all on sales to guest
--	grant all on salesdetail to guest
--	grant all on roysched to guest
--	grant all on stores to guest
--	grant all on discounts to guest
--	grant all on au_pix to guest
--	grant all on blurbs to guest
--	grant exec on byroyalty to guest
--	grant exec on history_proc to guest
--	grant exec on discount_proc to guest
--	grant exec on titleid_proc to guest
--	grant exec on storename_proc to guest
--	grant exec on storeid_proc to guest
--	grant exec on insert_sales_proc to guest
--	grant exec on insert_salesdetail_proc to guest
--	grant exec on title_proc to guest
--	grant create table to guest
--	grant create view to guest
--	grant create rule to guest
--	grant create default to guest
--	grant create procedure to guest
--end
--go
--use master
--go
--grant exec on sp_bindefault to guest
--grant exec on sp_unbindefault to guest
--grant exec on sp_bindrule to guest
--grant exec on sp_unbindrule to guest
--grant exec on sp_addtype to guest
--grant exec on sp_droptype to guest
--grant exec on sp_spaceused to guest
--grant exec on sp_help to guest
--grant exec on sp_helpgroup to guest
--grant exec on sp_helpindex to guest
--grant exec on sp_helprotect to guest
--go

COMMIT;

quit

