-------------------------------------------------------------------------------
--	M_INSERT_AUTHOR
-------------------------------------------------------------------------------
DROP PROCEDURE m_insert_author;

CREATE PROCEDURE m_insert_author
(
	id 			VARCHAR2,
	lname 		VARCHAR2,
	fname 		VARCHAR2,
	ph 			CHAR,
	addr 		VARCHAR2,
	cty 		VARCHAR2,
	st 			CHAR,
	cntry 		VARCHAR2,
	zip 		CHAR
)
IS
BEGIN
	INSERT INTO 
		authors
	VALUES
	( 
		id,
		lname,
		fname,
		ph,
		addr,
		cty,
		st,
		cntry,
		zip
	);
END;	-- m_insert_author
/

GRANT EXECUTE ON M_insert_author TO PUBLIC;


-------------------------------------------------------------------------------
--	M_UPDATE_AUTHOR
-------------------------------------------------------------------------------
DROP PROCEDURE m_update_author;

CREATE PROCEDURE m_update_author
(
	id 			VARCHAR2,
	lname 		VARCHAR2,
	fname 		VARCHAR2,
	ph 			CHAR,
	addr 		VARCHAR2,
	cty 		VARCHAR2,
	st 			CHAR,
	cntry 		VARCHAR2,
	zip 		CHAR
)
IS
BEGIN
	UPDATE 
		authors
	SET 
		au_lname = lname,
		au_fname = fname,
		phone = ph,
		address = addr,
		city = cty,
		state = st,
		country = cntry,
		postalcode = zip
	WHERE 
		au_id = id;
END;	-- m_update_author
/

GRANT EXECUTE ON m_update_author TO PUBLIC;


-------------------------------------------------------------------------------
--	M_DELETE_AUTHOR
-------------------------------------------------------------------------------
DROP PROCEDURE m_delete_author;

CREATE PROCEDURE m_delete_author
(
	id 			VARCHAR2
)
IS
BEGIN
	DELETE FROM 
		authors
	WHERE 
		au_id = id;
END;	-- m_delete_author
/

GRANT EXECUTE ON M_DELETE_AUTHOR TO PUBLIC;

COMMIT;


-------------------------------------------------------------------------------
--	D12_INSERT
-------------------------------------------------------------------------------
DROP PROCEDURE D12_INSERT;

CREATE PROCEDURE D12_INSERT
(
	ID    CHAR,
	NAME  CHAR,
	CITY  CHAR,
	STATE CHAR
)
IS
BEGIN
	INSERT INTO
		PUBLISHERS
	VALUES (
		ID,
		NAME,
		CITY,
		STATE
	);
END D12_INSERT;
/

GRANT EXECUTE ON D12_INSERT TO PUBLIC;

COMMIT;


-------------------------------------------------------------------------------
--	D12_UPDATE
-------------------------------------------------------------------------------
DROP PROCEDURE D12_UPDATE;

CREATE PROCEDURE D12_UPDATE
(
	ID CHAR,
	NAME CHAR,
	CTY CHAR,
	ST CHAR
)
IS
BEGIN
	UPDATE
		PUBLISHERS
	SET
		PUB_NAME = NAME,
		CITY     = CTY,
		STATE    = ST
	WHERE
		PUB_ID   = ID;
END D12_UPDATE;
/

GRANT EXECUTE ON D12_UPDATE TO PUBLIC;

COMMIT;


-------------------------------------------------------------------------------
--	D12_DELETE
-------------------------------------------------------------------------------
DROP PROCEDURE D12_DELETE;

CREATE PROCEDURE D12_DELETE
(
	ID    CHAR
)
IS
BEGIN
	DELETE
	FROM
		PUBLISHERS
	WHERE
		PUB_ID = ID;
END D12_DELETE;
/

GRANT EXECUTE ON D12_DELETE TO PUBLIC;

COMMIT;


quit

