#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SaRnHtml.h"

#define CR_HTML_TABLE_NAME "TABLE_NAME"
#define CR_HTML_TEMPLATE "Template"
#define MAX_TABLE_COLS 10
#define CR_BUF_SIZE 60000

#define CR_HTML_BEGIN "<CR_HTML>\n<TITLE>"
#define CR_HTML_BODY "</TITLE>\n<BODY>\n"
#define CR_HTML_HEADING "<H2>Create your table</H2>"
#define CR_HTML_END "</BODY>\n</CR_HTML>"
#define CR_HTML_CREB "<INPUT TYPE=\"SUBMIT\" NAME=\"SubmitName\" VALUE=\"Create\">"
#define CR_HTML_DROB "<INPUT TYPE=\"SUBMIT\" NAME=\"SubmitName\" VALUE=\"Drop\">"
#define CR_HTML_PASS "Password : <INPUT TYPE=\"PASSWORD\" NAME=\"SaPassWord\" VALUE=\"%s\">"
#define CR_HTML_USER "Username : <INPUT NAME=\"SaUserName\" VALUE=\"%s\">"
#define CR_HTML_RESET "<INPUT TYPE=\"RESET\" VALUE=\"Reset\">"
#define CR_HTML_TBOX "\nTable Name : <INPUT NAME=\"%s\" VALUE=\"%s\" SIZE=%d>\n"
#define CR_HTML_OBOX "\nTable Template\n<TEXTAREA NAME=\"%s\" ROWS=4 COLS=80>%s</TEXTAREA>\n"
#define CR_HTML_SEL_BEG "<SELECT NAME=\"%s%-d\">"
#define CR_HTML_OPT_EL "<OPTION %s VALUE=\"%s\">%s</OPTION>"
#define CR_HTML_SEL_END "</SELECT>"
#define CR_HTML_FOR "<PRE><FORM ACTION=\"%s\" METHOD=\"post\" >\n"
#define CR_HTML_FOR_E "</FORM></PRE>"
#define CR_HTML_HID "<INPUT TYPE=\"hidden\" NAME=\"SaFormName\" VALUE=\"%s\">\n"
#define CR_HTML_LABELS "Column        Name                Type              Size    PrimeKey   Not Null"
#define CR_HTML_IBOX_LAB "\n%s%d : "
#define CR_HTML_NBOX "<INPUT NAME=\"%s%-d\" VALUE=\"%s\" SIZE=%d>"
#define CR_HTML_SBOX "<INPUT NAME=\"%s%-d\" VALUE=\"%s\" SIZE=%d>"
#define CR_HTML_CBOX "   <INPUT TYPE=\"CHECKBOX\" NAME=\"%s%-d\" %s>"

static char* column_types[] = {
								"varchar",
								"char",
								"tinyint",
								"smallint",
								"int",
								"numeric",
								"decimal",
								"datetime",
								"smalldatetime",
								"smallmoney",
								"money",
								"real",
								"float"
								};

static char* key_types[] = {
								"not",
								"prime",
								"auto"
								};

#ifdef _NO_PROTO
int SaDropTableForm(server, db, vendor)
char *server;
char* db;
int vendor;
#else
int SaDropTableForm(char *server, char* db, int vendor)
#endif
{
	char* value;
	char* buf;
	char *pass, *user, *table;
	SaCallbackStruct* cbs;

	value = SaGetInputValue("SaPassWord");
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a password");
		return 1;
	}
	pass = value;

	value = SaGetInputValue("SaUserName");
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a username");
		return 1;
	}
	user = value;

	value = SaGetInputValue(CR_HTML_TABLE_NAME);
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a table name");
		return 1;
	}
	table = value;

	buf = (char*) malloc(512);
	buf[0] = '\0';
	strcat(buf, "drop table ");
	strcat(buf, table);
	SaPrintHtmlError(buf);

	cbs = SaExecSQL(server, db, vendor, buf);
	if (SaGetErrorStatus() != 0)
	{
		SaPrintHtmlError("Error dropping table");
	}

	free(buf);
	SaFreeCbs(cbs);

	return 0;

}

#ifdef _NO_PROTO
int SaDoCreateTableForm(server, db, vendor)
char *server;
char* db;
int vendor;
#else
int SaDoCreateTableForm(char *server, char* db, int vendor)
#endif
{
	char* value;
	int i, size;
	char nameBuf[256];
	int numAutos = 0, numKeys = 0;
	char* buf;
	char *pass, *user, *table;
	int size_flag;
	int first_flag = 0;
	pSutList keys;
	char* colName;
	SaCallbackStruct* cbs;
	int error_flag = 0;
	char* tempCont;
	char* tempFile;
	char* dirnam;
	char* autos = NULL;

	value = SaGetInputValue("SaPassWord");
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a password");
		return 1;
	}
	pass = value;

	value = SaGetInputValue("SaUserName");
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a username");
		return 1;
	}
	user = value;

	value = SaGetInputValue(CR_HTML_TABLE_NAME);
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a table name");
		return 1;
	}
	table = value;

	buf = (char*) malloc(CR_BUF_SIZE);
	buf[0] = '\0';
	strcat(buf, "create table ");
	strcat(buf, table);
	strcat(buf, "\n(");

	keys = SutNewList();
	i=0;
	for (i=0; i<MAX_TABLE_COLS; i++)
	{
		sprintf(nameBuf, "%s%-d", "NAM", i);
		value = SaGetInputValue(nameBuf);
		colName = value;
		if((!value) || (!*value))
		{
			break;
		}
		if(first_flag)
		{
			strcat(buf, ",\n");
		}
		else
		{
			first_flag = 1;
		}
		strcat(buf, value);
		strcat(buf, " ");

		sprintf(nameBuf, "%s%-d", "TYP", i);
		value = SaGetInputValue(nameBuf);
		if((value) && (*value))
		{
			strcat(buf, value);
			size_flag = 0;
			if(strcmp(value, "varchar") == 0)
			{
				size_flag = 1;
			}
			else if(strcmp(value, "char") == 0)
			{
				size_flag = 1;
			}
			else if(strcmp(value, "numeric") == 0)
			{
				size_flag = 1;
			}
			else if(strcmp(value, "decimal") == 0)
			{
				size_flag = 1;
			}
			else if(strcmp(value, "float") == 0)
			{
				size_flag = 1;
			}
			if (size_flag)
			{
				sprintf(nameBuf, "%s%-d", "SIZ", i);
				value = SaGetInputValue(nameBuf);
				if((value) && (*value))
				{
					strcat(buf, "(");
					strcat(buf, value);
					strcat(buf, ")");
				}
			}
			strcat(buf, " ");
		}

		sprintf(nameBuf, "%s%-d", "PKY", i);
		value = SaGetInputValue(nameBuf);
		if((value) && (*value))
		{
			if (strcmp(value, "auto") == 0)
			{
				numAutos++;
				numKeys++;
				sprintf(nameBuf, "%s%-d", "NUL", i);
				value = SaGetInputValue(nameBuf);
				if((!value) || (!*value))
				{
					SaPrintHtmlError("Error : an auto key must be NOT NULL");
					return 1;
				}
				SutAddList(keys, colName);
				strcat(buf, "identity");
				autos = SaCopyString(colName);
			}
			else if (strcmp(value, "prime") == 0)
			{
				numKeys++;
				sprintf(nameBuf, "%s%-d", "NUL", i);
				value = SaGetInputValue(nameBuf);
				if((!value) || (!*value))
				{
					SaPrintHtmlError("Error : a prime key must be NOT NULL");
					return 1;
				}
				SutAddList(keys, colName);
				strcat(buf, "not null");
			}
			else
			{
				sprintf(nameBuf, "%s%-d", "NUL", i);
				value = SaGetInputValue(nameBuf);
				if((!value) || (!*value))
				{
					strcat(buf, "null");
				}
				else
				{
					strcat(buf, "not null");
				}
			}
		}
	}
	strcat(buf, " )");
	SaPrintHtmlError("Running the following SQL!!!\n");
	SaPrintHtmlError(buf);
	cbs = SaExecSQL(server, db, vendor, buf);
	if (SaGetErrorStatus() != 0)
	{
		SaPrintHtmlError("Error creating table");
		error_flag = 1;
	}
	SaFreeCbs(cbs);

	buf[0] = '\0';
	strcat(buf, "execute sp_primarykey ");
	strcat(buf, table);
	size = SutSizList(keys);
	for (i=0; i<size; i++)
	{
		colName = (char*) SutGetNList(keys, i);
		strcat(buf, ", ");
		strcat(buf, colName);
	}
	SaPrintHtmlError(buf);
	cbs = SaExecSQL(server, db, vendor, buf);
	if (SaGetErrorStatus() != 0)
	{
		SaPrintHtmlError("Error creating prime key(s)");
		error_flag = 1;
	}
	SaFreeCbs(cbs);

	buf[0] = '\0';
	strcat(buf, "create unique clustered index ");
	strcat(buf, table);
	strcat(buf, "_idx on ");
	strcat(buf, table);
	strcat(buf, " (");
	size = SutSizList(keys);
	first_flag = 0;
	for (i=0; i<size; i++)
	{
		if(first_flag)
		{
			strcat(buf, ", ");
		}
		else
		{
			first_flag = 1;
		}
		colName = (char*) SutGetNList(keys, i);
		strcat(buf, colName);
	}
	strcat(buf, ")");
	SaPrintHtmlError(buf);
	cbs = SaExecSQL(server, db, vendor, buf);
	if (SaGetErrorStatus() != 0)
	{
		SaPrintHtmlError("Error creating indices");
		error_flag = 1;
	}
	SaFreeCbs(cbs);

	buf[0] = '\0';
	strcat(buf, "grant all on ");
	strcat(buf, table);
	strcat(buf, " to public");
	SaPrintHtmlError(buf);
	cbs = SaExecSQL(server, db, vendor, buf);
	if (SaGetErrorStatus() != 0)
	{
		SaPrintHtmlError("Error setting privileges");
		error_flag = 1;
	}
	SaFreeCbs(cbs);

	SutDeleteList(keys);

	if (error_flag)
	{
		if(autos) free(autos);
		free(buf);
		return 1;
	}

	tempCont = SaGetInputValue(CR_HTML_TEMPLATE);
	if((tempCont) && (*tempCont))
	{
		dirnam = SaGetHtmlDir();
		if (dirnam)
		{
			chdir(dirnam);
		}
		tempFile = SaStrMCat(table, "_tab.html", NULL);
	/* 	SaWriteStrToFile(tempFile, tempCont); */
		free(tempFile);
	}

	if(autos)
	{
		buf[0] = '\0';
		strcat(buf, "<HTML><HEAD><TITLE>");
		strcat(buf, table);
		strcat(buf, "</TITLE></HEAD><BODY>\n");
		strcat(buf, "##Sa_Table_Begin##\n");
		strcat(buf, "SaHtmlTable.AutoCols : ");
		strcat(buf, autos);
		strcat(buf, "\n");
		strcat(buf, "##Sa_Table_End##\n");
		strcat(buf, "##Sa_Table_List##\n");
		strcat(buf, "</BODY></HTML>");
	}

	dirnam = SaGetHtmlDir();
	if (dirnam)
	{
		chdir(dirnam);
	}
	tempFile = SaStrMCat(table, "_tab.html", NULL);
	unlink(tempFile);

	if(autos)
	{
		SaWriteStrToFile(tempFile, buf);
	}

	free(tempFile);

	if(autos) free(autos);
	free(buf);
	return 0;
}

#ifdef _NO_PROTO
int SaCheckCreateTableForm()
#else
int SaCheckCreateTableForm()
#endif
{
	char* value;
	int i, size;
	char nameBuf[256];
	int numAutos = 0, numKeys = 0;

	value = SaGetInputValue("SaPassWord");
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a password");
		return 1;
	}

	value = SaGetInputValue("SaUserName");
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a username");
		return 1;
	}

	value = SaGetInputValue(CR_HTML_TABLE_NAME);
	if((!value) || (!*value))
	{
		SaPrintHtmlError("Error : you must provide a table name");
		return 1;
	}
	i=0;
	for (i=0; i<MAX_TABLE_COLS; i++)
	{
		sprintf(nameBuf, "%s%-d", "NAM", i);
		value = SaGetInputValue(nameBuf);
		if((!value) || (!*value))
		{
			break;
		}
		sprintf(nameBuf, "%s%-d", "PKY", i);
		value = SaGetInputValue(nameBuf);
		if((value) && (*value))
		{
			if (strcmp(value, "auto") == 0)
			{
				numAutos++;
				numKeys++;
				sprintf(nameBuf, "%s%-d", "NUL", i);
				value = SaGetInputValue(nameBuf);
				if((!value) || (!*value))
				{
					SaPrintHtmlError("Error : an auto key must be NOT NULL");
					return 1;
				}
			}
			if (strcmp(value, "prime") == 0)
			{
				numKeys++;
				sprintf(nameBuf, "%s%-d", "NUL", i);
				value = SaGetInputValue(nameBuf);
				if((!value) || (!*value))
				{
					SaPrintHtmlError("Error : a prime key must be NOT NULL");
					return 1;
				}
			}
		}
		sprintf(nameBuf, "%s%-d", "TYP", i);
		value = SaGetInputValue(nameBuf);
		if((value) && (*value))
		{
		}
		sprintf(nameBuf, "%s%-d", "SIZ", i);
		value = SaGetInputValue(nameBuf);
		if((value) && (*value))
		{
		}
	}

	if (i <= 1)
	{
		SaPrintHtmlError
			("Error : at least the first 2 column names must be non-null");
		return 1;
	}
	if (numAutos > 1)
	{
		SaPrintHtmlError("Error : at most 1 column may be an auto key");
	}
	if (numKeys == 0)
	{
		SaPrintHtmlError("Error : at least 1 column must be a prime key");
	}

	return 0;
}

#ifdef _NO_PROTO
int SaCreateTableForm(server, db, vendor)
char *server;
char* db;
int vendor;
#else
int SaCreateTableForm(char *server, char* db, int vendor)
#endif
{
	char* server_port;
	char* server_name;
	char* script_name;
	char* act_name;
	char* href;
	char* user;
	char* pass;
	int i, j, size;
	int opSize;
	int opSize2;
	char* opVal;

	if ((!server) || (!*server) || (!db) || (!*db))
		return 1;

	if (SaIsSubmitName("Create"))
	{
		if(SaCheckCreateTableForm())
			return 1;
		SaDoCreateTableForm(server, db, vendor);
			return 0;
	}

	else if (SaIsSubmitName("Drop"))
	{
		SaDropTableForm(server, db, vendor);
			return 0;
	}

	/*** SYBASE ONLY FOR NOW ****/
	if (vendor != SGESYBASE)
		return 1;

	server_port = getenv("SERVER_PORT");
	server_name = getenv("SERVER_NAME");
	script_name = getenv("SCRIPT_NAME");
	act_name = SaGetActivator();

	if((!server_port) || (!server_name) || (!script_name) || (!act_name))
	{
		href = SaCopyString("hello");
	}
	else
	{
		href = (char*) malloc(strlen("http://") + strlen(server_name) +
					strlen(script_name) + strlen(server_port) + 5);
		sprintf(href, "http://%s:%s%s", server_name, server_port, script_name);
	}

	fprintf(stdout, "%s", CR_HTML_BEGIN);
	fprintf(stdout, "%s", "Create Your Table");
	fprintf(stdout, "%s", CR_HTML_BODY);
	fprintf(stdout, "%s", CR_HTML_HEADING);
	fprintf(stdout, CR_HTML_FOR, href);
	free(href);

	user = SaGetInputValue("SaUserName");
	pass = SaGetInputValue("SaPassWord");

	fprintf(stdout, CR_HTML_USER, "");
	fprintf(stdout, "        ");
	fprintf(stdout, CR_HTML_PASS, "" );
	fprintf(stdout, "        ");
	fprintf(stdout, CR_HTML_TBOX, CR_HTML_TABLE_NAME, "", 20);
	fprintf(stdout, "\n<HR>\n");

	opSize = sizeof(column_types)/sizeof(column_types[0]);
	opSize2 = sizeof(key_types)/sizeof(key_types[0]);
	fprintf(stdout, "%s", CR_HTML_LABELS);
	for(i=0; i<MAX_TABLE_COLS; i++)
	{
		fprintf(stdout, CR_HTML_IBOX_LAB, "Col", i);
		fprintf(stdout, CR_HTML_NBOX, "NAM", i, "", 20);

		fprintf(stdout, CR_HTML_SEL_BEG, "TYP", i);
		for(j=0; j<opSize; j++)
		{
			opVal = SaMakeHtmlString(column_types[j]);
			fprintf(stdout, CR_HTML_OPT_EL, j==0 ? "SELECTED" : "",opVal,opVal);
			free(opVal);
		}
		fprintf(stdout, CR_HTML_SEL_END);

		fprintf(stdout, CR_HTML_SBOX, "SIZ", i, "", 4);
		fprintf(stdout, CR_HTML_SEL_BEG, "PKY", i);
		for(j=0; j<opSize2; j++)
		{
			opVal = SaMakeHtmlString(key_types[j]);
			if(i==0)
			{
				fprintf(stdout, CR_HTML_OPT_EL, j==1 ? "SELECTED" : "",
								opVal,opVal);
			}
			else
			{
				fprintf(stdout, CR_HTML_OPT_EL, j==0 ? "SELECTED" : "",
								opVal,opVal);
			}
			free(opVal);
		}
		fprintf(stdout, CR_HTML_SEL_END);
		fprintf(stdout, CR_HTML_CBOX, "NUL", i, "CHECKED");

	}

	fprintf(stdout, "\n<HR>\n");
	fprintf(stdout, "%s", CR_HTML_CREB);
	fprintf(stdout, "%s", CR_HTML_DROB);
	fprintf(stdout, "%s", CR_HTML_RESET);
	/* fprintf(stdout, CR_HTML_OBOX, CR_HTML_TEMPLATE, "help\nme", 20); */
	fprintf(stdout, CR_HTML_HID, act_name);
	fprintf(stdout, "%s", CR_HTML_FOR_E);
	fprintf(stdout, "%s", CR_HTML_END);

	return 0;
}

