#include "SaRnHtml.h"

#ifdef _NO_PROTO
int EchoArgs(p)
pSgeWorkCallData p;
#else
int EchoArgs(pSgeWorkCallData p)
#endif
{
	int i, size;
	char* value;
	char* name;
	pSutList options;
	char* str;

	if (!p)
	{
		return 0;
	}

	/****** DO NOT MODIFY list or its contents, read-only. ****/
	options = SaReqGetOptionList(p);

	size = SaReqGetNumArgs(p);

	if (size == 0)
	{
		SaReqSetErrorCode(p, 1);
		SaReqSetReturnCode(p, 1);
		SaReqSetAffectedRowCount(p, 0);
		SaReqAppendError(p, SGEGENERIC,0,0,"EchoArgs : No args found", 0, 0); 
		return 0;
	}

	SaReqAppendString(p, "Hello");
	for(i=0; i<size; i++)
	{
		/**** DO NOT MODIFY, read-only data ****/
		value = SaReqGetNArg(p, i);
		/**** DO NOT MODIFY, read-only data ****/
		name = SaReqGetNArgName(p, i);

		str = (char*) malloc(strlen(name) + strlen(value) + 2);
		sprintf(str, "%s=%s", name, value);
		SaReqAppendString(p, str);
		/**** SaReqAppendString copies in string ****/
		free(str);

		/**** DO NOT MODIFY, read-only data ****/
		/**** example, not used here *****/
		value = SaReqGetArgByName(p, name);
	}

	SaReqSetGroupCount(p, 1);
	SaReqAppendRowCount(p, 1);
	SaReqAppendColCount(p, size+1);

	SaReqSetErrorCode(p, 0);
	SaReqSetReturnCode(p, 0);
	SaReqSetAffectedRowCount(p, 1);

	return 1;
}
