#include "saSetupLogin.h"

static char  ustr[] = "USERNAME";      /** Username string **/
static char  pstr[] = "PASSWORD";      /** Password string **/
static char  eustr[] = "EUSERNAME";    /** Encrypted Username string **/
static char  epstr[] = "EPASSWORD";    /** Encrypted Password string **/
static char  seustr[] = "EUserName";   /** Encrypted Username site string **/
static char  sepstr[] = "EPassWord";   /** Encrypted Password site string **/
static char  keyustr[] = "EUSER";      /** Encrypted Username key string **/
static char  keypstr[] = "EPASS";      /** Encrypted Password key string **/

static char  funcSiteName[] = "COOKIE";

static char* user;
static char* pass;
static char* euser;
static char* epass;

#ifdef _NO_PROTO
char* saEncrypt(s)
char* s;
#else
char* saEncrypt(char* s)
#endif
{
  return s;
}

#ifdef _NO_PROTO
char* saDecrypt(s)
char* s;
#else
char* saDecrypt(char* s)
#endif
{
  return s;
}

void ProcessPassword()
{
  char* htmlString; 

  SaSetUseDefaultFlag();
  SaSetDefaultUser(user);
  SaSetDefaultPass(pass);

  htmlString = SaMakeHtmlString(euser);
  SaRegisterStringSite(NULL, seustr, htmlString);
  if (htmlString)
    free(htmlString);

  htmlString = SaMakeHtmlString(epass);
  SaRegisterStringSite(NULL, sepstr, htmlString);
  if (htmlString)
    free(htmlString);

  htmlString = SaMakeHtmlQString(euser);
  SaStoreKeyString(keyustr, htmlString);
  if (htmlString)
    free(htmlString);

  htmlString = SaMakeHtmlQString(epass);
  SaStoreKeyString(keypstr, htmlString);
  if (htmlString)
    free(htmlString);

  SaRegisterFuncSite(NULL, funcSiteName, SaPrintAllKeys, NULL);
}

void saSetupLogin()
{
  int  num1, num2;

  /** Get normal and username input values **/
  num1 = SaGetNumInputValues(ustr);
  num2 = SaGetNumInputValues(pstr);

  /** if values exist, then is login form, validate values and encrypt **/
  if ( num1 && num2 )
  {
    user = SaGetInputValue(ustr);
    pass = SaGetInputValue(pstr);

    if ( (! pass) || (! *pass) || (! user) || (! *user) )
    {
      SaPrintHtmlError("Must enter login information.");
      return;
    }

    euser = saEncrypt (user);
    epass = saEncrypt (pass);

    ProcessPassword();

    return;
  }

  /** else not login form, check for encrypted values **/
  /** Get encrypted username and password values **/
  num1 = SaGetNumInputValues(eustr);
  num2 = SaGetNumInputValues(epstr);
    
  /** if values exist, get decrypted values **/
  if ( num1 && num2 )
  {
    euser = SaGetInputValue(eustr);
    epass = SaGetInputValue(epstr);

    user = saDecrypt (euser);
    pass = saDecrypt (epass);

    ProcessPassword();

    return;
  } 

  /** else not encrypted form, check for anchor strings **/
  /** get encrypted key arguments **/
  euser = SaGetKeyedArg(keyustr);
  epass = SaGetKeyedArg(keypstr);

  /** if encrypted strings exist, then decrypt them **/
  if ( euser && epass )
  {
    user = saDecrypt (euser);
    pass = saDecrypt (epass);

    ProcessPassword();

    return;
  }
}

