#ifndef __SACONSOLECALLS_HEADER__
#define __SACONSOLECALLS_HEADER__

#include "Sut.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*SaConsoleErrHandler) SUTPROTO((char*));

void XKEXPORT SaDisplayTheConsole SUTPROTO(());
void XKEXPORT SaAppendTheConsoleText SUTPROTO((char *text));

void XKEXPORT SaOpenConsole SUTPROTO(());

/**** this returns allocated memeory. You should free when done *****/
char* XKEXPORT SaGetConsoleText SUTPROTO(());

/**** this call will disable the console from getting error text and ****/
/**** poppping up when an error is received ***/
void XKEXPORT SaDisableConsole SUTPROTO(());

/**** this call will enables the console to get error text and ****/
/**** allows it to pop up when an error is received. The Console is ***/
/**** enabled by default ****/
void XKEXPORT SaEnableConsole SUTPROTO(());

/**** this function allows you to install a function to intercept ****/
/**** console text. The hanlder must be a function with a void ****/
/**** return and which accepts a char* parameter, as typedef'd above. ****/
/**** You must not modify the char* parameter passed to your handler. ****/
/**** To uninstall a handler, call this function with a NULL handler. ****/
void XKEXPORT SaAddConsoleErrHandler SUTPROTO((SaConsoleErrHandler handler));


/**** old function, do not use ****/
void XKEXPORT SaAppendConsoleText SUTPROTO((char *text));
/**** old function, do not use ****/
void XKEXPORT SaDisplayConsole SUTPROTO(());

#ifdef __cplusplus
}
#endif

#endif
