#ifndef __SAPOPCALLS_HEADER__
#define __SAPOPCALLS_HEADER__

#ifdef _WINDOWS
#include "WorkingDialog.h"
#else
#include "WorkingDialog.h"
#endif /* WINDOWS */


#define PROCESSBRSREQUEST_DSQL 300
#define PROCESSBRSREQUEST_OSQL 301
#define PROCESSBRSREQUEST_ISQL 302

#ifdef __cplusplus
extern "C" {
#endif

/************************ DATA RETRIEVAL CALLS **************************/

/*** returns a malloc'd string which must be free'd with free ***/
/*** the string is created from the row'th row ***/
char* XKEXPORT SaMakeStringFromThisRow SUTPROTO((SaCallbackStruct *cbs, int row));

/*** returns a malloc'd string which must be free'd with free ***/
/*** the string is created from the row'th row ***/
char* XKEXPORT SaMakeStringFromThisRowCol SUTPROTO((SaCallbackStruct *cbs, int row,
								XtPointer client_data));

/*** returns a malloc'd string which must be free'd with free ***/
/*** the string is created from the indexed row in the cache ***/
char* XKEXPORT SaMakeStringFromIndexRow SUTPROTO((SaCallbackStruct *cbs));

/*** returns a malloc'd string which must be free'd with free ***/
/*** the string is created from the indexed row in the cache ***/
char* XKEXPORT SaMakeStringFromIndexRowCol SUTPROTO((SaCallbackStruct *cbs,
								XtPointer client_data));

/*** returns a malloc'd string which must be free'd with free ***/
/*** the string is created from all rows with a return char ****/
/*** separating the rows in the string ****/
char* XKEXPORT SaMakeStringFromCBS SUTPROTO((SaCallbackStruct *cbs));

/*** returns a malloc'd XmString which must be free'd with XmStringFree ***/
/*** the XmString is created from the indexed row in the cache ***/
#if !defined(_WINDOWS) && !defined(WEB)
XmString SaMakeXmStringFromIndexRow SUTPROTO((SaCallbackStruct *cbs));
#endif

/*** returns a malloc'd XmString which must be free'd with XmStringFree ***/
/*** the XmString is created from the indexed row in the cache ***/
#if !defined(_WINDOWS) && !defined(WEB)
XmString SaMakeXmStringFromIndexRowCol SUTPROTO((SaCallbackStruct *cbs,
										XtPointer client_data));
#endif


/************************ WIDGET POPULATION CALLS **************************/

/*** This populates a List Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateList SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a List Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateListByCol SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a scrollBar Widget. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateIntValue SUTPROTO((Widget wid, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a File Selection Box Widget or Dialog. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateFileSelectionBox SUTPROTO((Widget box, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a File Selection Box Widget or Dialog. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateFileSelectionBoxByCol SUTPROTO((Widget box,
				XtPointer client_data, SaCallbackStruct *cbs));
#endif

/*** This populates a Selection Box  or Prompt Dialog. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateSelectionBox SUTPROTO((Widget box, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Selection Box  or Prompt Dialog. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateSelectionBoxByCol SUTPROTO((Widget box, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Message Box  or a derived Dialog. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateMessageBox SUTPROTO((Widget mbox, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Message Box  or a derived Dialog. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateMessageBoxByCol SUTPROTO((Widget mbox, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Scale Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateScale SUTPROTO((Widget scale, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Text Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTextWithIndexRow SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Text Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTextAppendIndexRow SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Text Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTextAppendCBS SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Text Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateText SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a TextField Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTextField SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a TextField Widget or subclass thereof. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTextFieldByCol SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Shell Widget by altering its Title. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTitle SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a Shell Widget by altering its Title. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTitleByCol SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a topLevelShell and applicationShell by altering its ***/
/*** Title and iconName. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTitleAndIcon SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a topLevelShell and applicationShell by altering its ***/
/*** Title and iconName. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateTitleAndIconByCol SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a BulletinBoard Widget or Form Widget. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateDialogTitle SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates a BulletinBoard Widget or Form Widget. If used with ***/
/*** any other, the call returns and does nothing ***/ 
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateDialogTitleByCol SUTPROTO((Widget text, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates several Widget classes. They are : ***/
/*** PushButton, PushButtonGadget, ToggleButton, ToggleButtonGadget, ***/
/*** Label, and LabelGadget. If used with any other, the call returns ***/
/*** and does nothing ***/
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateLabel SUTPROTO((Widget label, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates several Widget classes. They are : ***/
/*** PushButton, PushButtonGadget, ToggleButton, ToggleButtonGadget, ***/
/*** Label, and LabelGadget. If used with any other, the call returns ***/
/*** and does nothing ***/
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateLabelByCol SUTPROTO((Widget label, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** This populates an option menu when the rowcolumn of the option menu ***/
/*** is specified.  New widgets of type xmPushButtonWidgetClass are      ***/
/*** created or deleted as necessary to accomodate data.  Each pushButton***/
/*** labelString will contain one occurance of the bound column.  If     ***/
/*** more than one column is bound, they are ignored. The number of rows ***/
/*** and columns will be determined dynamically based upon the number of ***/
/*** pushButtons to manage.  An option menu should be used for choosing  ***/
/*** one of a few options.  Large or unknown numbers of choices should   ***/
/*** implement a scrolled list instead.                                  ***/
#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateMenu SUTPROTO((Widget prc, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateMatrix SUTPROTO((Widget matrix, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateXRTgraph SUTPROTO((Widget xrt, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateXRT3d SUTPROTO((Widget xrt3d, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaPopulateXRTtable SUTPROTO((Widget xrttable, XtPointer client_data,
						SaCallbackStruct *cbs));
#endif

/*** prints a cbs to standard out ***/
void SaPrintOutCBS SUTPROTO((Widget w, XtPointer client_data,
						SaCallbackStruct *cbs));

/*** prints a cbs to standardd error ***/
void SaPrintOutCBStoStdErr SUTPROTO((Widget w, XtPointer client_data,
						SaCallbackStruct *cbs));

/*** appends a cbs to the Sa Console interface *****/
void SaPrintCBStoSaConsole SUTPROTO((Widget w, XtPointer client_data,
						SaCallbackStruct *cbs));

/*** assigns to the int pointed to by client_data the total rows returned ***/
void SaAssignNumRowsToInt SUTPROTO((Widget w, XtPointer client_data,
						SaCallbackStruct *cbs));

/*** appends the cbs data to a file. The client_data holds the file name. ***/
/*** if the file does not exist, it is created. *****/
void SaPrintCBStoFile SUTPROTO((Widget w, XtPointer client_data,
						SaCallbackStruct *cbs));

/*** This function returns a pointer to a default population function ***/
/*** for a specified Widget class. If there is no default, NULL is ***/
/*** returned. A default population callback allows a user to not ***/
/*** have to specify any in the Results Detail editor of the Object ***/
/*** Bind Editor of dbuimx. If one is specified, that is used instead. ***/
PopulationCallback SaGetDefaultPopulateCallback SUTPROTO((Widget w, 
														char **name));



/************************ ARGUMENT EXTRACTION CALLS ************************/

/*** This function returns a pointer to the text in a Text or ***/
/*** TextField Widget.  This must not be FREED. This will be overwritten. ***/
/*** If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetText SUTPROTO((Widget text));
#endif

/*** This function returns a pointer to String representing the value ***/
/*** resource for scales and scrollBars.  This must not be FREED. This ***/
/*** will be overwritten. ***/
/*** If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetValue SUTPROTO((Widget text));
#endif

/*** This function returns the string in the rox x column cell. ****/
/*** If the cell is not valid then the selected cell's contents ****/
/*** is returned; if no cell is selected, an empty string is returned ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetMatrixCell SUTPROTO((Widget matrix, int row, int col));
#endif

/*** This function returns the string in the rox x column cell. ****/
/*** If the cell is not valid then the current cell's contents ****/
/*** is returned; if no cell is current, an empty string is returned ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetXrtTableCell SUTPROTO((Widget matrix, int row, int col));
#endif

/*** This function returns a pointer to the text in a Text or ***/
/*** TextField Widget.  This must not be FREED. This will be overwritten. ***/
/*** If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetLabelString SUTPROTO((Widget text));
#endif

/*** This function returns a pointer to the Title in a Shell.  ***/ 
/*** This must not be FREED. This will ***/
/*** be overwritten.  If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetTitle SUTPROTO((Widget wid));
#endif

/*** This function returns a pointer to the DialogTitle in a Form or ***/ 
/*** BulletinBoard Manager Widget.  This must not be FREED. This will ***/
/*** be overwritten.  If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetDialogTitle SUTPROTO((Widget wid));
#endif

/*** This function returns a pointer to the message in a message box. ***/
/*** This must not be FREED. This will be overwritten. ***/
/*** If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetMessageString SUTPROTO((Widget message));
#endif

/*** This function returns a pointer to the first item in a list's ***/
/***  text in a Text or ***/
/*** TextField Widget.  This must not be FREED. This will be overwritten. ***/
/*** If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetListSelection SUTPROTO((Widget text));
#endif

/*** This function returns a pointer to a SelectionBox's XmNtextString ***/
/*** resource. ***/
/*** This must not be FREED. This will be overwritten. ***/
/*** If you need a permanent copy, you must copy it ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetSelectionBoxChoice SUTPROTO((Widget box));
#endif

/*** This function returns a pointer to the OptionLabelGadget's text  ***/
/*** Which holds an Option Menu's selection.  This must not be FREED. ***/
/*** This will be overwritten. If you need a permanent copy, you must ***/
/*** copy it. ***/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetOMenuChoice SUTPROTO((Widget text));
#endif

char* SaCopyLocalBuffer SUTPROTO((char* str));

void SaReturnLocalBuffer SUTPROTO((char* str));

void SaDestroyLocalBuffers SUTPROTO(());

int SaGetWidgetIndex SUTPROTO((Widget w));

#if !defined(_WINDOWS) && !defined(WEB)
int SaGetIndexFromList SUTPROTO((Widget w));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
int SaGetIndexFromScale SUTPROTO((Widget w));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
int SaGetIndexFromXrtTable SUTPROTO((Widget w));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
int SaGetIndexFromMenu SUTPROTO((Widget w));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetDefaultCallbackName SUTPROTO((Widget w));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaLoadPopCalls SUTPROTO((void));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaRegisterPopCall SUTPROTO((char *cat, char *name, char *desc, 
									void *opts, WidgetClass classp));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaVaRegisterPopCall SUTPROTO((char *cat, char *name, char *desc, 
									void *opts, ...));
#endif

#if !defined(_WINDOWS) && !defined(WEB)
void SaRegisterPopCallAllClass SUTPROTO((char *name, char *desc, 
									void *opts));
#endif

/**
***  Extend Function: ***************************************************
***
***  The purpose of SaGetArgBindCode is to provide string which will be
***  inserted into the Argument Value textField in the Object Bind Editor when
***  the given widget class is dragged and dropped into the same Argument
***  Value textField.  You are responsible for making sure the specified
***  code fragment is available and correct.
**/
#if !defined(_WINDOWS) && !defined(WEB)
char* SaGetArgBindCode SUTPROTO((Widget w));
#endif

#ifdef __cplusplus
}
#endif

#endif
