#ifndef __SAHTML_HEADER__
#define __SAHTML_HEADER__

#ifndef WEB
#define WEB
#endif
#ifndef NOX
#define NOX
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "SaPopCalls.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ANCH_MORE "AnchorAppendString"
#define ANCH_ARG_SEP "___"
#define SA_OPTIONS_SEP " : "

#define SA_NOALIGN 0
#define SA_TOP 1
#define SA_MIDDLE 2
#define SA_BOTTOM 3
#define SA_LEFT 4
#define SA_CENTER 5
#define SA_RIGHT 6

/***** table option defs ***/
#define SA_TABLE_USE_PASS "SaHtmlTable.UsePass : True"
#define SA_TABLE_ECHO_PASS "SaHtmlTable.EchoPass : True"
#define SA_TABLE_HIDE_INSERT "SaHtmlTable.HideInsert : True"
#define SA_TABLE_HIDE_UPDATE "SaHtmlTable.HideUpdate : True"
#define SA_TABLE_HIDE_DELETE "SaHtmlTable.HideDelete : True"
#define SA_TABLE_TEMPLATE "SaHtmlTable.Template : True"
#define SA_TABLE_AUTO_KEY "SaHtmlTable.AutoKey : True"
#define HTML_TABLE_WHERE_CLAUSE "SaHtmlTable.WhereClause"
#define HTML_TABLE_UPDATE_TYPE "SaHtmlTable.WhereType"
#define HTML_TABLE_ESC_HREF "SaHtmlTable.EscHREF"
#define HTML_TABLE_UPDATE_COLS "SaHtmlTable.UpdateCols"
#define HTML_TABLE_AUTO_COLS "SaHtmlTable.AutoCols"
#define HTML_TABLE_TEXTBOX_COLS "SaHtmlTable.TextBoxes"
#define HTML_TABLE_DISPLAY_COLS "SaHtmlTable.DisplayCols"
#define HTML_TABLE_SEARCH_OPS "SaHtmlTable.SearchOps"
#define HTML_TABLE_MAX_ROWS "SaHtmlTable.MaxRows"
#define SA_TABLE_UPD_PRIME 0
#define SA_TABLE_UPD_PRIME_CHG 1
#define SA_TABLE_UPD_PRIME_MOD 2

typedef void (*SaHtmlCallback) SUTPROTO(());
typedef void (*SaSiteCallback) SUTPROTO((char* file, char* site, void* client));

void SaSetSkipAnch SUTPROTO(());
void SaSetCurrentPtr SUTPROTO((char* ptr));

int SaVaHtmlTable SUTPROTO((char* server, char* db, char* table,
						int vendor, ...));

int SaCatFile SUTPROTO((char* filename));
char* SaReadFileToString SUTPROTO((char* fileName));
void SaIncludeHtml SUTPROTO((char* file, char* site, void* client));
int SaRegErrSite SUTPROTO((char* filename, char* site));
int SaRegStdErrSite SUTPROTO(());
void SaStoreErrString SUTPROTO((char* str));
void SaPrintAllErrors SUTPROTO((char* file, char* site,
						void* client));
void SaClearTheErrors SUTPROTO(());
int SaPrintKeyStr SUTPROTO(());
void SaClearKeyList SUTPROTO(());
int SaStoreKeyString SUTPROTO((char* key, char* val));
void SaPrintAllKeys SUTPROTO((char* file, char* site, void* client));

/*** HTML output functions ***/
int SaAnchor SUTPROTO((char* href, char* elabel, char* ename));
int SaMailTo SUTPROTO((char* eaddr, char* elabel));

int SaHtmlTitle SUTPROTO((char* title));
int SaFormHidden SUTPROTO((char* ename, char* evalue));
int SaFormReset SUTPROTO((char* evalue));
int SaFormSubmit SUTPROTO((char* ename, char* evalue));
int SaFormPass SUTPROTO((char* ename, char* evalue));
int SaTableCaption SUTPROTO((char* evalue, int align));
int SaTextAreaBegin SUTPROTO((char* ename, int rows, int cols, int align));
int SaTableHeadExt SUTPROTO((char* evalue, int rows, int cols, int align, int nowrap));
int SaTableItem SUTPROTO((char* evalue));
int SaTableHead SUTPROTO((char* evalue));
int SaListItem SUTPROTO((char* evalue));
int SaListHead SUTPROTO((char* evalue));
int SaTableItemExt SUTPROTO((char* evalue, int rows, int cols, int align, int nowrap));
int SaTextArea SUTPROTO((char* ename, char* evalue, int rows, int cols, int align));
int SaTextBox SUTPROTO((char* ename, char* evalue, int size, int maxsize));
int SaSelectBegin SUTPROTO((char* ename, int multi, int size, char* elabel));
int SaFormRadio SUTPROTO((char* ename, char* evalue, int checked, char* elabel));
int SaSelectOption SUTPROTO((char* evalue, int selected, char* elabel));
int SaFormCheckBox SUTPROTO((char* ename, char* evalue, int checked, char* elabel));
int SaFormBegin SUTPROTO((char* faction, char* fmethod));
int SaFormEnd SUTPROTO(());
int SaTableBegin SUTPROTO(());
int SaRowBeginExt SUTPROTO((int nowrap, int align, int valign));
int SaTableBeginExt SUTPROTO((int border, int nowrap, int align));
int SaTableEnd SUTPROTO(());
int SaTableItemBegin SUTPROTO(());
int SaTableItemEnd SUTPROTO(());
int SaHeader SUTPROTO((char* evalue, int size));
int SaHeaderBegin SUTPROTO((int size));
int SaHeaderEnd SUTPROTO((int size));
int SaTableHeadBegin SUTPROTO(());
int SaTableHeadEnd SUTPROTO(());
int SaTableRowBegin SUTPROTO(());
int SaTableRowEnd SUTPROTO(());
int SaTextAreaEnd SUTPROTO(());
int SaUListBegin SUTPROTO(());
int SaListItemBegin SUTPROTO(());
int SaListItemEnd SUTPROTO(());
int SaOListBegin SUTPROTO(());
int SaUListEnd SUTPROTO(());
int SaOListEnd SUTPROTO(());
int SaMenuBegin SUTPROTO(());
int SaMenuEnd SUTPROTO(());
int SaSelectEnd SUTPROTO(());
int SaHtmlBegin SUTPROTO(());
int SaHtmlEnd SUTPROTO(());
int SaBodyBegin SUTPROTO(());
int SaBodyEnd SUTPROTO(());
int SaHeadBegin SUTPROTO(());
int SaHeadEnd SUTPROTO(());

pSutList SaAnchStringToPieceList SUTPROTO((char *inptr));
char* SaGetCurrentAnchString SUTPROTO((char* inptr));
char* SaGetCurrentPtr SUTPROTO(());
SaCallbackStruct* SaGetThisSiteCbs SUTPROTO((pSgeWorkCallData p, char* site));
SaCallbackStruct* SaGetCbsForThis SUTPROTO((char* filename, char* site));

int XKEXPORT SaSetHtmlDir SUTPROTO((char* dirnam));
int XKEXPORT SaSetHtmlURL SUTPROTO((char* URL));
int XKEXPORT SaSetGifURL SUTPROTO((char* URL));
int XKEXPORT SaSetCgiURL SUTPROTO((char* URL));
int XKEXPORT SaSetStartupHtml SUTPROTO((char* s));
int SaSetKOption SUTPROTO((int key));

int XKEXPORT SaAllowSQL SUTPROTO((int flag));
int XKEXPORT SaRelocatableProject SUTPROTO((int flag));
int XKEXPORT SaAllowConfigFile SUTPROTO((int flag));
int XKEXPORT SaSetConfigFile SUTPROTO((char* fileURL));

int XKEXPORT SaSetPrintArgs SUTPROTO((int flag));
int XKEXPORT SaSetPrintEnv SUTPROTO((int flag));
char* XKEXPORT SaGetKeyedArg SUTPROTO((char* key));
char* XKEXPORT SaGetNArg SUTPROTO((int num));
int XKEXPORT SaGetNumArg SUTPROTO(());
char* XKEXPORT SaGetActivator SUTPROTO(());
char* XKEXPORT SaGetInputValue SUTPROTO((char* element));
char* XKEXPORT SaSafeExecArg SUTPROTO((char* arg));
int XKEXPORT SaGetNumInputValues SUTPROTO((char* element));
char* XKEXPORT SaGetNInputValue SUTPROTO((char* element, int num));
int XKEXPORT SaIsSubmitName SUTPROTO((char* name));
void XKEXPORT SaDebugArgs SUTPROTO((char *name));
void XKEXPORT SaDebugEnv SUTPROTO((char *name));
int XKEXPORT SaInitClient SUTPROTO((int* argc, char* argv[]));
int XKEXPORT SaProcessInputStream SUTPROTO(());

/** set your content string **/
/** if empty string, disable our print out, if NULL, we print out default **/
int XKEXPORT SaSetContentString SUTPROTO((char* str));

int SaRegisterStringSite SUTPROTO((char* file, char* site, char* value));
int SaRegisterFuncSite SUTPROTO((char* file, char* site,
							SaSiteCallback func, void* client));
int XKEXPORT SaRegisterHtmlActivator SUTPROTO((char* actName,
						SaHtmlCallback call));
int XKEXPORT SaRegisterHtmlAlias SUTPROTO((char* aliasName, char* realOne));

int XKEXPORT SaHtmlStrLen SUTPROTO((char* str));
char* XKEXPORT SaMakeHtmlString SUTPROTO((char* str));
char* XKEXPORT SaMakeHtmlQString SUTPROTO((char* str));
char* SaFixHtmlQString SUTPROTO((char* str));

void XKEXPORT SaPrintHtmlError SUTPROTO((char* msg));
void XKEXPORT SaPrintOutHtmlError SUTPROTO((char* msg));
void XKEXPORT SaBeginMsgBox SUTPROTO((char* title));
void XKEXPORT SaEndMsgBox SUTPROTO(());

void XKEXPORT SaPopulateMasDetHotList SUTPROTO((Widget list,
							XtPointer client_data, SaCallbackStruct *cbs));
void XKEXPORT SaPopulateMasterDetail SUTPROTO((Widget list,
							XtPointer client_data, SaCallbackStruct *cbs));
void XKEXPORT SaPopulateTable SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateTableAll SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateMsgBox SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateTableMsgBox SUTPROTO((Widget list,
							XtPointer client_data, SaCallbackStruct *cbs));
void XKEXPORT SaPopulateForText SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateListItem SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateChars SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateParagraph SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateTextArea SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateOptions SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));
void XKEXPORT SaPopulateHotList SUTPROTO((Widget list, XtPointer client_data,
						SaCallbackStruct *cbs));


#ifdef __cplusplus
}
#endif

#endif
